
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         VLparse
#define yylex           VLlex
#define yyerror         VLerror
#define yylval          VLlval
#define yychar          VLchar
#define yydebug         VLdebug
#define yynerrs         VLnerrs
#define yylloc          VLlloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 2 "./parse.y"

/*
 * Copyright (c) 1998-2009 Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

# include "config.h"

# include  "parse_misc.h"
# include  "compiler.h"
# include  "pform.h"
# include  "Statement.h"
# include  "PSpec.h"
# include  <stack>
# include  <cstring>
# include  <sstream>

class PSpecPath;

extern void lex_start_table();
extern void lex_end_table();

static svector<PExpr*>* param_active_range = 0;
static bool param_active_signed = false;
static ivl_variable_type_t param_active_type = IVL_VT_LOGIC;

/* Port declaration lists use this structure for context. */
static struct {
      NetNet::Type port_net_type;
      NetNet::PortType port_type;
      ivl_variable_type_t var_type;
      bool sign_flag;
      svector<PExpr*>* range;
} port_declaration_context = {NetNet::NONE, NetNet::NOT_A_PORT,
                              IVL_VT_NO_TYPE, false, 0};

/* The task and function rules need to briefly hold the pointer to the
   task/function that is currently in progress. */
static PTask* current_task = 0;
static PFunction* current_function = 0;
static stack<PBlock*> current_block_stack;

/* Later version of bison (including 1.35) will not compile in stack
   extension if the output is compiled with C++ and either the YYSTYPE
   or YYLTYPE are provided by the source code. However, I can get the
   old behavior back by defining these symbols. */
# define YYSTYPE_IS_TRIVIAL 1
# define YYLTYPE_IS_TRIVIAL 1

/* Recent version of bison expect that the user supply a
   YYLLOC_DEFAULT macro that makes up a yylloc value from existing
   values. I need to supply an explicit version to account for the
   text field, that otherwise won't be copied. */
# define YYLLOC_DEFAULT(Current, Rhs, N)  do {       \
  (Current).first_line   = (Rhs)[1].first_line;      \
  (Current).first_column = (Rhs)[1].first_column;    \
  (Current).last_line    = (Rhs)[N].last_line;       \
  (Current).last_column  = (Rhs)[N].last_column;     \
  (Current).text         = (Rhs)[1].text;   } while (0)

/*
 * These are some common strength pairs that are used as defaults when
 * the user is not otherwise specific.
 */
const static struct str_pair_t pull_strength = { PGate::PULL,  PGate::PULL };
const static struct str_pair_t str_strength = { PGate::STRONG, PGate::STRONG };

static list<perm_string>* list_from_identifier(char*id)
{
      list<perm_string>*tmp = new list<perm_string>;
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(list<perm_string>*tmp, char*id)
{
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static svector<PExpr*>* copy_range(svector<PExpr*>* orig)
{
      svector<PExpr*>*copy = 0;

      if (orig) {
	    copy = new svector<PExpr*>(2);
	    (*copy)[0] = (*orig)[0];
	    (*copy)[1] = (*orig)[1];
      }

      return copy;
}

template <class T> void append(vector<T>&out, const vector<T>&in)
{
      for (size_t idx = 0 ; idx < in.size() ; idx += 1)
	    out.push_back(in[idx]);
}

/*
 * This is a shorthand for making a PECallFunction that takes a single
 * arg. This is used by some of the code that detects built-ins.
 */
static PECallFunction*make_call_function(perm_string tn, PExpr*arg)
{
      svector<PExpr*> parms(1);
      parms[0] = arg;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static PECallFunction*make_call_function(perm_string tn, PExpr*arg1, PExpr*arg2)
{
      svector<PExpr*> parms(2);
      parms[0] = arg1;
      parms[1] = arg2;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}



/* Line 189 of yacc.c  */
#line 220 "parse.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     SYSTEM_IDENTIFIER = 259,
     STRING = 260,
     DISCIPLINE_IDENTIFIER = 261,
     PATHPULSE_IDENTIFIER = 262,
     BASED_NUMBER = 263,
     DEC_NUMBER = 264,
     REALTIME = 265,
     K_LE = 266,
     K_GE = 267,
     K_EG = 268,
     K_EQ = 269,
     K_NE = 270,
     K_CEQ = 271,
     K_CNE = 272,
     K_LS = 273,
     K_RS = 274,
     K_RSS = 275,
     K_SG = 276,
     K_CONTRIBUTE = 277,
     K_PO_POS = 278,
     K_PO_NEG = 279,
     K_POW = 280,
     K_PSTAR = 281,
     K_STARP = 282,
     K_LOR = 283,
     K_LAND = 284,
     K_NAND = 285,
     K_NOR = 286,
     K_NXOR = 287,
     K_TRIGGER = 288,
     K_abs = 289,
     K_abstol = 290,
     K_access = 291,
     K_acos = 292,
     K_acosh = 293,
     K_asin = 294,
     K_analog = 295,
     K_asinh = 296,
     K_atan = 297,
     K_atanh = 298,
     K_atan2 = 299,
     K_automatic = 300,
     K_always = 301,
     K_and = 302,
     K_assign = 303,
     K_begin = 304,
     K_bool = 305,
     K_buf = 306,
     K_bufif0 = 307,
     K_bufif1 = 308,
     K_case = 309,
     K_casex = 310,
     K_casez = 311,
     K_ceil = 312,
     K_cmos = 313,
     K_continuous = 314,
     K_cos = 315,
     K_cosh = 316,
     K_ddt_nature = 317,
     K_deassign = 318,
     K_default = 319,
     K_defparam = 320,
     K_disable = 321,
     K_discrete = 322,
     K_domain = 323,
     K_edge = 324,
     K_edge_descriptor = 325,
     K_discipline = 326,
     K_else = 327,
     K_end = 328,
     K_endcase = 329,
     K_enddiscipline = 330,
     K_endfunction = 331,
     K_endgenerate = 332,
     K_endmodule = 333,
     K_endnature = 334,
     K_endprimitive = 335,
     K_endspecify = 336,
     K_endtable = 337,
     K_endtask = 338,
     K_event = 339,
     K_exclude = 340,
     K_exp = 341,
     K_floor = 342,
     K_flow = 343,
     K_from = 344,
     K_for = 345,
     K_force = 346,
     K_forever = 347,
     K_fork = 348,
     K_function = 349,
     K_generate = 350,
     K_genvar = 351,
     K_ground = 352,
     K_highz0 = 353,
     K_highz1 = 354,
     K_hypot = 355,
     K_idt_nature = 356,
     K_if = 357,
     K_ifnone = 358,
     K_inf = 359,
     K_initial = 360,
     K_inout = 361,
     K_input = 362,
     K_integer = 363,
     K_join = 364,
     K_large = 365,
     K_ln = 366,
     K_localparam = 367,
     K_log = 368,
     K_logic = 369,
     K_macromodule = 370,
     K_max = 371,
     K_medium = 372,
     K_min = 373,
     K_module = 374,
     K_nand = 375,
     K_nature = 376,
     K_negedge = 377,
     K_nmos = 378,
     K_nor = 379,
     K_not = 380,
     K_notif0 = 381,
     K_notif1 = 382,
     K_or = 383,
     K_output = 384,
     K_parameter = 385,
     K_pmos = 386,
     K_posedge = 387,
     K_potential = 388,
     K_pow = 389,
     K_primitive = 390,
     K_pull0 = 391,
     K_pull1 = 392,
     K_pulldown = 393,
     K_pullup = 394,
     K_rcmos = 395,
     K_real = 396,
     K_realtime = 397,
     K_reg = 398,
     K_release = 399,
     K_repeat = 400,
     K_rnmos = 401,
     K_rpmos = 402,
     K_rtran = 403,
     K_rtranif0 = 404,
     K_rtranif1 = 405,
     K_scalared = 406,
     K_signed = 407,
     K_sin = 408,
     K_sinh = 409,
     K_small = 410,
     K_specify = 411,
     K_specparam = 412,
     K_sqrt = 413,
     K_string = 414,
     K_strong0 = 415,
     K_strong1 = 416,
     K_supply0 = 417,
     K_supply1 = 418,
     K_table = 419,
     K_tan = 420,
     K_tanh = 421,
     K_task = 422,
     K_time = 423,
     K_tran = 424,
     K_tranif0 = 425,
     K_tranif1 = 426,
     K_tri = 427,
     K_tri0 = 428,
     K_tri1 = 429,
     K_triand = 430,
     K_trior = 431,
     K_trireg = 432,
     K_units = 433,
     K_vectored = 434,
     K_wait = 435,
     K_wand = 436,
     K_weak0 = 437,
     K_weak1 = 438,
     K_while = 439,
     K_wire = 440,
     K_wone = 441,
     K_wor = 442,
     K_xnor = 443,
     K_xor = 444,
     K_Shold = 445,
     K_Speriod = 446,
     K_Srecovery = 447,
     K_Srecrem = 448,
     K_Ssetup = 449,
     K_Swidth = 450,
     K_Ssetuphold = 451,
     K_always_comb = 452,
     K_always_ff = 453,
     K_always_latch = 454,
     K_assert = 455,
     KK_attribute = 456,
     K_TAND = 457,
     UNARY_PREC = 458,
     less_than_K_else = 459
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 140 "./parse.y"

      bool flag;

      char letter;

	/* text items are C strings allocated by the lexor using
	   strdup. They can be put into lists with the texts type. */
      char*text;
      list<perm_string>*perm_strings;
      pform_name_t*pform_name;

      ivl_discipline_t discipline;

      hname_t*hier;

      list<string>*strings;

      struct str_pair_t drive;

      PCase::Item*citem;
      svector<PCase::Item*>*citems;

      lgate*gate;
      svector<lgate>*gates;

      Module::port_t *mport;
      LexicalScope::range_t* value_range;
      vector<Module::port_t*>*mports;

      named_pexpr_t*named_pexpr;
      svector<named_pexpr_t*>*named_pexprs;
      struct parmvalue_t*parmvalue;

      PExpr*expr;
      svector<PExpr*>*exprs;

      svector<PEEvent*>*event_expr;

      NetNet::Type nettype;
      PGBuiltin::Type gatetype;
      NetNet::PortType porttype;
      ivl_variable_type_t datatype;

      PWire*wire;
      svector<PWire*>*wires;

      PEventStatement*event_statement;
      Statement*statement;
      svector<Statement*>*statement_list;

      PTaskFuncArg function_type;

      net_decl_assign_t*net_decl_assign;

      verinum* number;

      verireal* realtime;

      PSpecPath* specpath;
      list<index_component_t> *dimensions;



/* Line 214 of yacc.c  */
#line 524 "parse.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 549 "parse.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  22
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12345

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  250
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  184
/* YYNRULES -- Number of rules.  */
#define YYNRULES  695
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1649

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   459

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   225,     2,   222,     2,   214,   207,     2,
     217,   221,   212,   210,   218,   211,   228,   213,   231,   232,
       2,     2,     2,     2,     2,     2,     2,     2,   204,   220,
     208,   219,   209,   203,   223,     2,   239,     2,     2,     2,
     236,     2,     2,     2,     2,     2,     2,   242,   244,     2,
     246,   247,   241,     2,     2,     2,     2,     2,     2,     2,
       2,   229,     2,   230,   206,   249,     2,     2,   234,     2,
       2,     2,   235,     2,   238,     2,     2,     2,   237,     2,
     243,     2,   245,   248,   240,     2,     2,     2,     2,     2,
     233,     2,     2,   226,   205,   227,   224,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   215,   216
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,     8,    11,    13,    15,    18,
      20,    22,    26,    29,    30,    34,    36,    38,    42,    50,
      57,    62,    67,    72,    77,    81,    85,    89,    94,    99,
     104,   109,   114,   118,   122,   124,   127,   129,   130,   134,
     138,   141,   145,   148,   150,   154,   158,   162,   164,   165,
     169,   171,   174,   178,   181,   186,   189,   194,   201,   210,
     212,   213,   215,   219,   221,   227,   229,   231,   233,   235,
     237,   239,   241,   250,   252,   253,   254,   261,   264,   266,
     270,   274,   278,   282,   283,   290,   293,   295,   300,   305,
     310,   315,   320,   326,   332,   338,   344,   350,   356,   358,
     359,   361,   363,   365,   367,   369,   371,   373,   375,   378,
     383,   388,   390,   394,   398,   401,   404,   406,   413,   418,
     420,   423,   426,   429,   432,   435,   438,   441,   444,   447,
     450,   453,   456,   460,   464,   468,   472,   476,   480,   484,
     488,   492,   496,   500,   504,   508,   512,   516,   520,   524,
     528,   532,   536,   540,   544,   548,   552,   556,   562,   564,
     570,   574,   576,   577,   580,   584,   586,   588,   590,   592,
     594,   596,   601,   606,   611,   616,   621,   626,   631,   636,
     643,   648,   653,   658,   663,   668,   675,   680,   685,   692,
     697,   702,   707,   712,   717,   722,   729,   736,   740,   744,
     751,   759,   761,   764,   766,   768,   773,   779,   783,   786,
     791,   797,   802,   808,   812,   814,   816,   818,   820,   822,
     824,   826,   828,   830,   832,   834,   836,   838,   840,   842,
     844,   846,   848,   850,   852,   854,   856,   858,   860,   862,
     864,   868,   873,   880,   887,   894,   896,   900,   902,   906,
     908,   912,   916,   919,   922,   929,   936,   943,   950,   959,
     961,   962,   964,   965,   967,   971,   975,   979,   981,   982,
     983,   995,   997,   999,  1008,  1009,  1013,  1017,  1018,  1019,
    1024,  1027,  1031,  1036,  1045,  1054,  1062,  1069,  1076,  1083,
    1090,  1097,  1104,  1111,  1115,  1117,  1121,  1126,  1132,  1138,
    1145,  1149,  1153,  1160,  1167,  1173,  1179,  1185,  1189,  1193,
    1197,  1198,  1207,  1208,  1220,  1226,  1227,  1237,  1238,  1251,
    1258,  1262,  1266,  1267,  1282,  1283,  1289,  1292,  1293,  1301,
    1307,  1308,  1317,  1320,  1324,  1328,  1332,  1335,  1341,  1345,
    1349,  1359,  1365,  1367,  1368,  1373,  1376,  1378,  1379,  1384,
    1385,  1390,  1393,  1395,  1397,  1398,  1400,  1404,  1410,  1412,
    1414,  1418,  1422,  1424,  1426,  1428,  1430,  1432,  1433,  1435,
    1437,  1439,  1441,  1443,  1445,  1447,  1449,  1451,  1453,  1455,
    1457,  1459,  1460,  1464,  1465,  1470,  1471,  1475,  1476,  1480,
    1481,  1485,  1487,  1491,  1496,  1498,  1499,  1502,  1504,  1511,
    1518,  1525,  1532,  1535,  1537,  1539,  1542,  1545,  1547,  1549,
    1553,  1555,  1556,  1560,  1561,  1566,  1567,  1571,  1572,  1576,
    1577,  1581,  1583,  1587,  1592,  1597,  1600,  1603,  1604,  1610,
    1615,  1617,  1621,  1623,  1629,  1633,  1641,  1643,  1644,  1646,
    1653,  1658,  1663,  1665,  1669,  1675,  1681,  1686,  1690,  1692,
    1694,  1696,  1698,  1704,  1706,  1707,  1708,  1710,  1716,  1723,
    1725,  1728,  1730,  1732,  1734,  1736,  1737,  1740,  1744,  1746,
    1750,  1753,  1757,  1759,  1763,  1766,  1768,  1772,  1776,  1779,
    1782,  1789,  1796,  1800,  1811,  1820,  1831,  1842,  1855,  1868,
    1879,  1887,  1889,  1892,  1898,  1902,  1904,  1906,  1917,  1929,
    1940,  1952,  1954,  1956,  1958,  1964,  1968,  1974,  1981,  1988,
    1992,  1994,  1999,  2003,  2010,  2014,  2022,  2026,  2034,  2036,
    2040,  2042,  2044,  2045,  2048,  2051,  2056,  2061,  2067,  2075,
    2079,  2081,  2085,  2087,  2088,  2090,  2092,  2095,  2098,  2102,
    2104,  2110,  2114,  2120,  2124,  2128,  2129,  2137,  2140,  2145,
    2149,  2150,  2158,  2161,  2166,  2170,  2174,  2177,  2181,  2187,
    2194,  2201,  2208,  2215,  2222,  2229,  2235,  2243,  2249,  2257,
    2271,  2283,  2297,  2303,  2309,  2315,  2318,  2322,  2327,  2334,
    2339,  2344,  2349,  2354,  2360,  2366,  2372,  2382,  2388,  2398,
    2404,  2410,  2413,  2419,  2424,  2427,  2430,  2433,  2435,  2437,
    2439,  2444,  2446,  2448,  2450,  2451,  2458,  2465,  2472,  2477,
    2482,  2487,  2492,  2497,  2502,  2507,  2512,  2517,  2520,  2522,
    2524,  2525,  2531,  2537,  2543,  2547,  2551,  2555,  2559,  2563,
    2567,  2571,  2575,  2579,  2583,  2585,  2589,  2592,  2595,  2596,
    2601,  2603,  2605,  2610,  2612,  2615,  2617,  2620,  2627,  2633,
    2635,  2636,  2638,  2641,  2643,  2645,  2647,  2649,  2651,  2653,
    2655,  2657,  2659,  2661,  2663,  2665,  2667,  2669,  2671,  2673,
    2675,  2677,  2679,  2681,  2683,  2685,  2687,  2689,  2691,  2693,
    2695,  2699,  2703,  2707,  2712,  2714,  2717,  2719,  2723,  2725,
    2726,  2729,  2730,  2733,  2738,  2749
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     251,     0,    -1,   252,    -1,    -1,   273,    -1,   252,   273,
      -1,     8,    -1,     9,    -1,     9,     8,    -1,   141,    -1,
     142,    -1,    26,   256,    27,    -1,    26,    27,    -1,    -1,
     256,   218,   257,    -1,   257,    -1,     3,    -1,     3,   219,
     291,    -1,   255,   143,   341,   307,   375,   381,   220,    -1,
     255,   143,   341,   307,   381,   220,    -1,   255,   108,   381,
     220,    -1,   255,   168,   381,   220,    -1,   255,   141,   383,
     220,    -1,   255,   142,   383,   220,    -1,    84,   302,   220,
      -1,   130,   344,   220,    -1,   112,   358,   220,    -1,   255,
     143,     1,   220,    -1,   255,   108,     1,   220,    -1,   255,
     168,     1,   220,    -1,   255,   141,     1,   220,    -1,   255,
     142,     1,   220,    -1,   130,     1,   220,    -1,   112,     1,
     220,    -1,   258,    -1,   259,   258,    -1,   259,    -1,    -1,
     294,   204,   406,    -1,    64,   204,   406,    -1,    64,   406,
      -1,     1,   204,   406,    -1,   262,   261,    -1,   261,    -1,
     217,   155,   221,    -1,   217,   117,   221,    -1,   217,   110,
     221,    -1,   263,    -1,    -1,   301,   219,   291,    -1,   265,
      -1,   375,   265,    -1,   266,   218,   265,    -1,   222,   272,
      -1,   222,   217,   271,   221,    -1,   222,   272,    -1,   222,
     217,   271,   221,    -1,   222,   217,   271,   218,   271,   221,
      -1,   222,   217,   271,   218,   271,   218,   271,   221,    -1,
     268,    -1,    -1,   271,    -1,   270,   218,   271,    -1,   291,
      -1,   291,   204,   291,   204,   291,    -1,     9,    -1,    10,
      -1,     3,    -1,   311,    -1,   433,    -1,   279,    -1,   275,
      -1,   201,   217,     3,   218,     5,   218,     5,   221,    -1,
     220,    -1,    -1,    -1,    71,     3,   274,   276,   277,    75,
      -1,   277,   278,    -1,   278,    -1,    68,    67,   220,    -1,
      68,    59,   220,    -1,   133,     3,   220,    -1,    88,     3,
     220,    -1,    -1,   121,     3,   274,   280,   281,    79,    -1,
     281,   282,    -1,   282,    -1,   178,   219,     5,   220,    -1,
      35,   219,   291,   220,    -1,    36,   219,     3,   220,    -1,
     101,   219,     3,   220,    -1,    62,   219,     3,   220,    -1,
     217,   285,   218,   286,   221,    -1,   217,   286,   218,   285,
     221,    -1,   217,   285,   218,    99,   221,    -1,   217,   286,
     218,    98,   221,    -1,   217,    99,   218,   285,   221,    -1,
     217,    98,   218,   286,   221,    -1,   283,    -1,    -1,   162,
      -1,   160,    -1,   136,    -1,   182,    -1,   163,    -1,   161,
      -1,   137,    -1,   183,    -1,   223,   301,    -1,   223,   217,
     288,   221,    -1,   223,   217,     1,   221,    -1,   289,    -1,
     288,   128,   289,    -1,   288,   218,   289,    -1,   132,   291,
      -1,   122,   291,    -1,   291,    -1,     3,   217,     3,   218,
       3,   221,    -1,     3,   217,     3,   221,    -1,   295,    -1,
     210,   295,    -1,   211,   295,    -1,   224,   295,    -1,   207,
     295,    -1,   225,   295,    -1,   205,   295,    -1,   206,   295,
      -1,    30,   295,    -1,    31,   295,    -1,    32,   295,    -1,
     225,     1,    -1,   206,     1,    -1,   291,   206,   291,    -1,
     291,    25,   291,    -1,   291,   212,   291,    -1,   291,   213,
     291,    -1,   291,   214,   291,    -1,   291,   210,   291,    -1,
     291,   211,   291,    -1,   291,   207,   291,    -1,   291,   205,
     291,    -1,   291,    30,   291,    -1,   291,    31,   291,    -1,
     291,    32,   291,    -1,   291,   208,   291,    -1,   291,   209,
     291,    -1,   291,    18,   291,    -1,   291,    19,   291,    -1,
     291,    20,   291,    -1,   291,    14,   291,    -1,   291,    16,
     291,    -1,   291,    11,   291,    -1,   291,    12,   291,    -1,
     291,    15,   291,    -1,   291,    17,   291,    -1,   291,    28,
     291,    -1,   291,    29,   291,    -1,   291,   203,   291,   204,
     291,    -1,   291,    -1,   291,   204,   291,   204,   291,    -1,
     293,   218,   291,    -1,   291,    -1,    -1,   293,   218,    -1,
     294,   218,   291,    -1,   291,    -1,   253,    -1,    10,    -1,
       5,    -1,     4,    -1,   301,    -1,   301,   217,   294,   221,
      -1,     4,   217,   294,   221,    -1,    37,   217,   291,   221,
      -1,    38,   217,   291,   221,    -1,    39,   217,   291,   221,
      -1,    41,   217,   291,   221,    -1,    42,   217,   291,   221,
      -1,    43,   217,   291,   221,    -1,    44,   217,   291,   218,
     291,   221,    -1,    57,   217,   291,   221,    -1,    60,   217,
     291,   221,    -1,    61,   217,   291,   221,    -1,    86,   217,
     291,   221,    -1,    87,   217,   291,   221,    -1,   100,   217,
     291,   218,   291,   221,    -1,   111,   217,   291,   221,    -1,
     113,   217,   291,   221,    -1,   134,   217,   291,   218,   291,
     221,    -1,   153,   217,   291,   221,    -1,   154,   217,   291,
     221,    -1,   158,   217,   291,   221,    -1,   165,   217,   291,
     221,    -1,   166,   217,   291,   221,    -1,    34,   217,   291,
     221,    -1,   116,   217,   291,   218,   291,   221,    -1,   118,
     217,   291,   218,   291,   221,    -1,   217,   292,   221,    -1,
     226,   294,   227,    -1,   226,   291,   226,   294,   227,   227,
      -1,   226,   291,   226,   294,   227,     1,   227,    -1,   297,
      -1,   296,   297,    -1,   410,    -1,   258,    -1,     3,   217,
     293,   221,    -1,     3,   375,   217,   293,   221,    -1,   217,
     293,   221,    -1,     3,   375,    -1,     3,   217,   373,   221,
      -1,     3,   375,   217,   373,   221,    -1,     3,   217,     1,
     221,    -1,     3,   375,   217,     1,   221,    -1,   299,   218,
     298,    -1,   298,    -1,    47,    -1,   120,    -1,   128,    -1,
     124,    -1,   189,    -1,   188,    -1,    51,    -1,    52,    -1,
      53,    -1,   125,    -1,   126,    -1,   127,    -1,   123,    -1,
     146,    -1,   131,    -1,   147,    -1,    58,    -1,   140,    -1,
     169,    -1,   148,    -1,   170,    -1,   171,    -1,   149,    -1,
     150,    -1,     3,    -1,   301,   228,     3,    -1,   301,   229,
     291,   230,    -1,   301,   229,   291,   204,   291,   230,    -1,
     301,   229,   291,    23,   291,   230,    -1,   301,   229,   291,
      24,   291,   230,    -1,     3,    -1,   302,   218,     3,    -1,
     369,    -1,   303,   218,   369,    -1,   305,    -1,   304,   218,
     305,    -1,   304,   218,     3,    -1,   304,   218,    -1,   304,
     220,    -1,   255,   107,   306,   307,   376,     3,    -1,   255,
     106,   306,   307,   376,     3,    -1,   255,   129,   306,   307,
     376,     3,    -1,   255,   129,   343,   307,   376,     3,    -1,
     255,   129,   343,   307,   376,     3,   219,   291,    -1,   342,
      -1,    -1,   152,    -1,    -1,   301,    -1,   226,   294,   227,
      -1,   308,   219,   291,    -1,   310,   218,   309,    -1,   309,
      -1,    -1,    -1,   255,   314,     3,   312,   317,   316,   315,
     220,   313,   335,    78,    -1,   119,    -1,   115,    -1,    26,
       3,   108,     3,   219,     5,   220,    27,    -1,    -1,   217,
     303,   221,    -1,   217,   304,   221,    -1,    -1,    -1,   222,
     217,   318,   221,    -1,   130,   351,    -1,   318,   218,   351,
      -1,   318,   218,   130,   351,    -1,   255,   342,   341,   307,
     376,   269,   385,   220,    -1,   255,   342,   341,   307,   376,
     269,   339,   220,    -1,   255,   342,   341,   307,   283,   339,
     220,    -1,   177,   264,   376,   269,   302,   220,    -1,   374,
     307,   376,   269,   302,   220,    -1,   374,   342,   307,   376,
     302,   220,    -1,   129,   343,   307,   376,   302,   220,    -1,
     107,   343,   307,   376,   302,   220,    -1,   106,   343,   307,
     376,   302,   220,    -1,   374,   307,   376,   269,     1,   220,
      -1,     6,   302,   220,    -1,   258,    -1,    65,   266,   220,
      -1,   255,   300,   299,   220,    -1,   255,   300,   268,   299,
     220,    -1,   255,   300,   283,   299,   220,    -1,   255,   300,
     283,   268,   299,   220,    -1,   139,   299,   220,    -1,   138,
     299,   220,    -1,   139,   217,   286,   221,   299,   220,    -1,
     138,   217,   285,   221,   299,   220,    -1,   255,     3,   365,
     299,   220,    -1,   255,     3,   365,     1,   220,    -1,    48,
     284,   269,   310,   220,    -1,   255,    46,   402,    -1,   255,
     105,   402,    -1,   255,    40,   407,    -1,    -1,   167,   328,
       3,   220,   320,   412,   406,    83,    -1,    -1,   167,   328,
       3,   321,   217,   414,   221,   220,   260,   406,    83,    -1,
     167,   328,     3,     1,    83,    -1,    -1,    94,   328,   379,
       3,   220,   322,   296,   402,    76,    -1,    -1,    94,   328,
     379,     3,   323,   217,   414,   221,   220,   260,   402,    76,
      -1,    94,   328,   379,     3,     1,    76,    -1,    95,   335,
      77,    -1,    96,   302,   220,    -1,    -1,    90,   217,     3,
     219,   291,   220,   291,   220,     3,   219,   291,   221,   324,
     336,    -1,    -1,   329,   337,    72,   325,   336,    -1,   329,
     337,    -1,    -1,    54,   217,   291,   221,   326,   330,    74,
      -1,    95,    49,   335,    73,    77,    -1,    -1,    95,    49,
     204,     3,   327,   335,    73,    77,    -1,   156,    81,    -1,
     156,   387,    81,    -1,   156,     1,    81,    -1,   119,     1,
     220,    -1,     1,   220,    -1,    48,     1,   219,   291,   220,
      -1,    48,     1,   220,    -1,    94,     1,    76,    -1,   201,
     217,     3,   218,     5,   218,     5,   221,   220,    -1,   201,
     217,     1,   221,   220,    -1,    45,    -1,    -1,   102,   217,
     291,   221,    -1,   330,   331,    -1,   331,    -1,    -1,   294,
     204,   332,   337,    -1,    -1,    64,   204,   333,   337,    -1,
     334,   319,    -1,   319,    -1,   334,    -1,    -1,   319,    -1,
      49,   335,    73,    -1,    49,   204,     3,   335,    73,    -1,
     336,    -1,   220,    -1,     3,   219,   291,    -1,   339,   218,
     338,    -1,   338,    -1,   114,    -1,    50,    -1,   141,    -1,
     340,    -1,    -1,   185,    -1,   172,    -1,   174,    -1,   162,
      -1,   181,    -1,   175,    -1,   173,    -1,   163,    -1,   187,
      -1,   176,    -1,   186,    -1,   143,    -1,   350,    -1,    -1,
     375,   345,   350,    -1,    -1,   152,   375,   346,   350,    -1,
      -1,   108,   347,   350,    -1,    -1,   168,   348,   350,    -1,
      -1,   254,   349,   350,    -1,   351,    -1,   350,   218,   351,
      -1,     3,   219,   291,   352,    -1,   353,    -1,    -1,   353,
     354,    -1,   354,    -1,   356,   229,   355,   204,   355,   230,
      -1,   356,   229,   355,   204,   355,   221,    -1,   356,   217,
     355,   204,   355,   230,    -1,   356,   217,   355,   204,   355,
     221,    -1,    85,   291,    -1,   291,    -1,   104,    -1,   210,
     104,    -1,   211,   104,    -1,    89,    -1,    85,    -1,     3,
     219,   291,    -1,   364,    -1,    -1,   375,   359,   364,    -1,
      -1,   152,   375,   360,   364,    -1,    -1,   108,   361,   364,
      -1,    -1,   168,   362,   364,    -1,    -1,   254,   363,   364,
      -1,   357,    -1,   364,   218,   357,    -1,   222,   217,   293,
     221,    -1,   222,   217,   367,   221,    -1,   222,     9,    -1,
     222,     1,    -1,    -1,   228,     3,   217,   291,   221,    -1,
     228,     3,   217,   221,    -1,   366,    -1,   367,   218,   366,
      -1,   370,    -1,   228,     3,   217,   370,   221,    -1,   226,
     371,   227,    -1,   228,     3,   217,   226,   371,   227,   221,
      -1,   368,    -1,    -1,     3,    -1,     3,   229,   291,   204,
     291,   230,    -1,     3,   229,   291,   230,    -1,     3,   229,
       1,   230,    -1,   370,    -1,   371,   218,   370,    -1,   228,
       3,   217,   291,   221,    -1,   228,     3,   217,     1,   221,
      -1,   228,     3,   217,   221,    -1,   373,   218,   372,    -1,
     372,    -1,   107,    -1,   129,    -1,   106,    -1,   229,   291,
     204,   291,   230,    -1,   375,    -1,    -1,    -1,   378,    -1,
     229,   291,   204,   291,   230,    -1,   378,   229,   291,   204,
     291,   230,    -1,   375,    -1,   152,   375,    -1,   108,    -1,
     141,    -1,   142,    -1,   168,    -1,    -1,     3,   377,    -1,
       3,   219,   291,    -1,   380,    -1,   381,   218,   380,    -1,
       3,   377,    -1,     3,   219,   291,    -1,   382,    -1,   383,
     218,   382,    -1,     3,   377,    -1,   384,    -1,   385,   218,
     384,    -1,   157,   396,   220,    -1,   392,   220,    -1,   388,
     220,    -1,   102,   217,   291,   221,   392,   220,    -1,   102,
     217,   291,   221,   388,   220,    -1,   103,   392,   220,    -1,
     190,   217,   398,   218,   398,   218,   271,   400,   221,   220,
      -1,   191,   217,   398,   218,   271,   400,   221,   220,    -1,
     192,   217,   398,   218,   398,   218,   271,   400,   221,   220,
      -1,   194,   217,   398,   218,   398,   218,   271,   400,   221,
     220,    -1,   196,   217,   398,   218,   398,   218,   271,   218,
     271,   400,   221,   220,    -1,   193,   217,   398,   218,   398,
     218,   271,   218,   271,   400,   221,   220,    -1,   195,   217,
     398,   218,   271,   218,   291,   400,   221,   220,    -1,   195,
     217,   398,   218,   271,   221,   220,    -1,   386,    -1,   387,
     386,    -1,   390,   219,   217,   270,   221,    -1,   390,   219,
     272,    -1,   132,    -1,   122,    -1,   217,   394,   397,    13,
     217,   394,   391,   291,   221,   221,    -1,   217,   389,   394,
     397,    13,   217,   394,   391,   291,   221,   221,    -1,   217,
     394,   397,    21,   217,   394,   391,   291,   221,   221,    -1,
     217,   389,   394,   397,    21,   217,   394,   391,   291,   221,
     221,    -1,    23,    -1,    24,    -1,   204,    -1,   393,   219,
     217,   270,   221,    -1,   393,   219,   272,    -1,   393,   219,
     217,     1,   221,    -1,   217,   394,   397,    13,   394,   221,
      -1,   217,   394,   397,    21,   394,   221,    -1,   217,     1,
     221,    -1,     3,    -1,     3,   229,   295,   230,    -1,   394,
     218,     3,    -1,   394,   218,     3,   229,   295,   230,    -1,
       3,   219,   291,    -1,     3,   219,   291,   204,   291,   204,
     291,    -1,     7,   219,   291,    -1,     7,   219,   217,   291,
     218,   291,   221,    -1,   395,    -1,   396,   218,   395,    -1,
     210,    -1,   211,    -1,    -1,   132,   291,    -1,   122,   291,
      -1,   132,   295,   202,   291,    -1,   122,   295,   202,   291,
      -1,    69,   229,   399,   230,   295,    -1,    69,   229,   399,
     230,   295,   202,   291,    -1,   295,   202,   291,    -1,   295,
      -1,   399,   218,    70,    -1,    70,    -1,    -1,   401,    -1,
     218,    -1,   218,   301,    -1,   401,   218,    -1,   401,   218,
     301,    -1,     3,    -1,    48,   308,   219,   291,   220,    -1,
      63,   308,   220,    -1,    91,   308,   219,   291,   220,    -1,
     144,   308,   220,    -1,    49,   405,    73,    -1,    -1,    49,
     204,     3,   403,   260,   405,    73,    -1,    49,    73,    -1,
      49,   204,     3,    73,    -1,    49,     1,    73,    -1,    -1,
      93,   204,     3,   404,   260,   405,   109,    -1,    93,   109,
      -1,    93,   204,     3,   109,    -1,    66,   301,   220,    -1,
      33,   301,   220,    -1,    92,   402,    -1,    93,   405,   109,
      -1,   145,   217,   291,   221,   402,    -1,    54,   217,   291,
     221,   262,    74,    -1,    55,   217,   291,   221,   262,    74,
      -1,    56,   217,   291,   221,   262,    74,    -1,    54,   217,
     291,   221,     1,    74,    -1,    55,   217,   291,   221,     1,
      74,    -1,    56,   217,   291,   221,     1,    74,    -1,   102,
     217,   291,   221,   406,    -1,   102,   217,   291,   221,   406,
      72,   406,    -1,   102,   217,     1,   221,   406,    -1,   102,
     217,     1,   221,   406,    72,   406,    -1,    90,   217,   308,
     219,   291,   220,   291,   220,   308,   219,   291,   221,   402,
      -1,    90,   217,   308,   219,   291,   220,   291,   220,     1,
     221,   402,    -1,    90,   217,   308,   219,   291,   220,     1,
     220,   308,   219,   291,   221,   402,    -1,    90,   217,     1,
     221,   402,    -1,   184,   217,   291,   221,   402,    -1,   184,
     217,     1,   221,   402,    -1,   267,   406,    -1,   287,   255,
     406,    -1,   223,   212,   255,   406,    -1,   223,   217,   212,
     221,   255,   406,    -1,   308,   219,   291,   220,    -1,     1,
     219,   291,   220,    -1,   308,    11,   291,   220,    -1,     1,
      11,   291,   220,    -1,   308,   219,   267,   291,   220,    -1,
     308,    11,   267,   291,   220,    -1,   308,   219,   287,   291,
     220,    -1,   308,   219,   145,   217,   291,   221,   287,   291,
     220,    -1,   308,    11,   287,   291,   220,    -1,   308,    11,
     145,   217,   291,   221,   287,   291,   220,    -1,   180,   217,
     291,   221,   406,    -1,     4,   217,   293,   221,   220,    -1,
       4,   220,    -1,   301,   217,   294,   221,   220,    -1,   301,
     217,   221,   220,    -1,   301,   220,    -1,     1,   220,    -1,
     405,   402,    -1,   402,    -1,   402,    -1,   220,    -1,   290,
      22,   291,   220,    -1,   258,    -1,   410,    -1,   143,    -1,
      -1,   107,   409,   307,   376,   302,   220,    -1,   129,   409,
     307,   376,   302,   220,    -1,   106,   409,   307,   376,   302,
     220,    -1,   107,   108,   302,   220,    -1,   129,   108,   302,
     220,    -1,   106,   108,   302,   220,    -1,   107,   168,   302,
     220,    -1,   129,   168,   302,   220,    -1,   106,   168,   302,
     220,    -1,   107,   254,   302,   220,    -1,   129,   254,   302,
     220,    -1,   106,   254,   302,   220,    -1,   411,   408,    -1,
     408,    -1,   411,    -1,    -1,   107,   409,   307,   376,     3,
      -1,   129,   409,   307,   376,     3,    -1,   106,   409,   307,
     376,     3,    -1,   107,   108,     3,    -1,   129,   108,     3,
      -1,   106,   108,     3,    -1,   107,   168,     3,    -1,   129,
     168,     3,    -1,   106,   168,     3,    -1,   107,   254,     3,
      -1,   129,   254,     3,    -1,   106,   254,     3,    -1,   414,
     218,   413,    -1,   413,    -1,   414,   218,     3,    -1,   414,
     218,    -1,   414,   220,    -1,    -1,   164,   416,   417,    82,
      -1,   419,    -1,   420,    -1,   424,   204,   426,   220,    -1,
     418,    -1,   419,   418,    -1,   421,    -1,   420,   421,    -1,
     424,   204,   425,   204,   426,   220,    -1,   105,     3,   219,
     253,   220,    -1,   422,    -1,    -1,   425,    -1,   424,   425,
      -1,   231,    -1,   232,    -1,   233,    -1,   203,    -1,   234,
      -1,   212,    -1,   214,    -1,   235,    -1,   236,    -1,   237,
      -1,   238,    -1,   239,    -1,   240,    -1,   241,    -1,   242,
      -1,   243,    -1,   244,    -1,   245,    -1,   246,    -1,   247,
      -1,   248,    -1,   249,    -1,   210,    -1,   231,    -1,   232,
      -1,   233,    -1,   211,    -1,   107,   302,   220,    -1,   129,
       3,   220,    -1,   143,     3,   220,    -1,   143,   129,     3,
     220,    -1,   427,    -1,   428,   427,    -1,     3,    -1,   429,
     218,     3,    -1,   143,    -1,    -1,   219,   291,    -1,    -1,
     107,     3,    -1,   432,   218,   107,     3,    -1,   135,     3,
     217,   429,   221,   220,   428,   423,   415,    80,    -1,   135,
       3,   217,   129,   430,     3,   431,   218,   432,   221,   220,
     415,    80,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   349,   349,   349,   352,   353,   356,   358,   360,   368,
     369,   376,   377,   378,   382,   388,   397,   404,   422,   435,
     449,   454,   463,   465,   468,   472,   473,   478,   483,   488,
     492,   496,   500,   504,   511,   512,   516,   517,   521,   528,
     533,   538,   545,   551,   559,   560,   561,   565,   566,   570,
     577,   578,   582,   586,   591,   599,   604,   609,   615,   625,
     626,   630,   635,   643,   647,   653,   664,   674,   683,   684,
     685,   686,   687,   699,   699,   703,   702,   709,   710,   714,
     716,   718,   720,   726,   725,   733,   734,   738,   740,   741,
     743,   745,   750,   754,   758,   762,   766,   770,   777,   778,
     782,   783,   784,   785,   789,   790,   791,   792,   796,   804,
     810,   817,   819,   825,   834,   841,   848,   862,   864,   869,
     871,   873,   878,   883,   888,   893,   898,   903,   908,   913,
     918,   923,   928,   933,   938,   943,   948,   953,   958,   963,
     968,   973,   978,   983,   988,   993,   998,  1003,  1008,  1013,
    1018,  1023,  1028,  1033,  1038,  1043,  1048,  1053,  1061,  1063,
    1110,  1115,  1121,  1126,  1134,  1139,  1147,  1153,  1158,  1163,
    1174,  1185,  1191,  1202,  1209,  1216,  1223,  1230,  1237,  1244,
    1251,  1258,  1265,  1272,  1279,  1286,  1293,  1300,  1307,  1314,
    1321,  1328,  1335,  1342,  1353,  1359,  1365,  1373,  1378,  1384,
    1391,  1407,  1409,  1424,  1426,  1433,  1443,  1456,  1467,  1484,
    1495,  1510,  1523,  1538,  1546,  1555,  1556,  1557,  1558,  1559,
    1560,  1561,  1562,  1563,  1564,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1588,
    1593,  1599,  1608,  1618,  1628,  1644,  1646,  1668,  1674,  1682,
    1688,  1693,  1712,  1717,  1725,  1742,  1759,  1776,  1793,  1818,
    1819,  1822,  1822,  1829,  1835,  1847,  1856,  1862,  1872,  1876,
    1871,  1885,  1885,  1888,  1889,  1893,  1894,  1895,  1901,  1903,
    1907,  1908,  1909,  1920,  1941,  1960,  1975,  1981,  1989,  1994,
    2003,  2009,  2015,  2026,  2032,  2036,  2041,  2045,  2049,  2053,
    2060,  2064,  2069,  2073,  2081,  2089,  2100,  2105,  2109,  2114,
    2126,  2125,  2141,  2140,  2155,  2168,  2167,  2183,  2182,  2198,
    2209,  2211,  2217,  2214,  2224,  2221,  2228,  2233,  2232,  2239,
    2246,  2246,  2259,  2262,  2266,  2275,  2282,  2287,  2293,  2299,
    2308,  2315,  2320,  2321,  2324,  2327,  2328,  2332,  2332,  2334,
    2334,  2339,  2340,  2344,  2345,  2355,  2356,  2357,  2361,  2361,
    2372,  2383,  2389,  2395,  2396,  2397,  2400,  2400,  2403,  2404,
    2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,  2417,
    2424,  2426,  2425,  2436,  2435,  2446,  2445,  2463,  2462,  2480,
    2479,  2492,  2493,  2497,  2505,  2505,  2508,  2510,  2515,  2517,
    2519,  2521,  2523,  2528,  2529,  2530,  2531,  2534,  2534,  2542,
    2553,  2555,  2554,  2565,  2564,  2575,  2574,  2592,  2591,  2609,
    2608,  2621,  2622,  2642,  2648,  2654,  2666,  2672,  2676,  2683,
    2693,  2698,  2721,  2729,  2740,  2749,  2758,  2759,  2775,  2783,
    2806,  2828,  2842,  2844,  2857,  2864,  2872,  2882,  2888,  2896,
    2897,  2898,  2902,  2911,  2912,  2915,  2916,  2919,  2927,  2938,
    2939,  2940,  2941,  2942,  2943,  2944,  2953,  2969,  2979,  2985,
    2994,  3009,  3018,  3024,  3033,  3052,  3058,  3067,  3068,  3071,
    3074,  3082,  3090,  3098,  3102,  3106,  3110,  3114,  3119,  3124,
    3129,  3135,  3136,  3140,  3142,  3149,  3149,  3152,  3156,  3160,
    3164,  3171,  3172,  3173,  3177,  3179,  3184,  3192,  3195,  3198,
    3205,  3211,  3217,  3223,  3232,  3237,  3275,  3279,  3287,  3288,
    3292,  3293,  3294,  3298,  3300,  3302,  3306,  3310,  3312,  3316,
    3320,  3329,  3330,  3335,  3336,  3340,  3342,  3344,  3346,  3348,
    3360,  3366,  3376,  3381,  3393,  3401,  3400,  3416,  3421,  3427,
    3436,  3435,  3451,  3456,  3463,  3469,  3475,  3480,  3487,  3492,
    3497,  3502,  3507,  3509,  3511,  3513,  3518,  3523,  3527,  3531,
    3537,  3542,  3547,  3551,  3556,  3560,  3567,  3578,  3585,  3592,
    3597,  3602,  3607,  3612,  3619,  3626,  3631,  3637,  3642,  3647,
    3655,  3662,  3669,  3681,  3688,  3695,  3703,  3708,  3716,  3718,
    3723,  3730,  3731,  3735,  3736,  3741,  3749,  3757,  3769,  3784,
    3799,  3817,  3831,  3845,  3862,  3870,  3878,  3889,  3895,  3900,
    3903,  3908,  3922,  3935,  3951,  3972,  3993,  4017,  4037,  4057,
    4080,  4093,  4106,  4122,  4128,  4130,  4144,  4149,  4158,  4158,
    4164,  4165,  4169,  4182,  4188,  4197,  4203,  4212,  4226,  4237,
    4238,  4242,  4248,  4260,  4261,  4262,  4263,  4264,  4265,  4266,
    4267,  4268,  4269,  4270,  4271,  4272,  4273,  4274,  4275,  4276,
    4277,  4278,  4279,  4280,  4281,  4282,  4286,  4287,  4288,  4289,
    4296,  4298,  4306,  4314,  4325,  4327,  4336,  4342,  4350,  4350,
    4353,  4354,  4358,  4364,  4377,  4392
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYSTEM_IDENTIFIER",
  "STRING", "DISCIPLINE_IDENTIFIER", "PATHPULSE_IDENTIFIER",
  "BASED_NUMBER", "DEC_NUMBER", "REALTIME", "K_LE", "K_GE", "K_EG", "K_EQ",
  "K_NE", "K_CEQ", "K_CNE", "K_LS", "K_RS", "K_RSS", "K_SG",
  "K_CONTRIBUTE", "K_PO_POS", "K_PO_NEG", "K_POW", "K_PSTAR", "K_STARP",
  "K_LOR", "K_LAND", "K_NAND", "K_NOR", "K_NXOR", "K_TRIGGER", "K_abs",
  "K_abstol", "K_access", "K_acos", "K_acosh", "K_asin", "K_analog",
  "K_asinh", "K_atan", "K_atanh", "K_atan2", "K_automatic", "K_always",
  "K_and", "K_assign", "K_begin", "K_bool", "K_buf", "K_bufif0",
  "K_bufif1", "K_case", "K_casex", "K_casez", "K_ceil", "K_cmos",
  "K_continuous", "K_cos", "K_cosh", "K_ddt_nature", "K_deassign",
  "K_default", "K_defparam", "K_disable", "K_discrete", "K_domain",
  "K_edge", "K_edge_descriptor", "K_discipline", "K_else", "K_end",
  "K_endcase", "K_enddiscipline", "K_endfunction", "K_endgenerate",
  "K_endmodule", "K_endnature", "K_endprimitive", "K_endspecify",
  "K_endtable", "K_endtask", "K_event", "K_exclude", "K_exp", "K_floor",
  "K_flow", "K_from", "K_for", "K_force", "K_forever", "K_fork",
  "K_function", "K_generate", "K_genvar", "K_ground", "K_highz0",
  "K_highz1", "K_hypot", "K_idt_nature", "K_if", "K_ifnone", "K_inf",
  "K_initial", "K_inout", "K_input", "K_integer", "K_join", "K_large",
  "K_ln", "K_localparam", "K_log", "K_logic", "K_macromodule", "K_max",
  "K_medium", "K_min", "K_module", "K_nand", "K_nature", "K_negedge",
  "K_nmos", "K_nor", "K_not", "K_notif0", "K_notif1", "K_or", "K_output",
  "K_parameter", "K_pmos", "K_posedge", "K_potential", "K_pow",
  "K_primitive", "K_pull0", "K_pull1", "K_pulldown", "K_pullup", "K_rcmos",
  "K_real", "K_realtime", "K_reg", "K_release", "K_repeat", "K_rnmos",
  "K_rpmos", "K_rtran", "K_rtranif0", "K_rtranif1", "K_scalared",
  "K_signed", "K_sin", "K_sinh", "K_small", "K_specify", "K_specparam",
  "K_sqrt", "K_string", "K_strong0", "K_strong1", "K_supply0", "K_supply1",
  "K_table", "K_tan", "K_tanh", "K_task", "K_time", "K_tran", "K_tranif0",
  "K_tranif1", "K_tri", "K_tri0", "K_tri1", "K_triand", "K_trior",
  "K_trireg", "K_units", "K_vectored", "K_wait", "K_wand", "K_weak0",
  "K_weak1", "K_while", "K_wire", "K_wone", "K_wor", "K_xnor", "K_xor",
  "K_Shold", "K_Speriod", "K_Srecovery", "K_Srecrem", "K_Ssetup",
  "K_Swidth", "K_Ssetuphold", "K_always_comb", "K_always_ff",
  "K_always_latch", "K_assert", "KK_attribute", "K_TAND", "'?'", "':'",
  "'|'", "'^'", "'&'", "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "'%'",
  "UNARY_PREC", "less_than_K_else", "'('", "','", "'='", "';'", "')'",
  "'#'", "'@'", "'~'", "'!'", "'{'", "'}'", "'.'", "'['", "']'", "'0'",
  "'1'", "'x'", "'b'", "'f'", "'F'", "'l'", "'h'", "'B'", "'r'", "'R'",
  "'M'", "'n'", "'N'", "'p'", "'P'", "'Q'", "'q'", "'_'", "$accept",
  "main", "source_file", "number", "real_or_realtime",
  "attribute_list_opt", "attribute_list", "attribute", "block_item_decl",
  "block_item_decls", "block_item_decls_opt", "case_item", "case_items",
  "charge_strength", "charge_strength_opt", "defparam_assign",
  "defparam_assign_list", "delay1", "delay3", "delay3_opt",
  "delay_value_list", "delay_value", "delay_value_simple", "description",
  "optional_semicolon", "discipline_declaration", "$@1",
  "discipline_items", "discipline_item", "nature_declaration", "$@2",
  "nature_items", "nature_item", "drive_strength", "drive_strength_opt",
  "dr_strength0", "dr_strength1", "event_control", "event_expression_list",
  "event_expression", "branch_probe_expression", "expression",
  "expr_mintypmax", "expression_list_with_nuls", "expression_list_proper",
  "expr_primary", "function_item_list", "function_item", "gate_instance",
  "gate_instance_list", "gatetype", "hierarchy_identifier",
  "list_of_identifiers", "list_of_ports", "list_of_port_declarations",
  "port_declaration", "net_type_opt", "signed_opt", "lpvalue",
  "cont_assign", "cont_assign_list", "module", "$@3", "$@4",
  "module_start", "module_attribute_foreign", "module_port_list_opt",
  "module_parameter_port_list_opt", "module_parameter_port_list",
  "module_item", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "automatic_opt", "generate_if", "generate_case_items",
  "generate_case_item", "$@13", "$@14", "module_item_list",
  "module_item_list_opt", "generate_block", "generate_block_opt",
  "net_decl_assign", "net_decl_assigns", "primitive_type",
  "primitive_type_opt", "net_type", "var_type", "parameter_assign_decl",
  "$@15", "$@16", "$@17", "$@18", "$@19", "parameter_assign_list",
  "parameter_assign", "parameter_value_ranges_opt",
  "parameter_value_ranges", "parameter_value_range",
  "value_range_expression", "from_exclude", "localparam_assign",
  "localparam_assign_decl", "$@20", "$@21", "$@22", "$@23", "$@24",
  "localparam_assign_list", "parameter_value_opt",
  "parameter_value_byname", "parameter_value_byname_list", "port",
  "port_opt", "port_reference", "port_reference_list", "port_name",
  "port_name_list", "port_type", "range", "range_opt", "dimensions_opt",
  "dimensions", "function_range_or_type_opt", "register_variable",
  "register_variable_list", "real_variable", "real_variable_list",
  "net_variable", "net_variable_list", "specify_item", "specify_item_list",
  "specify_edge_path_decl", "edge_operator", "specify_edge_path",
  "polarity_operator", "specify_simple_path_decl", "specify_simple_path",
  "specify_path_identifiers", "specparam", "specparam_list",
  "spec_polarity", "spec_reference_event", "edge_descriptor_list",
  "spec_notifier_opt", "spec_notifier", "statement", "$@25", "$@26",
  "statement_list", "statement_or_null", "analog_statement", "task_item",
  "reg_opt", "task_port_item", "task_item_list", "task_item_list_opt",
  "task_port_decl", "task_port_decl_list", "udp_body", "$@27",
  "udp_entry_list", "udp_comb_entry", "udp_comb_entry_list",
  "udp_sequ_entry_list", "udp_sequ_entry", "udp_initial", "udp_init_opt",
  "udp_input_list", "udp_input_sym", "udp_output_sym", "udp_port_decl",
  "udp_port_decls", "udp_port_list", "udp_reg_opt", "udp_initial_expr_opt",
  "udp_input_declaration_list", "udp_primitive", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    63,    58,   124,    94,    38,    60,    62,
      43,    45,    42,    47,    37,   458,   459,    40,    44,    61,
      59,    41,    35,    64,   126,    33,   123,   125,    46,    91,
      93,    48,    49,   120,    98,   102,    70,   108,   104,    66,
     114,    82,    77,   110,    78,   112,    80,    81,   113,    95
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   250,   251,   251,   252,   252,   253,   253,   253,   254,
     254,   255,   255,   255,   256,   256,   257,   257,   258,   258,
     258,   258,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   258,   258,   259,   259,   260,   260,   261,   261,
     261,   261,   262,   262,   263,   263,   263,   264,   264,   265,
     266,   266,   266,   267,   267,   268,   268,   268,   268,   269,
     269,   270,   270,   271,   271,   272,   272,   272,   273,   273,
     273,   273,   273,   274,   274,   276,   275,   277,   277,   278,
     278,   278,   278,   280,   279,   281,   281,   282,   282,   282,
     282,   282,   283,   283,   283,   283,   283,   283,   284,   284,
     285,   285,   285,   285,   286,   286,   286,   286,   287,   287,
     287,   288,   288,   288,   289,   289,   289,   290,   290,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   292,   292,
     293,   293,   293,   293,   294,   294,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   296,   296,   297,   297,   298,   298,   298,   298,   298,
     298,   298,   298,   299,   299,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   301,
     301,   301,   301,   301,   301,   302,   302,   303,   303,   304,
     304,   304,   304,   304,   305,   305,   305,   305,   305,   306,
     306,   307,   307,   308,   308,   309,   310,   310,   312,   313,
     311,   314,   314,   315,   315,   316,   316,   316,   317,   317,
     318,   318,   318,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     320,   319,   321,   319,   319,   322,   319,   323,   319,   319,
     319,   319,   324,   319,   325,   319,   319,   326,   319,   319,
     327,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   328,   328,   329,   330,   330,   332,   331,   333,
     331,   334,   334,   335,   335,   336,   336,   336,   337,   337,
     338,   339,   339,   340,   340,   340,   341,   341,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   343,
     344,   345,   344,   346,   344,   347,   344,   348,   344,   349,
     344,   350,   350,   351,   352,   352,   353,   353,   354,   354,
     354,   354,   354,   355,   355,   355,   355,   356,   356,   357,
     358,   359,   358,   360,   358,   361,   358,   362,   358,   363,
     358,   364,   364,   365,   365,   365,   365,   365,   366,   366,
     367,   367,   368,   368,   368,   368,   369,   369,   370,   370,
     370,   370,   371,   371,   372,   372,   372,   373,   373,   374,
     374,   374,   375,   376,   376,   377,   377,   378,   378,   379,
     379,   379,   379,   379,   379,   379,   380,   380,   381,   381,
     382,   382,   383,   383,   384,   385,   385,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   386,
     386,   387,   387,   388,   388,   389,   389,   390,   390,   390,
     390,   391,   391,   391,   392,   392,   392,   393,   393,   393,
     394,   394,   394,   394,   395,   395,   395,   395,   396,   396,
     397,   397,   397,   398,   398,   398,   398,   398,   398,   398,
     398,   399,   399,   400,   400,   401,   401,   401,   401,   401,
     402,   402,   402,   402,   402,   403,   402,   402,   402,   402,
     404,   402,   402,   402,   402,   402,   402,   402,   402,   402,
     402,   402,   402,   402,   402,   402,   402,   402,   402,   402,
     402,   402,   402,   402,   402,   402,   402,   402,   402,   402,
     402,   402,   402,   402,   402,   402,   402,   402,   402,   402,
     402,   402,   402,   402,   402,   402,   405,   405,   406,   406,
     407,   408,   408,   409,   409,   410,   410,   410,   410,   410,
     410,   410,   410,   410,   410,   410,   410,   411,   411,   412,
     412,   413,   413,   413,   413,   413,   413,   413,   413,   413,
     413,   413,   413,   414,   414,   414,   414,   414,   416,   415,
     417,   417,   418,   419,   419,   420,   420,   421,   422,   423,
     423,   424,   424,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   426,   426,   426,   426,
     427,   427,   427,   427,   428,   428,   429,   429,   430,   430,
     431,   431,   432,   432,   433,   433
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     1,     1,     2,     1,
       1,     3,     2,     0,     3,     1,     1,     3,     7,     6,
       4,     4,     4,     4,     3,     3,     3,     4,     4,     4,
       4,     4,     3,     3,     1,     2,     1,     0,     3,     3,
       2,     3,     2,     1,     3,     3,     3,     1,     0,     3,
       1,     2,     3,     2,     4,     2,     4,     6,     8,     1,
       0,     1,     3,     1,     5,     1,     1,     1,     1,     1,
       1,     1,     8,     1,     0,     0,     6,     2,     1,     3,
       3,     3,     3,     0,     6,     2,     1,     4,     4,     4,
       4,     4,     5,     5,     5,     5,     5,     5,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     1,     3,     3,     2,     2,     1,     6,     4,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     1,     5,
       3,     1,     0,     2,     3,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       4,     4,     4,     4,     4,     6,     4,     4,     6,     4,
       4,     4,     4,     4,     4,     6,     6,     3,     3,     6,
       7,     1,     2,     1,     1,     4,     5,     3,     2,     4,
       5,     4,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     4,     6,     6,     6,     1,     3,     1,     3,     1,
       3,     3,     2,     2,     6,     6,     6,     6,     8,     1,
       0,     1,     0,     1,     3,     3,     3,     1,     0,     0,
      11,     1,     1,     8,     0,     3,     3,     0,     0,     4,
       2,     3,     4,     8,     8,     7,     6,     6,     6,     6,
       6,     6,     6,     3,     1,     3,     4,     5,     5,     6,
       3,     3,     6,     6,     5,     5,     5,     3,     3,     3,
       0,     8,     0,    11,     5,     0,     9,     0,    12,     6,
       3,     3,     0,    14,     0,     5,     2,     0,     7,     5,
       0,     8,     2,     3,     3,     3,     2,     5,     3,     3,
       9,     5,     1,     0,     4,     2,     1,     0,     4,     0,
       4,     2,     1,     1,     0,     1,     3,     5,     1,     1,
       3,     3,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     3,     0,     4,     0,     3,     0,     3,     0,
       3,     1,     3,     4,     1,     0,     2,     1,     6,     6,
       6,     6,     2,     1,     1,     2,     2,     1,     1,     3,
       1,     0,     3,     0,     4,     0,     3,     0,     3,     0,
       3,     1,     3,     4,     4,     2,     2,     0,     5,     4,
       1,     3,     1,     5,     3,     7,     1,     0,     1,     6,
       4,     4,     1,     3,     5,     5,     4,     3,     1,     1,
       1,     1,     5,     1,     0,     0,     1,     5,     6,     1,
       2,     1,     1,     1,     1,     0,     2,     3,     1,     3,
       2,     3,     1,     3,     2,     1,     3,     3,     2,     2,
       6,     6,     3,    10,     8,    10,    10,    12,    12,    10,
       7,     1,     2,     5,     3,     1,     1,    10,    11,    10,
      11,     1,     1,     1,     5,     3,     5,     6,     6,     3,
       1,     4,     3,     6,     3,     7,     3,     7,     1,     3,
       1,     1,     0,     2,     2,     4,     4,     5,     7,     3,
       1,     3,     1,     0,     1,     1,     2,     2,     3,     1,
       5,     3,     5,     3,     3,     0,     7,     2,     4,     3,
       0,     7,     2,     4,     3,     3,     2,     3,     5,     6,
       6,     6,     6,     6,     6,     5,     7,     5,     7,    13,
      11,    13,     5,     5,     5,     2,     3,     4,     6,     4,
       4,     4,     4,     5,     5,     5,     9,     5,     9,     5,
       5,     2,     5,     4,     2,     2,     2,     1,     1,     1,
       4,     1,     1,     1,     0,     6,     6,     6,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     2,     1,     1,
       0,     5,     5,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     3,     2,     2,     0,     4,
       1,     1,     4,     1,     2,     1,     2,     6,     5,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     4,     1,     2,     1,     3,     1,     0,
       2,     0,     2,     4,    10,    13
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      13,     0,     0,     0,     0,     0,     0,    13,     0,     4,
      71,    70,    68,    69,    16,    12,     0,    15,    74,    74,
       0,     0,     1,     5,   272,   271,     0,     0,    11,     0,
      73,    75,    83,     0,     0,   268,   239,   169,   168,     6,
       7,   167,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   166,    17,
     119,   170,    14,     0,     0,   686,   689,     0,     0,   278,
       0,     8,   127,   128,   129,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   125,
     131,   126,   123,   120,   121,   158,     0,   122,   130,   124,
     165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,     0,     0,     0,     0,
       0,     0,    86,   688,     0,     0,     0,     0,     0,   277,
     165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,     0,     0,
     198,   151,   152,   149,   153,   150,   154,   146,   147,   148,
     133,   155,   156,   141,   142,   143,     0,   140,   132,   139,
     144,   145,   137,   138,   134,   135,   136,     0,   240,     0,
       0,     0,     0,     0,    76,    77,     0,     0,     0,     0,
       0,    84,    85,   691,   687,     0,     0,     0,    13,   274,
     172,   194,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,   183,   184,     0,   186,   187,     0,     0,     0,
     189,   190,   191,   192,   193,     0,     0,   164,     0,   171,
       0,     0,     0,   241,    80,    79,    82,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   684,   650,
       0,     0,     0,   438,     0,     0,     0,     0,     0,   249,
     436,   247,   432,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   157,     0,     0,     0,    88,    89,    91,    90,
      87,   690,     0,   245,     0,     0,     0,     0,     0,   649,
       0,   685,    72,     0,   280,     0,   279,     0,   442,     0,
       0,   260,   260,   260,   437,   275,    13,   253,   276,     0,
     269,   179,   185,   195,   196,   188,   159,     0,   199,   243,
     244,   242,     0,     0,     0,   680,   681,   682,     0,     0,
     638,     0,     0,     0,   281,     0,     0,     0,   434,     0,
     371,   375,   369,   374,   370,   373,   377,   372,   368,   378,
     376,   262,   259,   262,   379,   262,   262,   248,   251,   250,
       0,     0,   200,   692,     0,     0,   246,   683,     0,     0,
     694,   395,   282,   441,     0,   440,   443,     0,     0,   261,
     454,   454,   454,   454,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   451,   449,     0,     0,
     450,     0,     0,     0,     0,   343,    48,     0,     0,   294,
     352,     0,     0,     0,   262,     0,     0,     0,   656,   675,
     658,   659,   653,   654,   655,   657,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,     0,   643,   640,   641,   645,     0,   651,   408,   407,
     393,   394,   397,     0,     0,     0,   433,     0,   453,     0,
       0,     0,     0,     0,   336,     0,     0,     0,    98,    60,
       0,    50,     0,     0,     0,     0,     0,     0,   342,   465,
       0,     0,     0,     0,   262,   262,     0,     0,   415,     9,
      10,     0,   417,   419,   421,     0,   410,   411,     0,   262,
       0,   385,     0,   387,   389,     0,   380,   391,   381,     0,
     162,   214,     0,   162,     0,     0,   332,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   491,     0,
       0,     0,     0,     0,     0,     0,    47,   454,     0,   427,
       0,     0,   215,   221,   222,   223,   231,     0,     0,   216,
     227,   218,   224,   225,   226,   217,   229,   232,     0,     0,
       0,   228,   230,   234,   237,   238,     0,   233,   235,   236,
     220,   219,     0,   367,     0,   359,   355,   358,   326,   351,
     270,   454,   262,   693,     0,   648,   639,   644,     0,   646,
       0,     0,   652,   402,   396,     0,     0,   439,     0,     0,
     255,   254,   256,   257,     0,   293,     0,   338,     0,     0,
     102,   106,   101,   105,   100,   104,   103,   107,     0,     0,
       0,    59,     0,     0,     0,   295,     0,    51,    24,     0,
     339,   461,   462,   463,     0,   464,   459,     0,     0,     0,
     320,   321,     0,   454,   454,    33,     0,     0,   413,     0,
       0,    26,     0,     0,   335,   454,    32,     0,   383,     0,
       0,    25,     0,     0,     0,   208,     0,   161,     0,     0,
     301,     0,   300,   334,     0,     0,     0,     0,     0,   518,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   510,
     496,   495,     0,   522,   333,   492,   479,     0,   478,     0,
       0,     0,     0,     0,    60,     0,     0,     0,     0,     0,
       0,   309,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    13,   263,     0,   307,   308,
       0,   455,   468,     0,     0,   455,   472,     0,     0,     0,
       0,   364,   363,   365,   366,   262,     0,     0,   162,     0,
       0,     0,   262,     0,     0,   324,    60,   454,   695,     0,
       0,   679,   653,   654,   655,     0,     0,   404,     0,     0,
     403,     0,     0,   435,     0,     0,     0,     0,     0,     0,
       0,     0,    67,    65,    66,     0,    55,   263,     0,   267,
       0,   327,    52,    49,     0,   460,     0,   330,     0,   344,
       0,     0,   409,   416,     0,   418,   420,   422,   412,     0,
     386,     0,   388,   390,   392,   382,     0,     0,     0,   448,
       0,     0,     0,   163,   207,   162,   213,     0,     0,   522,
     482,     0,     0,     0,   477,     0,     0,     0,   530,     0,
       0,     0,     0,     0,     0,     0,   509,     0,   522,   520,
     521,     0,     0,     0,   494,     0,   505,     0,   310,     0,
      46,    45,    44,     0,     0,     0,   426,   425,   162,     0,
       0,     0,     0,     0,     0,   595,   162,   591,     0,     0,
       0,   547,     0,   597,     0,     0,     0,     0,     0,     0,
       0,     0,   556,   552,     0,     0,     0,     0,     0,     0,
       0,     0,    53,    13,     0,   108,     0,   599,   598,   575,
       0,     0,   594,     0,     0,    28,     0,     0,   466,   456,
       0,    20,    30,     0,   470,     0,    22,    31,    23,    27,
       0,    29,    21,     0,     0,     0,   296,   454,     0,   356,
       0,     0,     0,   676,   677,   678,     0,   642,   405,   406,
       0,     0,     0,   258,   273,   337,     0,     0,     0,     0,
       0,     0,     0,    63,     0,     0,   306,     0,     0,     0,
     315,     0,     0,   329,     0,     0,   414,     0,   384,   211,
       0,   205,     0,   209,     0,     0,     0,     0,   160,     0,
       0,     0,   514,     0,   516,   519,     0,   524,   119,   523,
     119,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   512,     0,     0,     0,    61,     0,     0,   314,   620,
       0,     0,   341,     0,     0,     0,   430,     0,   305,   304,
       0,     0,     0,     0,     0,   555,     0,   549,   545,   544,
     596,     0,     0,     0,   541,   554,     0,     0,     0,   550,
     557,     0,     0,   543,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   111,   116,   264,   576,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     467,     0,     0,   469,   471,   473,     0,     0,   297,     0,
     298,     0,    60,     0,   325,     0,     0,     0,     0,     0,
       0,   452,    97,    96,    94,    92,    95,    93,     0,    56,
       0,   265,   266,     0,     0,     0,   346,     0,   319,    13,
       0,     0,   291,   290,   289,     0,   447,   212,   206,   210,
     303,   302,     0,     0,     0,     0,     0,   158,   532,     0,
       0,     0,   529,     0,   533,     0,     0,     0,     0,     0,
     511,     0,     0,     0,     0,     0,     0,     0,     0,   493,
     506,   504,   604,   604,   604,     0,   601,   618,   602,   619,
       0,   604,   604,   604,   634,     0,   286,     0,     0,   423,
       0,   424,     0,   118,   600,   582,   580,     0,     0,   548,
      37,     0,     0,     0,     0,     0,     0,   553,    37,     0,
       0,     0,     0,     0,     0,    54,   577,   110,   115,   114,
      13,     0,     0,   109,   593,     0,     0,     0,     0,     0,
     581,     0,     0,     0,   579,     0,     0,     0,    19,   299,
       0,   362,     0,     0,   357,   292,   287,   288,   647,   401,
     400,   399,   398,     0,     0,   349,   347,   328,   345,     0,
     204,     0,   201,   203,     0,     0,     0,   446,     0,   481,
     480,     0,     0,     0,     0,   526,   525,     0,   539,   535,
       0,   534,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   507,     0,   508,    62,     0,   603,     0,     0,
     262,     0,     0,     0,   262,     0,     0,     0,   262,   617,
       0,     0,     0,     0,   262,     0,     0,     0,   262,     0,
       0,     0,   262,   636,   637,     0,     0,     0,   431,     0,
     590,   540,    34,    36,     0,     0,     0,    43,     0,     0,
       0,     0,     0,     0,   572,     0,   542,     0,   567,   565,
     558,   589,   574,   573,     0,   112,   113,   592,     0,   584,
     587,     0,   583,   585,     0,     0,    18,     0,     0,   285,
     455,     0,   475,     0,     0,    57,     0,     0,     0,     0,
     202,     0,     0,   331,   445,   444,     0,     0,   531,   527,
     533,   536,     0,   537,   533,     0,   533,   533,   490,     0,
       0,     0,   513,   501,   502,   503,     0,     0,     0,     0,
       0,   454,     0,     0,     0,   454,     0,     0,     0,   454,
     311,   626,   629,   632,   454,   624,   627,   630,   454,   625,
     628,   631,   454,   635,   633,    37,     0,   429,     0,   117,
      35,     0,   562,     0,     0,    40,     0,   559,    42,     0,
     563,   560,   564,   561,     0,     0,     0,     0,   578,     0,
       0,   457,     0,   360,   361,   474,   284,     0,   283,     0,
      64,   350,   348,     0,   316,    37,   515,   517,     0,     0,
     484,   538,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   610,   613,   616,     0,   608,   611,   614,     0,   609,
     612,   615,     0,     0,     0,     0,     0,   340,   428,   546,
      41,    39,    38,     0,     0,   551,   568,   566,     0,     0,
     458,   455,   476,    58,     0,     0,   528,     0,     0,   533,
       0,     0,   533,     0,     0,     0,     0,     0,     0,     0,
     623,   621,   622,     0,     0,     0,     0,     0,     0,     0,
     483,   485,     0,   486,   489,     0,     0,     0,   497,   499,
     607,   605,   606,   313,     0,     0,     0,   588,   586,   322,
     318,     0,     0,   498,   500,     0,     0,     0,     0,   488,
     487,     0,   570,     0,   323,     0,     0,   571,   569
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,    78,   553,   468,    16,    17,   469,  1393,
    1394,  1397,  1398,   596,   597,   531,   532,   794,   681,   682,
    1084,  1085,   856,     9,    31,    10,    83,   164,   165,    11,
      84,   171,   172,   528,   529,   678,   679,   795,  1134,  1135,
     770,  1033,   126,   728,  1399,    80,  1321,  1322,   571,   572,
     632,    81,   344,   317,   318,   319,   411,   440,   797,   859,
     860,    12,    89,   421,    26,   324,   259,   179,   312,   470,
    1089,   929,  1189,  1041,  1638,  1010,  1037,  1042,   539,   471,
    1185,  1186,  1438,  1437,   472,   473,   637,   638,  1301,  1302,
     814,   815,   412,   416,   565,   723,   881,   717,   719,   720,
     566,   567,   510,   511,   512,   841,   513,   554,   555,   713,
     874,   707,   709,   710,   556,   768,  1096,  1097,   320,   321,
     322,   359,   889,   890,   474,   518,   519,  1525,   989,   697,
     802,   803,   806,   807,  1432,  1433,   588,   589,   590,   752,
     591,  1466,   592,   593,  1225,   739,   740,   922,   909,  1209,
    1340,  1341,   978,  1260,  1268,   954,   979,   771,  1237,  1360,
    1238,  1239,  1240,  1244,  1245,   391,   429,   501,   502,   503,
     504,   505,   349,   350,   506,   507,   836,   308,   309,    87,
     174,   304,   383,    13
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1247
static const yytype_int16 yypact[] =
{
     421,   306,   204,   209,   222,   -74,   282,   451,   262, -1247,
   -1247, -1247, -1247, -1247,    73, -1247,    19, -1247,    87,    87,
     130,   549, -1247, -1247, -1247, -1247,   554,  6640, -1247,   584,
   -1247, -1247, -1247,   148,   406, -1247, -1247,   426, -1247, -1247,
     641, -1247,  7317,  7317,  7317,   466,   485,   525,   537,   555,
     566,   623,   652,   656,   675,   681,   687,   697,   701,   709,
     718,   763,   783,   787,   797,   807,   811,   838,   855,  7317,
    4135,  7317,  7317,  7317,  6640,  7317,  4222,  6640, -1247, 10337,
   -1247,   427, -1247,   122,   200, -1247,   654,   -46,   725,   545,
    6640, -1247, -1247, -1247, -1247,  6640,  6640,  6640,  6640,  6640,
    6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,
    6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640, -1247,
   -1247, -1247, -1247, -1247, -1247, 10648,   594, -1247, -1247, -1247,
    4797,   279,  6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,
    6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,
    6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,  6640,   843,
    6640,   559,   906,   937,   514, -1247,   818,   861,   876,   883,
     890,   410, -1247, -1247,   941,   985,   894,   901,   913,   916,
   10337,   363,  1447,  1875,  2493,  3094,  3393,  3676,  5129, 10188,
    5179,  5288,  6173,  7508,  7630, 10210,  7658,  7716, 10232, 10270,
   10292,  7738,  7760,  7782,  7866,  7990,  6640, -1247,  6640,  6640,
   -1247,   550,   550,   507,   507,   507,   507,   242,   242,   242,
   -1247,  6891,  1015,   673,  2223,  2223, 10852,  1523,  2223,   673,
     550,   550,   127,   127,  1141,  1141,  1141,   580, -1247,  1120,
     951,   957,   961,   962, -1247, -1247,  6640,  1185,  1193,  1199,
    1198, -1247, -1247,   991, -1247,   301,  1209,  1088,   192,  1204,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,  6640, -1247,
   -1247, -1247, -1247, -1247,  6640, -1247, -1247,  6640,  6640,  6640,
   -1247, -1247, -1247, -1247, -1247, 10874,   310, 10337,  6640, -1247,
    6640,  6640,  6640, -1247, -1247, -1247, -1247, -1247,  9206,  1033,
    1037,  1042,  1046,  6640,  1049,  1272,  1274,   151, -1247,   644,
    1057,  1281,   598,  1058,  1282,  1283,   407,   618,   244, -1247,
   -1247, -1247, -1247,  1288,  1073,  8012,  8034,  8074,  8096,  8118,
    6640,    27, 10337,  2175,  2334,  2634, -1247, -1247, -1247, -1247,
   -1247, 10337,  1190, -1247,   176,  1078,  1084,  1289,  1303, -1247,
    1143, -1247, -1247,  1090, -1247,   201, -1247,  3175, -1247,   418,
    1093,  1180,  1180,   810,    20, -1247,   170, -1247, -1247,  1203,
   -1247, -1247, -1247, -1247, -1247, -1247, 10337,  1092, -1247, -1247,
   -1247, -1247,  1312,   624,  1314, -1247, -1247, -1247,  1100,  1102,
   -1247,  1255,  6640,  1281, -1247,  1106,  2016,  1282, -1247,    32,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,
   -1247,  1186, -1247,  1186, -1247,  1186,  1186, -1247, -1247, -1247,
    1334, 11695, -1247, -1247,  1232,  1121, -1247, -1247,   669, 11985,
   -1247,  6143, -1247, -1247,  6640, -1247, -1247,  1282,  1119, -1247,
    1115,  1115,  1115,  1115,  1128,  1126,  1272,    61,  1131,    40,
    1272,  1132,    92, 11543,  1272,  1134,  1214,  1214,   177,  1357,
    1214,   182,    39,    91,   477,  1317,  1142,  1146, 12156, -1247,
   -1247,  7451, 11385,  1290,  1127,  1366,  1143,  1150, -1247, -1247,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,
   -1247,  1291, -1247, 11985, 11985, -1247,  5509, -1247,  6922, -1247,
   -1247,   445, -1247,   265,  2793,   487, -1247,  6640, -1247,  1369,
    1372,  1374,  1375,  1376, -1247,   535,   634,   695, -1247,  1157,
    6640, -1247,   587,   481,  1377,   645,  1379,  1309, -1247,   453,
   10468,  1310,   747,  6640,  1186,  1186,  1166,  1169, -1247, -1247,
   -1247,  1115, -1247, -1247, -1247,  1170,  1171, -1247,  1172,  1186,
    1173, -1247,  1115, -1247, -1247,  1175,  1178, -1247, -1247,   281,
    5069, -1247,   785,  5211,   850,  1316, -1247,  1174,  1182,   734,
    1184,  1187,  1188,  1189,  1191,  1194,  1195,   294, -1247,   632,
    1183,  1201,  1206,  1208,  1399,    84, -1247,  1115,   357,  1207,
    1404,  4741, -1247, -1247, -1247, -1247, -1247,  4741,   978, -1247,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,  1072,  1080,
     158, -1247, -1247, -1247, -1247, -1247,  1083, -1247, -1247, -1247,
   -1247, -1247,    98,   221, 10645, -1247, -1247, -1247,  1338, -1247,
   -1247,  1115,  1186, -1247,  1333, -1247, -1247, -1247, 11033, -1247,
   11080, 11127, -1247, 10337, -1247,  6065,  6065, -1247,  1210, 10896,
   -1247, -1247, -1247,  1211,  1212, -1247,  6640, -1247,  1215,  1216,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,  1217,  1218,
     188, -1247,    53,  8140,  1377, -1247,  6640, -1247, -1247,  1219,
   -1247, -1247, -1247, -1247,  1115, -1247, -1247,  1425,  1434,  1368,
   -1247, -1247,  8242,  1115,  1115, -1247,  6640,  1439, -1247,  1439,
    1439, -1247,  1439,  1439, -1247,  1115, -1247,  1281, -1247,  1281,
    1281, -1247,  1281,  1281,  1413,  1229,  1227, 10337,   629,   132,
   -1247,  1228, -1247, -1247,  6640,  1091,  1233,  1241,  1249, -1247,
     878,  7008,  7008,  7008,  7008,  7008,  7008,  7008,  1248,  1242,
   -1247, -1247,  1477,   248, -1247, -1247, -1247,   212, -1247,   214,
      97,  1260,  1261,  1262,  1157,  1263,  1267,   157,   185,  1269,
    1466, -1247,   195,   202,  1377,    53,   394,  1273,  1275,  1276,
      53,  1377,  1277,    53,  4741,  4311,  1278,    53,  1280,  1284,
    1285,   217,    99,  6640,  4433,  1463,   437,    34, -1247, -1247,
    1271,    11, -1247,   881,  1286,   206, -1247,   888,  1287,   892,
    1292, -1247, -1247, -1247, -1247,  1186,  1294,   895,  4859,   132,
     162,   908,  1186,  1495,  1430, -1247,  1157,  1115, -1247,   577,
   11985, -1247,  1295,  1296,  1297,  1300,  1298, -1247,  7146,  7232,
   10337,  1301,  1304, -1247,  6640,  6640,  1482,  9228,   332,   576,
     448,   478, -1247, -1247, -1247,  6640, -1247,   723,  1306, -1247,
     909, -1247, -1247, 10337,  6640, -1247,   131, -1247,  1433, -1247,
    1272,  1272, 10337,  1171,  1439,  1171,  1171, -1247,  1171,  1272,
    1178,  1281,  1178,  1178, -1247,  1178,  1302,  1516,   727, -1247,
     728,  1639,   132,  6640, -1247,  6640, -1247,   132,  8348,   248,
   -1247,  6640,  6781,   734, -1247,  1293,  6640,  6640,  1325,  1315,
    1326,  1327,  1328,  1331,  1332,  1340, -1247,  7317,   248, -1247,
   -1247,  1525,   744,  6640, -1247,  3316, -1247,  1449, -1247,  1313,
   -1247, -1247, -1247,  1272,  1336,  1554, -1247, -1247,  3457,  1341,
     936,  1557,  6640,  6640,  6640, -1247,  6640, -1247,   271,  1343,
     218, -1247,  1560, -1247,  4506,  6640,  6640,  6640,  1344,   422,
      58,  1346, -1247, -1247,  1565,  4555,  3616,  1349,  6640,  6640,
    3757,  6640, -1247,  1463,  1798,   723,   513, -1247, -1247, -1247,
    4433,  6206, -1247,  5421,  5573, -1247,  6640,  6640, -1247,  1345,
    1567, -1247, -1247,  6640, -1247,  1570, -1247, -1247, -1247, -1247,
      41, -1247, -1247,   939,   132,   943, -1247,   348, 11847, -1247,
   12005,  1161,  1272, -1247, -1247, -1247,   577, -1247, -1247, -1247,
    6065,  6065,  2952, 10337, -1247, -1247,  1354,  1355,  1356,  1361,
    1370,  1371,   737, 10918,  6640,    53, -1247,  6358,  9250,  1514,
   -1247,  1378, 11847, -1247,   947,   952,  1171,   956,  1178, -1247,
    1385, -1247,  1365, -1247,  1382,   757,   769,   960, 10337,   967,
    1387,   761, 10940,  6640, 10337, -1247,  1526, 10337,  1403, 10337,
    1405,  6640,  7008,  6640,  7008,  7008,  7008,  6640,  7008,  1381,
     779,  1380,   135,   165,   771, -1247,  1391,   780, -1247,   764,
     486,   971, -1247,  1388,  1610,   781, -1247,   800, -1247, -1247,
     802,  9334,  9457,  9479,   804, -1247,  6640, -1247,  1541, -1247,
   -1247,  8370,  8392,  8450, -1247, -1247,  1394,  1397,  6640,  1508,
   -1247,  1400,  8472, -1247,  8494,  8516,  1401,  8600,  1406,  4433,
    1407,  6640,  6640,  1408,   104, -1247, 10337, -1247, -1247,  1412,
     820,  1409,   166,  6640,  6640,  9501,  1416,  6640,  6640,  9541,
   10337, 10962,  6640, -1247, 10337, -1247,  1567,   974, -1247,   977,
   -1247,  1622,  1157,  1562, -1247,  1426,   980,   981,  1431,   522,
     526, -1247, -1247, -1247, -1247, -1247, -1247, -1247,  6640, -1247,
    6640, 10337, -1247,  1432,   181,  5783, -1247,  6640, -1247,   574,
     486,  1572, -1247, -1247, -1247,  2557, -1247, -1247, -1247, -1247,
   -1247, -1247,  1442,  1443,  1477,  1477,  6640, 10065, -1247,   194,
    6640,  6640, 10337,  1446,    63,  1448,  1454,  1456,   821,  1457,
   -1247,  1450,  1462,  7317,  1477,   841,  1477,   845,  6640, -1247,
   -1247, -1247,   533,   661,   670,   754, -1247, -1247, -1247,   764,
    4433,   759,   782,   795, -1247,   692, -1247,  1660,  1467, -1247,
    1458, -1247,  1682, -1247, -1247, -1247, -1247,  1468,  9563, -1247,
     638,  2716,  2875,  3034,  4741,  6640,  9585, -1247,   638,  4433,
    4433,  4741,  4433,  4741,  4741, -1247, -1247, -1247, 10337, 10337,
    1463,  5924,  5924, -1247, -1247,  1469,  6640,  1939,  9607,  9708,
   -1247,  6640,  9814,  9836, -1247,  6640, 10984,   989, -1247, -1247,
    1471, -1247,   993,  1684, -1247, -1247, -1247, -1247, -1247, -1247,
   -1247, -1247, -1247,   846, 11006, -1247, -1247, -1247, -1247,  9858,
   -1247,  3987, -1247, -1247,   713,  1614,  1472, -1247,  8724, -1247,
   -1247, 11210,  6640,  1624,  7317, 10337, 10337,  6640, -1247,  1377,
    1474,  1479,  6640,  6640,  6640,  6640,  1478,  6640,  1477,  1477,
    1473,   313, -1247,   313, -1247, -1247,  1272, -1247,  1272,  1272,
    1186,  1272,  1272,  1272,  1186,  1272,  1272,  1272,  1186, -1247,
    1609,  1698,  1699,  1701,  1186,  1702,  1703,  1704,  1186,  1705,
    1706,  1707,  1186,   501, -1247,  1491,  1492,  6499, -1247,  1493,
   -1247, -1247, -1247,   638,  4741,    82,  4367, -1247,  2098,   205,
     128,  2257,   140,  2416, -1247,  9915, -1247,  4741,  1640,  1643,
   -1247, -1247, -1247, -1247,  4433, -1247, -1247, -1247,  8746, -1247,
   -1247,  8768, -1247, -1247,  3426,  6640, -1247,  6640,  1622, -1247,
     304,   999, -1247,  1013,  6640, -1247,  6640,  7451,  7451,  1713,
   -1247,  1641,  1498, -1247, -1247, -1247,  6640,  8808, -1247,  1517,
      63,   723,  1500,  1377,    63,  1503,    63,  1569, -1247,  1504,
     313,   313, -1247, -1247, -1247, -1247,  6640,  6640,  1019,  1023,
    1024,  1115,  1027,  1028,  1031,  1115,  1032,  1038,  1045,  1115,
   -1247, -1247, -1247, -1247,  1115, -1247, -1247, -1247,  1115, -1247,
   -1247, -1247,  1115, -1247, -1247,   638,  1507, -1247,  8830, -1247,
   -1247,  4619, -1247,  4433,  4433, -1247,  1519, -1247, -1247,  4433,
   -1247, -1247, -1247, -1247,  3898,  4692,  4433,  4433, -1247,  1501,
    1501, -1247,  3534, 10337, -1247, -1247, -1247,  1725, -1247,  1520,
   10337, -1247, -1247,  1521, -1247,   638, 10337, -1247,  6640,  1522,
   -1247,   723,  1524,  6640,  1527,  1528,  6640,  6640,  6640,  8852,
    8874, -1247, -1247, -1247,  1272, -1247, -1247, -1247,  1272, -1247,
   -1247, -1247,  1272,  1735,  1739,  1741,  4433, -1247, -1247, -1247,
   -1247, -1247, -1247,  1531,  9937, -1247, -1247, -1247,  6640,  6640,
   -1247,  1518, -1247, -1247,  6640,  4741, 10337,  1533,  1534,    63,
    1536,  1538,    63,  8976,  9082,  1539,  1540,  1052,  1053,  1056,
   -1247, -1247, -1247,  1663,    53,   147,  9959,  9981,  9104,  1683,
   -1247, -1247,  1542, -1247, -1247,  1543,  1544,  1545, -1247, -1247,
   -1247, -1247, -1247, -1247,  1548,  1547,  1550, -1247, -1247, -1247,
   -1247,  1551,  1564, -1247, -1247,  6640,  4741,  6640, 12005, -1247,
   -1247,  9126, -1247,  9184, -1247,  4741,  4741, -1247, -1247
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1247, -1247, -1247,  1342,  -457,     1, -1247,  1733, -1055, -1247,
   -1246,  -568,  -301, -1247, -1247,  -485, -1247,    93,  -492,  -734,
     860,  -835,  -548,  1779,  1769, -1247, -1247, -1247,  1625, -1247,
   -1247, -1247,  1619,  -615, -1247,  -551,  -546,  -970, -1247,  -194,
   -1247,   -27, -1247,  -585,   -61,   -18, -1247,   470,  1065,  -456,
   -1247,  -221,  -350, -1247, -1247,  1429,   760,  -271,  -634,   765,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,  -469,
   -1247, -1247, -1247, -1247, -1247, -1247, -1247, -1247,  1347, -1247,
   -1247,   611, -1247, -1247, -1247,  -441, -1005,  -296,   370,   506,
   -1247,  1177,   -35,   239, -1247, -1247, -1247, -1247, -1247, -1247,
    -244,  -290, -1247, -1247,  1305,  -645, -1247,  1099, -1247, -1247,
   -1247, -1247, -1247, -1247,  -239, -1247,   563, -1247, -1247,  1451,
     226,  1383,   762,   926, -1247,  -294,  -410,    -6, -1247, -1247,
     828,  -611,   824,  1202,   295, -1247,  1234, -1247,   766, -1247,
   -1247, -1057,  -572, -1247,  -578,   921, -1247,  -729,  -706, -1247,
    -844, -1247,  -430, -1247, -1247,  -775,  -913, -1247,   586,  -382,
   -1129, -1247, -1247,   444,   648,  1358, -1247, -1247,  1330, -1247,
   -1247,  1339, -1247, -1247,   643,  -488,   815,  1552, -1247, -1247,
   -1247, -1247, -1247, -1247
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -679
static const yytype_int16 yytable[] =
{
      79,     8,   636,   639,   564,  1164,   736,   574,     8,   753,
     965,   842,   541,  1144,  1148,   817,   131,   820,   652,   726,
    1032,   354,  1407,   313,    92,    93,    94,   731,   377,   181,
     933,   520,   521,   522,  1236,   313,   910,   911,   912,   913,
     914,   915,   569,    36,   801,   983,    28,   125,   858,   687,
     130,   119,   121,   122,   123,   124,    36,   127,   129,  1116,
    1323,    36,   526,   180,   -99,   394,  1338,  1138,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,  1011,   537,   569,  -343,   525,   237,   927,   699,
     535,   569,    36,   432,   542,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   180,  1039,   239,  1320,   569,  1128,   538,   749,   888,
     819,   949,   441,    21,   442,   443,   958,   286,  1625,   961,
      36,    85,   141,   967,   346,   534,  1502,   899,   936,   810,
     652,  -367,   652,   835,   557,   569,   937,   568,   749,    36,
    1061,   798,   175,   418,   918,   176,   821,   799,   546,   285,
     547,   180,   287,   560,  1236,   353,   939,   764,   569,  1080,
     161,   852,  1323,   824,   761,   313,     1,   853,   854,   862,
    -343,   762,  1510,   641,   353,  1392,   943,    18,   811,   924,
     162,   926,    19,  1392,  1512,   852,  1276,   852,     1,   298,
     852,   853,   854,   853,   854,    20,   853,   854,   533,   943,
     986,   826,  1281,  -343,  -343,   166,   167,    29,  1214,   763,
     987,   325,  1218,   972,  -343,   696,   314,   326,   315,  1566,
     327,   328,   329,   984,   378,   163,   570,   708,   437,   316,
    -343,   332,   168,   333,   334,   335,  1320,   141,   718,   517,
     517,   811,   812,   703,   704,   725,   341,    86,   527,   793,
     347,  1339,    22,   -99,   793,   548,  1503,   -99,   715,  1585,
     561,  1107,    27,   870,   871,   748,  1467,   749,  1027,   813,
    1031,   169,  1026,   376,  1029,   879,  1055,    30,   573,    14,
    -367,   973,   940,   533,  -312,   818,   974,   928,   549,   550,
     680,  -343,  1282,   549,   550,  1283,  1117,  1370,  1004,   551,
     396,   393,  1503,    15,   562,   812,  1463,  1464,  1500,   155,
     156,   157,   835,  1313,  1503,   552,   953,    33,  -317,   895,
     563,  1040,  1224,  1095,   962,   953,  1408,  1409,   765,  1411,
     766,  1104,   813,  1003,  1005,   431,  1213,   316,  1215,  1216,
    1217,   827,  1219,   793,   938,  1169,  1170,    24,   170,   895,
     796,    25,  1226,  1287,   680,  1316,   796,  -367,  -252,  1157,
    -252,  -252,  1161,  1355,   384,   950,   385,    36,   773,   209,
     865,   858,   895,  1547,  1548,   855,   517,   514,   305,  1509,
    -437,   517,  1333,  -437,   944,   945,   750,  1012,   314,   946,
     315,    -3,   947,   209,  1334,   993,   751,   774,  1303,   923,
     306,   925,   884,   633,   971,   987,  1057,   944,   945,   642,
    1392,  1059,   775,   776,   307,   166,   167,     1,   777,   778,
     779,    -2,   153,   154,   155,   156,   157,   780,   919,   920,
     781,   857,   366,   533,   367,   368,   921,   951,   873,   671,
     875,   876,   168,   880,   878,   882,   883,     1,   575,   885,
    1392,   653,   655,  1505,   782,   783,   784,   785,  1203,   251,
     659,  1105,     2,   673,   656,   675,   786,   209,   724,   159,
     160,  1518,  1450,   683,  1493,  1227,   210,  1454,  1455,  1456,
     517,   169,  1459,   361,   362,   677,   702,  1465,   132,   133,
    1044,  1045,     2,  1427,  1110,   138,   139,   140,   209,  1047,
     508,   921,   141,   987,   509,  1110,   363,   331,   787,   788,
     358,   636,     3,   727,  1000,  1297,   727,  1028,  1159,  1578,
    1579,  1007,    34,   948,   857,   796,     4,    35,   576,   857,
     959,   691,   857,   796,   796,   527,   857,  1163,   138,   139,
     140,   975,     3,   796,   789,   141,  1030,   517,   790,   577,
     578,   209,   161,  1091,   260,   671,     4,    14,   170,   244,
    1570,  1571,  1241,  1242,   692,   693,  1572,  1162,   952,  1529,
       1,  1191,   162,  1576,  1577,   694,  1539,  1241,  1242,   673,
    1542,   675,  1544,  1545,   670,  1243,   791,   792,   240,  1501,
     793,   695,     5,   436,    88,   438,   241,  1227,   840,   840,
    1243,   677,  1515,  1644,   579,  1046,   397,  1048,   672,   847,
     674,  1356,  1115,    90,   158,   398,  1351,   163,  1353,    91,
     159,   160,     5,  1603,   981,   159,   160,   982,   450,   863,
     676,  1166,  1167,   358,     1,   159,   160,   580,   581,   582,
     583,   584,   585,   586,   549,   550,  1357,    39,    40,   872,
    1232,  1233,   517,    95,   132,   133,   458,   134,   135,   136,
     137,   138,   139,   140,   587,   544,   545,   727,   141,   559,
     686,  1358,    96,  1234,   461,   397,  1156,   898,  1589,   159,
     160,  1592,   670,   754,   658,   151,   152,   153,   154,   155,
     156,   157,   450,   908,   908,   908,   908,   908,   908,   908,
     177,   209,   976,   796,   577,   578,   672,   737,   674,   857,
    1137,   738,    97,  1309,   796,  1612,   -13,  1311,  1615,   348,
     458,   305,  1310,   384,    98,   665,  1312,  1082,   676,   796,
     153,   154,   155,   156,   157,  1083,   180,   178,   461,  1361,
    1460,  1461,    99,   306,  1204,  1359,  1363,  1367,  1365,   -13,
     -13,   -13,  1205,   100,  1373,  1377,  1381,   307,   831,   579,
       1,   727,  1221,   668,   669,   988,   980,   173,   209,   994,
    1222,   289,   549,   550,  1357,   684,   -13,   685,  1013,  1014,
    1015,   549,   550,  1357,   857,   207,   355,  1022,  1023,   356,
     123,   124,   580,   581,   582,   583,   584,   585,   586,  1362,
    1508,   670,   671,  1508,  1404,  1508,   364,  1038,  1366,   365,
     101,  1410,   424,  1412,  1413,   425,   238,   893,   450,   587,
     894,  1364,  1368,   666,   667,   672,   673,   674,   675,  1374,
    1378,  1382,   608,   384,   727,   688,  1058,  1371,   727,   102,
    1232,  1233,   -13,   103,  1062,  1064,   458,   676,   677,  1067,
    1069,   151,   152,   153,   154,   155,   156,   157,  1068,  1070,
    1375,  1441,   104,  1234,   461,   618,   619,   620,   105,  1079,
     549,   550,  1357,  1379,   106,   -13,   -13,   -13,   796,   242,
    1383,   727,  1384,  1385,   107,  1101,  1102,  1103,   108,   727,
    1140,   975,   626,   549,   550,  1357,   109,  1372,  1111,  1112,
    1113,  1383,   -13,  1384,  1442,   110,   549,   550,  1357,  1122,
     243,  1124,  1125,  1127,   253,   893,  1052,  1136,  1051,  1053,
    1376,   159,   160,   414,   180,  1178,  1145,  1149,  1179,  1150,
    1151,  1401,  1403,  1380,   953,   384,  1154,   701,   636,   636,
    1624,  1626,   400,   401,  1129,   893,  1184,   953,  1198,   800,
     111,   801,   402,   403,   404,   405,   406,  1052,   254,  1228,
    1199,   407,  1229,   840,   840,   408,   409,   410,  1228,   893,
     112,  1231,  1249,   729,   113,   730,  1468,  1181,  1469,  1470,
     180,  1472,  1473,  1474,   114,  1476,  1477,  1478,  1250,   796,
    1252,  1251,   893,  1253,   115,  1257,   132,   133,   116,   134,
     135,   136,   137,   138,   139,   140,  1207,   246,   209,  1345,
     141,  1285,  1346,   796,  1212,   144,   145,   146,   796,   796,
     796,   796,   796,   796,   908,   117,   908,   908,   908,   921,
     908,  1554,  1352,   921,  1434,  1558,  1354,  1435,   729,  1562,
     732,  1110,   118,   804,  1563,   805,  1143,  1147,  1564,  1258,
     247,   808,  1565,   805,   816,  1110,   801,  1415,  1416,  1471,
    1235,  1266,   748,  1475,   749,   248,   903,  1479,   904,   990,
     796,   991,   249,  1484,  1278,  1279,   995,  1488,   996,   250,
     995,  1492,   998,   990,   255,  1002,  1288,  1289,  1451,   256,
    1292,  1293,   413,   415,  1184,  1296,   729,  1035,  1006,  1036,
     257,   132,   133,   258,   134,   135,   136,   137,   138,   139,
     140,  1531,  1532,   290,   291,   141,   648,   650,   142,   143,
     144,   145,   146,  1314,   729,  1609,  1099,   729,   180,  1158,
    1319,   729,  1165,  1160,   343,   384,   141,  1192,  1328,   636,
     384,   294,  1193,   796,   384,   796,  1194,   295,   729,  1331,
    1200,   296,   297,  1335,  1336,   729,   796,  1201,   299,   384,
    1235,  1246,   990,   796,  1298,   729,   300,  1299,   384,   384,
    1306,  1307,   301,   302,  1597,  1350,  1642,   990,  1598,  1426,
     303,  1428,  1599,  1429,   310,  1647,  1648,  1428,   311,  1526,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     323,  1527,  1541,  1528,   180,   180,   180,   384,  1405,  1551,
    1235,   384,   384,  1552,  1553,   384,   384,  1555,  1556,   384,
     384,  1557,  1559,   337,  1136,  1136,   384,   338,  1560,  1418,
    1136,  1235,   339,   384,  1421,  1561,   340,   342,  1424,  1235,
     384,   384,  1620,  1621,   384,   343,  1622,   345,   352,   439,
     796,  1414,   796,   796,   353,   313,   360,   357,   796,   400,
     401,   369,   388,   370,   796,   796,   796,   382,   386,   402,
     403,   404,   405,   406,   387,  1447,   389,   390,   407,   392,
     399,   420,   408,   409,   410,   423,  1449,   426,  1457,   422,
     427,   428,  1235,   147,   292,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   430,   433,   444,   439,   475,
     516,   476,   400,   401,   517,   796,   524,   523,   530,   536,
     293,   543,   402,   403,   404,   405,   406,   414,   558,   595,
    1498,   407,   538,   598,   796,   408,   409,   410,   640,   643,
     645,   180,   660,   646,   180,   661,   180,   662,   663,   680,
      36,   664,   689,   857,   857,   690,   705,   700,   706,   712,
     711,   734,   714,   716,  1235,   721,   722,   733,  1522,   735,
    1523,   741,   760,   756,   742,   743,   744,   769,   745,  1530,
     825,   746,   747,   828,   886,   796,    36,    37,    38,  1536,
     757,    39,    40,    41,   796,   796,   758,   759,   866,   767,
     845,   843,   846,   848,   849,   850,   851,   867,   864,  1549,
    1550,   868,   547,    42,    43,    44,   891,    45,   892,   897,
      46,    47,    48,   900,    49,    50,    51,    52,   132,   133,
     901,   134,   135,   136,   137,   138,   139,   140,   902,   916,
      53,   917,   141,    54,    55,   142,   143,   144,   145,   146,
     749,   930,   931,   932,   934,   935,   941,  1574,   942,     1,
     955,   985,   956,   957,   960,   966,  1235,   968,  1008,    56,
      57,   969,   970,  1009,  1016,  1020,   992,   997,  1021,  1024,
    1043,  1586,   999,    58,  1001,  -676,  -677,  -678,  1017,  1050,
    1593,  1594,  1066,  1049,    59,  1034,    60,  1071,  1081,    61,
    1090,    62,  1088,  1072,   132,   133,  1235,   134,   135,   136,
     137,   138,   139,   140,  1073,  1074,  1075,    63,   141,  1076,
    1077,  1606,  1607,   144,   145,   146,  1092,  1608,  1078,  1093,
    1100,  1098,  1106,  1108,  1114,  1118,    64,    65,  1119,  1123,
     801,    66,  1338,   805,  1152,  1172,  1173,  1174,    67,    68,
     132,   133,  1175,   134,   135,   136,   137,   138,   139,   140,
    1188,  1176,  1177,   887,   141,  1190,  1208,   142,   143,   144,
     145,   146,  1195,  1197,   587,  1210,  1247,  1211,  1641,  1223,
    1643,  1220,  1230,  1248,  1259,  1264,  1265,  1267,    69,    70,
      71,  1269,  1273,    72,    73,  1300,  1286,  1275,  1277,  1280,
      74,  -162,  1284,  1291,  -162,  1304,  1315,    75,    76,    77,
    1054,   887,    36,    37,    38,  1325,  1305,    39,    40,    41,
     147,  1308,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,  1329,  1330,  1337,  1386,  1342,  1348,   261,    42,
      43,    44,  1343,    45,  1344,  1347,    46,    47,    48,  1349,
      49,    50,    51,    52,  1387,  1389,  1094,  1430,  1390,  1417,
    1427,  1443,  1480,  1444,  1448,  1452,    53,  1453,  1458,    54,
      55,  1481,  1482,  1462,  1483,  1485,  1486,  1487,  1489,  1490,
    1491,  1495,  1516,  1496,  1499,  1517,  1533,  1534,  1535,  1538,
    1540,  1543,  1546,  1503,  1142,    56,    57,  1567,  1581,   149,
     150,   151,   152,   153,   154,   155,   156,   157,  1600,    58,
    1584,  1583,  1601,  1587,  1602,  1588,  1623,   987,  1590,  1591,
      59,  1604,    60,  1610,  1611,    61,  1613,    62,  1614,  1630,
    1618,  1619,    82,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
     477,  1639,   147,    63,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,  1640,  1087,    23,  1339,    32,   245,
     252,  1440,    64,    65,   896,   419,  1318,    66,  1524,  1130,
    1182,    36,    37,    38,    67,    68,    39,    40,    41,  1431,
     822,   877,   594,  1388,  1196,   417,   654,  1056,  1153,  1155,
     515,   809,  1582,   755,  1065,  1369,  1202,  1494,    42,    43,
      44,  1168,    45,   647,   644,    46,    47,    48,  1324,    49,
      50,    51,    52,   649,    69,    70,    71,     0,     0,    72,
      73,     0,     0,     0,     0,    53,    74,  -162,    54,    55,
    -162,   351,     0,    75,    76,    77,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    56,    57,   132,   133,     0,   134,
     135,   136,   137,   138,   139,   140,     0,     0,    58,     0,
     141,     0,     0,   142,   143,   144,   145,   146,     0,    59,
       0,    60,     0,     0,    61,     0,    62,     0,     0,     0,
    1131,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1132,     0,    63,     0,     0,     0,     0,     0,     0,     0,
    1130,     0,    36,    37,    38,     0,     0,    39,    40,    41,
       0,    64,    65,     0,     0,     0,    66,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,     0,     0,    42,
      43,    44,     0,    45,     0,     0,    46,    47,    48,     0,
      49,    50,    51,    52,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,     0,    69,    70,    71,     0,     0,    72,    73,
    1133,     0,     0,     0,     0,    74,     0,     0,     0,     0,
       0,     0,    75,    76,    77,    56,    57,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,    58,
       0,   141,     0,     0,   142,   143,   144,   145,   146,     0,
      59,     0,    60,     0,     0,    61,     0,    62,     0,     0,
       0,  1131,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1132,     0,    63,     0,     0,     0,     0,   147,     0,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
       0,     0,    64,    65,     0,     0,   262,    66,     0,  1506,
       0,    36,    37,    38,    67,    68,    39,    40,    41,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    42,    43,
      44,     0,    45,     0,     0,    46,    47,    48,     0,    49,
      50,    51,    52,     0,    69,    70,    71,     0,     0,    72,
      73,     0,     0,     0,     0,    53,    74,     0,    54,    55,
       0,     0,  1396,    75,    76,    77,     0,     0,     0,     0,
       0,     0,  1507,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    56,    57,   132,   133,     0,   134,
     135,   136,   137,   138,   139,   140,     0,     0,    58,     0,
     141,     0,     0,   142,   143,   144,   145,   146,     0,    59,
       0,    60,     0,     0,    61,     0,    62,     0,     0,   147,
     434,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,    63,     0,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,     0,   435,     0,   141,     0,
       0,    64,    65,   144,     0,     0,    66,     0,  1506,     0,
      36,    37,    38,    67,    68,    39,    40,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    42,    43,    44,
       0,    45,     0,     0,    46,    47,    48,     0,    49,    50,
      51,    52,     0,    69,    70,    71,     0,     0,    72,    73,
       0,     0,     0,     0,    53,    74,     0,    54,    55,     0,
       0,  1396,    75,    76,    77,     0,     0,     0,     0,     0,
       0,  1511,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    56,    57,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,    58,     0,   141,
       0,     0,   142,   143,   144,   145,   146,     0,    59,     0,
      60,     0,     0,    61,     0,    62,     0,     0,   147,     0,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
       0,    63,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   379,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,  1506,     0,    36,
      37,    38,    67,    68,    39,    40,    41,     0,     0,     0,
     150,   151,   152,   153,   154,   155,   156,   157,     0,     0,
       0,     0,     0,     0,     0,     0,    42,    43,    44,     0,
      45,     0,     0,    46,    47,    48,     0,    49,    50,    51,
      52,     0,    69,    70,    71,     0,     0,    72,    73,     0,
       0,     0,     0,    53,    74,     0,    54,    55,     0,     0,
    1396,    75,    76,    77,     0,     0,     0,     0,     0,     0,
    1513,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,    57,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,     0,    58,     0,   141,     0,
       0,   142,   143,   144,   145,   146,     0,    59,     0,    60,
       0,     0,    61,     0,    62,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
      63,     0,     0,     0,     0,     0,     0,     0,  1326,     0,
      36,    37,    38,     0,   380,    39,    40,    41,     0,    64,
      65,     0,     0,     0,    66,     0,     0,     0,     0,     0,
       0,    67,    68,     0,     0,     0,     0,    42,    43,    44,
       0,    45,     0,     0,    46,    47,    48,     0,    49,    50,
      51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
       0,    69,    70,    71,     0,     0,    72,    73,     0,     0,
       0,     0,     0,    74,     0,     0,     0,     0,     0,     0,
      75,    76,    77,    56,    57,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,    58,     0,   141,
       0,     0,   142,   143,   144,   145,   146,     0,    59,     0,
      60,     0,     0,    61,     0,    62,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    63,     0,     0,     0,     0,   147,     0,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,     0,     0,
      64,    65,     0,     0,   263,    66,     0,  1395,     0,    36,
      37,    38,    67,    68,    39,    40,    41,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    42,    43,    44,     0,
      45,     0,     0,    46,    47,    48,     0,    49,    50,    51,
      52,     0,    69,    70,    71,     0,     0,    72,    73,     0,
       0,     0,     0,    53,    74,     0,    54,    55,  1327,     0,
    1396,    75,    76,    77,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,    57,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,     0,    58,     0,   141,     0,
       0,   142,   143,   144,   145,   146,     0,    59,     0,    60,
       0,     0,    61,     0,    62,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
      63,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   381,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,  1400,     0,    36,    37,
      38,    67,    68,    39,    40,    41,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    42,    43,    44,     0,    45,
       0,     0,    46,    47,    48,     0,    49,    50,    51,    52,
       0,    69,    70,    71,     0,     0,    72,    73,     0,     0,
       0,     0,    53,    74,     0,    54,    55,     0,     0,  1396,
      75,    76,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    56,    57,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,    58,     0,   141,     0,     0,
     142,   143,   144,   145,   146,     0,    59,     0,    60,     0,
       0,    61,     0,    62,     0,     0,   147,     0,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,     0,    63,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   657,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,  1402,     0,    36,    37,    38,
      67,    68,    39,    40,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,    43,    44,     0,    45,     0,
       0,    46,    47,    48,     0,    49,    50,    51,    52,     0,
      69,    70,    71,     0,     0,    72,    73,     0,     0,     0,
       0,    53,    74,     0,    54,    55,     0,     0,  1396,    75,
      76,    77,     0,     0,     0,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
      56,    57,   142,   143,   144,   145,   146,     0,     0,     0,
       0,     0,     0,     0,    58,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    59,     0,    60,     0,     0,
      61,     0,    62,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,    63,     0,
       0,     0,     0,     0,     0,     0,   395,     0,    36,    37,
      38,     0,  1171,    39,    40,    41,     0,    64,    65,     0,
       0,     0,    66,     0,     0,     0,     0,     0,     0,    67,
      68,     0,     0,     0,     0,    42,    43,    44,     0,    45,
       0,     0,    46,    47,    48,     0,    49,    50,    51,    52,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,    54,    55,     0,     0,    69,
      70,    71,     0,     0,    72,    73,     0,     0,     0,     0,
       0,    74,     0,     0,     0,     0,     0,     0,    75,    76,
      77,    56,    57,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    58,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    59,     0,    60,     0,
       0,    61,     0,    62,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,    63,
       0,     0,     0,     0,     0,   264,     0,  1086,     0,    36,
      37,    38,     0,     0,    39,    40,    41,     0,    64,    65,
       0,     0,     0,    66,     0,     0,     0,     0,     0,     0,
      67,    68,     0,     0,     0,     0,    42,    43,    44,     0,
      45,     0,     0,    46,    47,    48,     0,    49,    50,    51,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,     0,
      69,    70,    71,     0,     0,    72,    73,     0,     0,     0,
       0,     0,    74,     0,     0,     0,     0,     0,     0,    75,
      76,    77,    56,    57,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,     0,    58,     0,   141,     0,
       0,   142,   143,   144,   145,   146,     0,    59,     0,    60,
       0,     0,    61,     0,    62,     0,     0,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
      63,   141,     0,     0,   142,   143,   144,   145,   146,     0,
      36,    37,    38,     0,     0,    39,    40,    41,     0,    64,
      65,     0,     0,     0,    66,     0,     0,     0,     0,     0,
       0,    67,    68,     0,     0,     0,     0,    42,    43,    44,
       0,    45,     0,     0,    46,    47,    48,     0,    49,    50,
      51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
       0,    69,    70,    71,     0,     0,    72,    73,     0,     0,
       0,     0,     0,    74,     0,     0,     0,     0,     0,     0,
      75,    76,    77,    56,    57,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,    58,     0,   141,
       0,     0,   142,   143,   144,   145,   146,     0,    59,     0,
      60,     0,     0,    61,     0,    62,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    63,     0,     0,     0,     0,   147,     0,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,     0,     0,
      64,    65,     0,     0,   265,    66,     0,  1121,     0,    36,
      37,    38,    67,    68,    39,    40,    41,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,     0,    42,    43,    44,     0,
      45,     0,     0,    46,    47,    48,  1521,    49,    50,    51,
      52,     0,    69,    70,    71,     0,     0,    72,    73,     0,
       0,     0,     0,    53,    74,     0,    54,    55,     0,     0,
       0,    75,    76,    77,     0,  1094,     0,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,    56,    57,   142,   143,   144,   145,   146,     0,
       0,     0,     0,     0,     0,     0,    58,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    59,     0,    60,
       0,     0,    61,     0,    62,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
      63,     0,     0,     0,     0,     0,     0,     0,  1126,     0,
      36,    37,    38,     0,  1580,    39,    40,    41,     0,    64,
      65,     0,     0,     0,    66,     0,     0,     0,     0,     0,
       0,    67,    68,     0,     0,     0,     0,    42,    43,    44,
       0,    45,     0,     0,    46,    47,    48,     0,    49,    50,
      51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
       0,    69,    70,    71,     0,     0,    72,    73,     0,     0,
       0,     0,     0,    74,     0,     0,     0,     0,     0,     0,
      75,    76,    77,    56,    57,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    59,     0,
      60,     0,     0,    61,     0,    62,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,    63,     0,     0,     0,     0,     0,   266,     0,  1573,
       0,    36,    37,    38,     0,     0,    39,    40,    41,     0,
      64,    65,     0,     0,     0,    66,     0,     0,     0,     0,
       0,     0,    67,    68,     0,     0,     0,     0,    42,    43,
      44,     0,    45,     0,     0,    46,    47,    48,     0,    49,
      50,    51,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,     0,    69,    70,    71,     0,     0,    72,    73,     0,
       0,     0,     0,     0,    74,     0,     0,     0,     0,     0,
       0,    75,    76,    77,    56,    57,     0,     0,   772,     0,
      36,   773,     0,     0,     0,     0,     0,     0,    58,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    59,
       0,    60,     0,     1,    61,     0,    62,     0,     0,     0,
     774,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    63,     0,     0,   775,   776,     0,     0,     0,
       0,   777,   778,   779,     0,     0,     0,     0,     0,     0,
     780,    64,    65,   781,     0,     0,    66,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,     0,     0,     0,
       0,   450,     0,     0,     0,     0,     0,   782,   783,   784,
     785,     0,     0,     0,     0,     0,     0,     0,     0,   786,
       0,     0,     0,  1232,  1233,   -13,     0,     0,     0,   458,
       0,     0,     0,    69,    70,    71,     0,     0,    72,    73,
       0,     0,     0,     0,     0,    74,  1234,   461,     0,     0,
       0,     0,    75,    76,    77,     0,     0,     0,   -13,   -13,
     -13,   787,   788,     0,     0,     0,   120,     0,    36,    37,
      38,     0,     0,    39,    40,    41,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   -13,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   789,     0,    45,
       0,   790,    46,    47,    48,     0,    49,    50,    51,    52,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,    54,    55,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
     792,     0,     0,   793,     0,     0,     0,     0,     0,     0,
       0,    56,    57,   128,     0,    36,    37,    38,     0,     0,
      39,    40,    41,     0,     0,    58,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    59,     0,    60,     0,
       0,    61,     0,    62,     0,     0,    45,     0,     0,    46,
      47,    48,     0,    49,    50,    51,    52,     0,     0,    63,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,     0,     0,     0,     0,
      67,    68,     0,     0,     0,     0,     0,     0,    56,    57,
       0,     0,   772,     0,    36,   773,     0,     0,     0,     0,
       0,     0,    58,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    59,     0,    60,     0,     0,    61,     0,
      62,     0,     0,     0,   774,     0,     0,     0,     0,     0,
       0,     0,    74,     0,     0,     0,    63,     0,     0,   775,
     776,    77,     0,     0,     0,   777,   778,   779,   772,     0,
      36,   773,     0,     0,   780,    64,    65,   781,     0,     0,
      66,     0,     0,     0,     0,     0,     0,    67,    68,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     774,   782,   783,   784,   785,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,   775,   776,     0,     0,     0,
     963,   777,   778,   779,     0,     0,     0,     0,     0,     0,
     780,     0,     0,   781,   772,     0,    36,   773,     0,    74,
       0,     0,     0,     0,     0,     0,     0,     0,    77,     0,
       0,     0,     0,     0,     0,   787,   788,   782,   783,   784,
     785,     0,     0,     0,     0,     0,   774,     0,     0,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   775,   776,     0,     0,     0,     0,   777,   778,   779,
       0,   789,     0,     0,     0,   790,   780,     0,     0,   781,
       0,     0,     0,     0,     0,     0,     0,   772,     0,    36,
     773,   787,   788,     0,     0,   964,     0,     0,     0,     0,
       0,     0,     0,   782,   783,   784,   785,     0,     0,     0,
       0,     0,     0,   791,   792,   786,     0,   793,     0,   774,
       0,     0,     0,     0,     0,     0,     0,   789,     0,     0,
       0,   790,     0,     0,   775,   776,   772,     0,    36,   773,
     777,   778,   779,     0,     0,     0,     0,     0,     0,   780,
       0,  1504,   781,     0,     0,     0,     0,   787,   788,  1109,
       0,     0,     0,     0,     0,     0,     0,   977,   774,   791,
     792,     0,     0,   793,     0,     0,   782,   783,   784,   785,
       0,     0,     0,   775,   776,     0,     0,     0,   786,   777,
     778,   779,     0,   789,     0,     0,     0,   790,   780,     0,
     772,   781,    36,   773,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   782,   783,   784,   785,     0,
     787,   788,   774,   977,     0,   791,   792,   786,     0,   793,
       0,     0,     0,     0,  1120,     0,     0,   775,   776,     0,
       0,     0,     0,   777,   778,   779,     0,     0,     0,     0,
       0,     0,   780,     0,     0,   781,   789,     0,     0,     0,
     790,     0,  1569,   772,     0,    36,   773,     0,     0,   787,
     788,     0,     0,     0,     0,     0,     0,     0,     0,   782,
     783,   784,   785,     0,     0,     0,     0,     0,     0,     0,
       0,   786,     0,     0,     0,   774,     0,     0,   791,   792,
       0,     0,   793,     0,     0,   789,     0,     0,     0,   790,
     775,   776,   772,     0,    36,   773,   777,   778,   779,     0,
       0,     0,     0,     0,     0,   780,     0,     0,   781,     0,
       0,     0,     0,   787,   788,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   774,     0,     0,   791,   792,     0,
       0,   793,   782,   783,   784,   785,     0,     0,     0,   775,
     776,     0,     0,     0,   786,   777,   778,   779,     0,   789,
       0,  1575,     0,   790,   780,     0,     0,   781,   132,   133,
       0,   134,   135,   136,   137,   138,   139,   140,     0,     0,
       0,     0,   141,     0,     0,   142,   143,   144,   145,   146,
       0,   782,   783,   784,   785,     0,   787,   788,     0,     0,
       0,   791,   792,   786,     0,   793,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,    37,    38,     0,     0,    39,    40,    41,
       0,     0,   789,     0,     0,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,   787,   788,     0,     0,    42,
      43,    44,     0,    45,     0,     0,    46,    47,    48,     0,
      49,    50,    51,    52,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,   792,    53,     0,   793,    54,
      55,   789,     0,     0,     0,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    56,    57,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   668,   669,    58,
       0,     0,     0,   791,   792,     0,     0,   793,     0,     0,
      59,     0,    60,     0,     0,    61,     0,    62,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    63,     0,   670,   671,     0,     0,     0,
     147,     0,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,    64,    65,     0,     0,     0,    66,     0,   672,
     673,   674,   675,   208,    67,    68,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   676,   677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    69,    70,    71,     0,     0,    72,
      73,     0,    36,    37,    38,     0,    74,    39,    40,    41,
       0,     0,     0,    75,    76,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    42,
      43,    44,     0,    45,     0,     0,    46,    47,    48,     0,
      49,    50,    51,    52,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     132,   133,     0,   134,   135,   136,   137,   138,   139,   140,
       0,     0,     0,     0,   141,    56,    57,   142,   143,   144,
     145,   146,     0,     0,     0,     0,     0,     0,     0,    58,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      59,     0,    60,     0,     0,    61,     0,    62,     0,     0,
     132,   133,     0,   134,   135,   136,   137,   138,   139,   140,
       0,     0,     0,    63,   141,   670,     0,   142,   143,   144,
     145,   146,     0,     0,    36,    37,    38,     0,     0,    39,
      40,    41,    64,    65,     0,     0,     0,    66,     0,   672,
       0,   674,     0,     0,    67,    68,     0,     0,     0,     0,
       0,    42,    43,    44,     0,    45,     0,     0,    46,    47,
      48,   676,    49,    50,    51,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,    69,    70,    71,     0,     0,    72,
      73,     0,     0,     0,     0,     0,    74,     0,     0,     0,
       0,     0,     0,    75,    76,    77,     0,    56,    57,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,    58,     0,   141,     0,     0,   142,   143,   144,   145,
     146,     0,    59,     0,    60,     0,     0,    61,     0,    62,
       0,     0,   147,     0,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,     0,    63,     0,     0,   671,     0,
     267,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    64,    65,     0,     0,     0,    66,
       0,     0,   673,     0,   675,     0,    67,    68,     0,     0,
       0,     0,   147,     0,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   677,     0,     0,     0,     0,     0,
     269,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,    70,    71,     0,
       0,    72,    73,     0,    36,    37,    38,     0,    74,    39,
      40,    41,     0,     0,     0,    75,    76,    77,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,    43,    44,     0,    45,     0,     0,    46,    47,
      48,     0,    49,    50,    51,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,    56,    57,   270,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    58,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    59,     0,    60,     0,     0,    61,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    63,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1141,     0,     0,     0,
       0,     0,     0,     0,    64,    65,    36,    37,    38,    66,
       0,    39,    40,    41,     0,     0,    67,    68,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,    43,    44,     0,    45,     0,     0,
      46,    47,    48,     0,    49,    50,    51,    52,     0,     0,
       0,     0,     0,     0,     0,     0,    69,    70,    71,     0,
      53,    72,    73,    54,    55,     0,     0,     0,    74,     0,
       0,     0,     0,   791,  1142,    75,    76,    77,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    56,
      57,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    58,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    59,     0,    60,     0,     0,    61,
       0,    62,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    63,     0,     0,
       0,     0,   478,   651,     0,     0,     0,     0,  1146,   479,
       0,   480,     0,   481,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,     0,     0,     0,     0,    67,    68,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,    70,
      71,     0,     0,    72,    73,     0,    36,    37,    38,     0,
      74,    39,    40,    41,     0,   791,  1142,    75,    76,    77,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,    43,    44,     0,    45,     0,     0,
      46,    47,    48,     0,    49,    50,    51,    52,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      53,     0,     0,    54,    55,     0,     0,  1183,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1317,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    56,
      57,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    58,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    59,     0,    60,     0,     0,    61,
       0,    62,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    63,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    37,    38,
       0,     0,    39,    40,    41,     0,    64,    65,     0,     0,
       0,    66,     0,     0,     0,     0,     0,     0,    67,    68,
       0,     0,     0,     0,    42,    43,    44,     0,    45,     0,
       0,    46,    47,    48,     0,    49,    50,    51,    52,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    53,     0,     0,    54,    55,     0,     0,    69,    70,
      71,     0,     0,    72,    73,     0,     0,     0,     0,     0,
      74,     0,     0,     0,     0,     0,     0,    75,    76,    77,
      56,    57,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    58,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    59,     0,    60,     0,     0,
      61,     0,    62,     0,     0,     0,  1131,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1132,     0,    63,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,    37,
      38,     0,     0,    39,    40,    41,     0,    64,    65,     0,
       0,     0,    66,     0,     0,     0,     0,     0,     0,    67,
      68,     0,     0,     0,     0,    42,    43,    44,     0,    45,
       0,     0,    46,    47,    48,     0,    49,    50,    51,    52,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,    54,    55,     0,     0,    69,
      70,    71,     0,     0,    72,    73,     0,     0,     0,     0,
       0,    74,     0,     0,     0,     0,     0,     0,    75,    76,
      77,    56,    57,     0,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,    58,     0,     0,   141,   837,
       0,   142,   143,   144,   145,   146,    59,     0,    60,     0,
       0,    61,     0,    62,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,     0,     0,     0,   141,    63,
       0,   142,   143,   144,   145,   146,     0,     0,     0,    36,
      37,    38,     0,     0,    39,    40,    41,     0,    64,    65,
       0,     0,     0,    66,     0,     0,     0,     0,   508,     0,
      67,    68,   509,     0,     0,     0,    42,    43,    44,     0,
      45,     0,     0,    46,    47,    48,     0,    49,    50,    51,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,     0,
      69,    70,    71,     0,     0,   838,   839,     0,     0,     0,
       0,     0,    74,     0,     0,     0,     0,     0,     0,    75,
      76,    77,    56,    57,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    58,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    59,     0,    60,
       0,     0,    61,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      63,     0,     0,     0,     0,     0,   147,     0,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,     0,    64,
      65,    36,    37,    38,    66,     0,    39,    40,    41,     0,
       0,    67,    68,     0,     0,     0,   147,     0,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,    42,    43,
      44,     0,    45,     0,   271,    46,    47,    48,     0,    49,
      50,    51,    52,     0,     0,     0,     0,     0,     0,     0,
       0,    69,    70,    71,     0,    53,    72,    73,    54,    55,
       0,     0,  1183,    74,     0,     0,     0,  1139,     0,     0,
      75,    76,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    56,    57,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    58,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    59,
       0,    60,     0,     0,    61,     0,    62,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    63,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,    37,    38,     0,     0,    39,    40,    41,
       0,    64,    65,     0,     0,     0,    66,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,     0,     0,    42,
      43,    44,     0,    45,     0,     0,    46,    47,    48,     0,
      49,    50,    51,    52,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,     0,    69,    70,    71,     0,     0,    72,    73,
       0,     0,     0,     0,     0,    74,     0,     0,     0,     0,
       0,     0,    75,    76,    77,    56,    57,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    58,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      59,     0,    60,     0,     0,    61,     0,    62,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    63,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,    37,    38,     0,     0,    39,    40,
      41,     0,    64,    65,     0,     0,     0,    66,     0,     0,
       0,     0,     0,     0,    67,    68,     0,     0,     0,     0,
      42,    43,    44,     0,    45,     0,     0,    46,    47,    48,
       0,    49,    50,    51,    52,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    53,     0,     0,
      54,    55,     0,     0,    69,    70,    71,     0,     0,    72,
      73,     0,     0,     0,     0,     0,    74,     0,     0,     0,
    1497,     0,     0,    75,    76,    77,    56,    57,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      58,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    59,     0,    60,     0,     0,    61,     0,    62,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    63,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    36,    37,    38,     0,     0,    39,
      40,    41,     0,    64,    65,     0,     0,     0,    66,     0,
       0,     0,     0,     0,     0,    67,    68,     0,     0,     0,
       0,    42,    43,    44,     0,    45,     0,     0,    46,    47,
      48,     0,    49,    50,    51,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,     0,    69,    70,    71,     0,     0,
      72,    73,     0,     0,     0,     0,     0,    74,     0,     0,
       0,     0,     0,     0,    75,    76,    77,    56,    57,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    58,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    59,     0,    60,     0,     0,    61,     0,    62,
       0,     0,   132,   133,     0,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,    63,   141,     0,     0,     0,
     143,   144,   145,   146,     0,    36,    37,    38,     0,     0,
      39,    40,    41,     0,    64,    65,     0,     0,     0,    66,
       0,     0,     0,     0,     0,     0,    67,    68,     0,     0,
       0,     0,    42,    43,    44,     0,    45,     0,     0,    46,
      47,    48,     0,    49,    50,    51,    52,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,     0,    69,    70,    71,     0,
       0,    72,    73,     0,     0,     0,     0,     0,  1063,     0,
       0,     0,     0,     0,     0,    75,    76,    77,    56,    57,
       0,    36,    37,    38,     0,     0,    39,    40,    41,     0,
       0,     0,    58,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    59,     0,    60,     0,     0,    61,     0,
      62,     0,    45,     0,     0,    46,    47,    48,     0,    49,
      50,    51,    52,     0,     0,     0,    63,     0,     0,     0,
       0,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,     0,     0,     0,     0,    64,    65,   905,     0,     0,
      66,     0,     0,     0,     0,     0,     0,    67,    68,     0,
       0,     0,     0,     0,    56,    57,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,     0,     0,    58,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    59,
       0,    60,     0,     0,    61,     0,    62,    69,    70,    71,
     906,     0,    72,    73,     0,     0,     0,     0,     0,     0,
     907,     0,    63,     0,     0,     0,    75,    76,    77,    36,
      37,    38,     0,     0,    39,    40,    41,     0,     0,     0,
       0,    64,    65,     0,     0,     0,    66,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,     0,     0,     0,
      45,     0,     0,    46,    47,    48,     0,    49,    50,    51,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    74,     0,     0,     0,     0,
       0,     0,    56,    57,    77,    36,    37,    38,     0,     0,
      39,    40,    41,     0,     0,     0,    58,     0,     0,     0,
    1018,     0,     0,     0,     0,     0,     0,    59,     0,    60,
       0,     0,    61,     0,    62,     0,    45,     0,     0,    46,
      47,    48,     0,    49,    50,    51,    52,     0,     0,     0,
      63,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,     0,     0,     0,
       0,    67,    68,     0,     0,     0,     0,     0,    56,    57,
      36,    37,    38,     0,     0,    39,    40,    41,     0,     0,
       0,     0,    58,     0,     0,     0,  1019,     0,     0,     0,
       0,     0,     0,    59,     0,    60,     0,     0,    61,     0,
      62,    45,     0,     0,    46,    47,    48,     0,    49,    50,
      51,    52,     0,    74,     0,     0,    63,     0,     0,     0,
       0,     0,    77,     0,    53,     0,     0,    54,    55,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,     0,     0,     0,     0,    67,    68,     0,
       0,     0,     0,    56,    57,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    59,     0,
      60,     0,     0,    61,     0,    62,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    74,
       0,    63,   445,     0,   -13,     0,     0,   446,    77,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     1,     0,     0,
       0,     0,    67,    68,     0,     0,     0,     0,     0,     0,
       0,   -13,     0,     0,     0,     0,     0,   -13,   -13,   447,
     634,     0,   -13,   -13,   -13,   448,     0,     0,     0,   -13,
       0,     0,     0,     0,     0,     0,   449,     0,     0,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,    74,   450,   142,   143,   144,   145,
     146,   451,     0,    77,     0,   452,   453,   454,     0,     0,
       0,     0,     0,   455,     0,     0,   -13,   456,   457,   -13,
       0,     0,     0,   458,     0,     0,     0,     0,     0,     0,
     459,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,   -13,
     460,   461,   -13,     0,     0,     0,     0,     0,     0,   462,
     463,   -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,
     -13,   -13,     0,     0,     0,     0,     0,   464,     0,     0,
       0,     0,     0,   -13,   -13,     0,     0,     0,   465,   -13,
     -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   466,     0,
       0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,   -13,
     -13,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,   467,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,     0,     0,     0,     0,     0,     0,   132,
     133,   635,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,   132,   133,   272,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,     0,
       0,   273,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,   132,   133,   275,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,     0,     0,   276,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,     0,     0,   280,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,     0,
       0,   281,     0,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,   132,   133,   282,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,   132,   133,   283,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,     0,
       0,   284,     0,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,     0,     0,   371,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,   132,   133,   372,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,     0,   373,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,     0,     0,   374,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,     0,     0,   375,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,   132,
     133,   861,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,   132,   133,   869,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,     0,     0,  1060,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,     0,
       0,  1261,     0,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,   132,   133,  1262,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,     0,
       0,  1263,     0,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,     0,     0,  1270,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,     0,  1271,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,   132,   133,  1272,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,   132,
     133,  1274,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,     0,  1445,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,     0,     0,  1519,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,   132,   133,  1520,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,     0,     0,  1537,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,     0,
       0,  1568,     0,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,     0,     0,  1595,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,   132,   133,  1596,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,   132,   133,  1616,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,     0,     0,  1617,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,     0,  1629,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,   132,   133,  1645,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,     0,  1646,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,     0,   336,     0,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,   132,   133,
    1187,   134,   135,   136,   137,   138,   139,   140,     0,     0,
       0,     0,   141,     0,     0,   142,   143,   144,   145,   146,
     132,   133,     0,   134,   135,   136,   137,   138,   139,   140,
       0,     0,     0,     0,   141,     0,     0,   142,   143,   144,
     145,   146,   132,   133,     0,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   141,     0,     0,   142,
     143,   144,   145,   146,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,   132,   133,  1254,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   141,     0,     0,   142,
     143,   144,   145,   146,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,     0,     0,     0,   141,     0,
       0,   142,   143,   144,   145,   146,   132,   133,     0,   134,
     135,   136,   137,   138,   139,   140,     0,     0,     0,     0,
     141,     0,     0,   142,   143,   144,   145,   146,   132,   133,
       0,   134,   135,   136,   137,   138,   139,   140,     0,     0,
       0,     0,   141,     0,     0,   142,   143,   144,   145,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     147,     0,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,     0,     0,     0,     0,     0,  1255,     0,     0,
       0,     0,   147,     0,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,     0,     0,     0,     0,     0,  1256,
       0,     0,     0,     0,   147,     0,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,     0,     0,     0,   132,
     133,  1290,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,     0,     0,     0,   147,     0,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,     0,     0,     0,     0,
       0,  1294,     0,     0,     0,     0,   147,     0,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,     0,     0,
       0,     0,     0,  1391,     0,     0,     0,     0,   147,     0,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
       0,     0,     0,     0,     0,  1406,     0,     0,     0,     0,
     147,     0,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,     0,     0,     0,   132,   133,  1419,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,   132,   133,  1420,   134,
     135,   136,   137,   138,   139,   140,     0,     0,     0,     0,
     141,     0,     0,   142,   143,   144,   145,   146,   132,   133,
       0,   134,   135,   136,   137,   138,   139,   140,     0,     0,
       0,     0,   141,     0,     0,   142,   143,   144,   145,   146,
     132,   133,     0,   134,   135,   136,   137,   138,   139,   140,
       0,     0,     0,     0,   141,     0,     0,   142,   143,   144,
     145,   146,   132,   133,     0,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   141,     0,     0,   142,
     143,   144,   145,   146,     0,     0,     0,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,  1422,     0,     0,     0,     0,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,   132,   133,  1439,   134,
     135,   136,   137,   138,   139,   140,     0,     0,     0,     0,
     141,     0,     0,   142,   143,   144,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   147,     0,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
       0,     0,     0,     0,     0,  1514,     0,     0,     0,     0,
     147,     0,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,     0,     0,     0,     0,     0,  1605,     0,     0,
       0,     0,   147,     0,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,     0,     0,     0,     0,     0,  1627,
       0,     0,     0,     0,   147,     0,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,     0,     0,     0,   132,
     133,  1628,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,     0,     0,     0,   147,   206,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
       0,   132,   133,  1332,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   132,   133,
       0,   134,   135,   136,   137,   138,   139,   140,     0,     0,
       0,     0,   141,     0,     0,   142,   143,   144,   145,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,   268,     0,     0,     0,
       0,     0,     0,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,   274,     0,
       0,     0,     0,     0,     0,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
     277,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   445,
       0,   -13,     0,   147,   446,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,   278,     0,
       0,     0,     0,     0,     1,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,   -13,     0,
     279,     0,     0,     0,   -13,   -13,   447,     0,     0,   -13,
     -13,   -13,   448,     0,     0,     0,   -13,     0,     0,     0,
       0,     0,     0,   449,     0,     0,     0,     0,     0,     0,
     147,  -354,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   450,     0,     0,     0,     0,     0,   451,     0,
       0,     0,   452,   453,   454,     0,     0,     0,     0,     0,
     455,     0,     0,   -13,   456,   457,   -13,     0,     0,     0,
     458,     0,     0,     0,     0,     0,     0,   459,   -13,     0,
       0,   -13,   -13,   -13,   -13,   -13,   -13,   460,   461,   -13,
       0,     0,     0,     0,     0,     0,   462,   463,   -13,   -13,
     -13,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,     0,
       0,     0,     0,     0,   464,     0,     0,     0,     0,     0,
     -13,   -13,     0,     0,     0,   465,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,   -13,   -13,   466,   445,     0,   -13,   -13,
       0,   446,     0,   -13,   -13,   -13,   -13,   -13,     0,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   467,
       0,     1,   698,   141,     0,     0,   142,   143,   144,   145,
     146,     0,     0,     0,     0,   -13,     0,     0,     0,     0,
       0,   -13,   -13,   447,     0,     0,   -13,   -13,   -13,   448,
       0,     0,     0,   -13,     0,     0,     0,     0,     0,     0,
     449,     0,     0,     0,     0,     0,     0,     0,  -354,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   450,
       0,     0,     0,     0,     0,   451,     0,     0,     0,   452,
     453,   454,     0,     0,     0,     0,     0,   455,     0,     0,
     -13,   456,   457,   -13,     0,     0,     0,   458,     0,     0,
       0,     0,     0,     0,   459,   -13,     0,     0,   -13,   -13,
     -13,   -13,   -13,   -13,   460,   461,   -13,     0,     0,     0,
       0,     0,     0,   462,   463,   -13,   -13,   -13,   -13,     0,
       0,   -13,   -13,   -13,   -13,   -13,     0,     0,     0,     0,
       0,   464,     0,     0,     0,     0,     0,   -13,   -13,     0,
       0,     0,   465,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   466,     0,     0,     0,   -13,     0,     0,     0,
     -13,   -13,   -13,   -13,   -13,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   467,     0,     0,   823,
       0,   147,   206,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,   132,
     133,     0,   134,   135,   136,   137,   138,   139,   140,     0,
       0,     0,     0,   141,     0,     0,   142,   143,   144,   145,
     146,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,     0,     0,   142,   143,
     144,   145,   146,   132,   133,     0,   134,   135,   136,   137,
     138,   139,   140,     0,     0,     0,     0,   141,     0,     0,
     142,   143,   144,   145,   146,   132,   133,     0,   134,   135,
     136,   137,   138,   139,   140,     0,     0,     0,     0,   141,
       0,     0,   142,   143,   144,   145,   146,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,     0,     0,     0,
       0,   141,     0,     0,   142,   143,   144,   145,   146,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,   288,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,   330,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
     844,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,  1180,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,  1206,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,  1295,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,  1425,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
    1436,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,   478,   829,   142,   143,
     144,   145,   146,   479,     0,   480,     0,   481,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   478,   830,     0,     0,     0,     0,     0,
     479,     0,   480,     0,   481,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     478,     0,     0,     0,     0,     0,     0,   479,   831,   480,
       0,   481,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   832,   833,
     834,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   445,     0,   -13,     0,
       0,   446,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     0,   147,  1446,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   -13,     0,     0,     0,     0,
       0,   -13,   -13,   447,     0,     0,   -13,   -13,   -13,   448,
       0,     0,     0,   -13,     0,     0,     0,     0,     0,     0,
     449,     0,     0,     0,     0,     0,     0,     0,  -353,     0,
       0,     0,  -353,  -353,     0,     0,     0,     0,     0,   450,
       0,     0,     0,     0,     0,   451,     0,     0,     0,   452,
     453,   454,     0,     0,     0,     0,     0,   455,     0,     0,
     -13,   456,   457,   -13,     0,     0,     0,   458,     0,     0,
       0,     0,     0,     0,   459,   -13,     0,     0,   -13,   -13,
     -13,   -13,   -13,   -13,   460,   461,   -13,     0,     0,     0,
       0,     0,     0,   462,   463,   -13,   -13,   -13,   -13,     0,
       0,   -13,   -13,   -13,   -13,   -13,     0,     0,     0,     0,
       0,   464,     0,     0,   445,     0,   -13,   -13,   -13,   446,
       0,     0,   465,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   466,     0,     0,     0,   -13,     0,     0,     1,
     -13,   -13,   -13,   -13,   -13,     0,     0,     0,     0,     0,
       0,     0,     0,   -13,     0,     0,   467,     0,     0,   -13,
     -13,   447,   540,     0,   -13,   -13,   -13,   448,     0,     0,
       0,   -13,     0,     0,     0,     0,     0,     0,   449,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -354,     0,     0,     0,     0,     0,     0,   450,     0,     0,
       0,     0,     0,   451,     0,     0,     0,   452,   453,   454,
       0,     0,     0,     0,     0,   455,     0,     0,   -13,   456,
     457,   -13,     0,     0,     0,   458,     0,     0,     0,     0,
       0,     0,   459,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,   -13,   460,   461,   -13,     0,     0,     0,     0,     0,
       0,   462,   463,   -13,   -13,   -13,   -13,     0,     0,   -13,
     -13,   -13,   -13,   -13,     0,     0,   445,     0,   -13,   464,
       0,   446,     0,     0,     0,   -13,   -13,     0,     0,     0,
     465,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     466,     1,     0,     0,   -13,     0,     0,     0,   -13,   -13,
     -13,   -13,   -13,     0,     0,   -13,     0,     0,     0,     0,
       0,   -13,   -13,   447,   467,     0,   -13,   -13,   -13,   448,
       0,     0,     0,   -13,     0,     0,     0,     0,     0,     0,
     449,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -354,     0,     0,     0,     0,     0,   450,
       0,     0,     0,     0,     0,   451,     0,     0,     0,   452,
     453,   454,     0,     0,     0,     0,     0,   455,     0,     0,
     -13,   456,   457,   -13,     0,     0,     0,   458,     0,     0,
       0,     0,     0,     0,   459,   -13,     0,     0,   -13,   -13,
     -13,   -13,   -13,   -13,   460,   461,   -13,     0,     0,     0,
       0,     0,     0,   462,   463,   -13,   -13,   -13,   -13,     0,
       0,   -13,   -13,   -13,   -13,   -13,     0,     0,   445,     0,
     -13,   464,     0,   446,     0,     0,     0,   -13,   -13,     0,
       0,     0,   465,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   466,     1,     0,     0,   -13,     0,     0,     0,
     -13,   -13,   -13,   -13,   -13,     0,     0,   -13,     0,     0,
       0,     0,     0,   -13,   -13,   447,   467,     0,   -13,   -13,
     -13,   448,     0,     0,     0,   -13,     0,     0,     0,     0,
       0,     0,   449,     0,     0,     0,     0,     0,     0,     0,
    -354,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   450,     0,     0,     0,     0,     0,   451,     0,     0,
       0,   452,   453,   454,     0,     0,     0,     0,     0,   455,
       0,     0,   -13,   456,   457,   -13,     0,     0,     0,   458,
       0,     0,     0,     0,     0,     0,   459,   -13,     0,     0,
     -13,   -13,   -13,   -13,   -13,   -13,   460,   461,   -13,     0,
       0,     0,     0,     0,     0,   462,   463,   -13,   -13,   -13,
     -13,     0,     0,   -13,   -13,   -13,   -13,   -13,     0,     0,
       0,     0,     0,   464,     0,     0,   445,     0,   -13,   -13,
     -13,   446,     0,     0,   465,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,   -13,   466,     0,     0,     0,   -13,     0,
       0,     1,   -13,   -13,   -13,   -13,   -13,     0,     0,     0,
       0,     0,     0,     0,     0,   -13,     0,     0,   467,     0,
       0,   -13,   -13,   447,   634,     0,   -13,   -13,   -13,   448,
       0,     0,     0,   -13,     0,     0,     0,     0,     0,     0,
     449,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   450,
       0,     0,     0,     0,     0,   451,     0,     0,     0,   452,
     453,   454,     0,     0,     0,     0,     0,   455,     0,     0,
     -13,   456,   457,   -13,     0,     0,     0,   458,     0,     0,
       0,     0,     0,     0,   459,   -13,     0,     0,   -13,   -13,
     -13,   -13,   -13,   -13,   460,   461,   -13,     0,     0,     0,
       0,     0,     0,   462,   463,   -13,   -13,   -13,   -13,     0,
       0,   -13,   -13,   -13,   -13,   -13,     0,     0,     0,   599,
       0,   464,     0,     0,     0,     0,     0,   -13,   -13,     0,
       0,     0,   465,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   466,     0,     0,     0,   -13,     0,   478,     0,
     -13,   -13,   -13,   -13,   -13,   479,   600,   480,     0,   481,
       0,     0,   601,   602,     0,     0,   467,   603,   604,   605,
       0,     0,     0,     0,   606,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   607,     0,     0,   608,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,     0,     0,   616,     0,     0,
       0,     0,     0,     0,     0,     0,   617,   618,   619,   620,
       0,     0,   621,   622,   623,   624,   625,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   400,   401,
       0,     0,     0,     0,   626,   627,   628,   629,   402,   403,
     404,   405,   406,     0,     0,     0,     0,   407,     0,     0,
       0,   408,   409,   410,   630,   631
};

static const yytype_int16 yycheck[] =
{
      27,     0,   471,   472,   461,  1010,   578,   463,     7,   587,
     785,   656,   453,   983,   984,   626,    77,   632,   506,   570,
     855,   311,  1268,     3,    42,    43,    44,   573,     1,    90,
     764,   441,   442,   443,  1089,     3,   742,   743,   744,   745,
     746,   747,     3,     3,     3,    11,    27,    74,   682,   534,
      77,    69,    70,    71,    72,    73,     3,    75,    76,     1,
    1189,     3,     1,    90,     3,   355,     3,   980,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   826,     1,     3,     3,   446,   158,     1,   540,
     450,     3,     3,   393,   454,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,     1,   160,  1189,     3,   971,    45,     3,   724,
     632,   775,   413,   217,   415,   416,   780,   208,     1,   783,
       3,     3,    25,   787,     3,   449,    74,   735,     1,     1,
     648,     3,   650,   651,   458,     3,     9,   461,     3,     3,
     899,   601,   218,     3,   752,   221,   632,   607,     1,   206,
       3,   208,   209,     1,  1239,     3,     1,   597,     3,   918,
      68,     3,  1321,   634,   110,     3,    26,     9,    10,   684,
     108,   117,    74,   474,     3,  1260,    11,     3,    50,   757,
      88,   759,     3,  1268,    74,     3,  1129,     3,    26,   246,
       3,     9,    10,     9,    10,     3,     9,    10,   449,    11,
     219,   641,   128,   141,   142,    35,    36,   218,  1073,   155,
     229,   268,  1077,   791,   152,   539,   226,   274,   228,  1495,
     277,   278,   279,   219,   227,   133,   217,   551,   226,   258,
     168,   288,    62,   290,   291,   292,  1321,    25,   562,   229,
     229,    50,   114,   544,   545,   569,   303,   129,   217,   226,
     129,   218,     0,   222,   226,   108,   204,   226,   559,  1535,
     108,    73,   219,   703,   704,     1,  1353,     3,   849,   141,
     851,   101,   848,   330,   850,   715,   891,   220,   217,     3,
     152,   212,   768,   534,   217,   217,   217,   220,   141,   142,
     222,   229,   218,   141,   142,   221,   960,  1240,   820,   152,
     357,   130,   204,    27,   152,   114,    23,    24,  1393,   212,
     213,   214,   830,  1178,   204,   168,   776,   217,   217,   217,
     168,   220,   217,   938,   784,   785,  1269,  1270,     1,  1272,
       3,   946,   141,   819,   820,   392,  1072,   366,  1074,  1075,
    1076,   642,  1078,   226,   217,  1020,  1021,   115,   178,   217,
     601,   119,   217,   217,   222,   204,   607,   229,   218,  1000,
     220,   221,  1007,  1228,   218,     1,   220,     3,     4,   218,
     694,  1035,   217,  1460,  1461,   217,   229,   434,   107,   204,
     218,   229,   218,   221,   219,   220,   122,   827,   226,   217,
     228,     0,   220,   218,   230,   219,   132,    33,  1162,   217,
     129,   217,   722,   468,   217,   229,   892,   219,   220,   474,
    1495,   897,    48,    49,   143,    35,    36,    26,    54,    55,
      56,     0,   210,   211,   212,   213,   214,    63,   210,   211,
      66,   682,   218,   684,   220,   221,   218,    73,   707,   137,
     709,   710,    62,   717,   713,   719,   720,    26,     1,   723,
    1535,   508,   217,  1396,    90,    91,    92,    93,  1060,    79,
     517,   220,    71,   161,   229,   163,   102,   218,   217,   228,
     229,  1414,  1337,   530,     3,  1083,   227,  1342,  1343,  1344,
     229,   101,  1347,   106,   107,   183,   543,   204,    11,    12,
     870,   871,    71,   219,   954,    18,    19,    20,   218,   879,
      85,   218,    25,   229,    89,   965,   129,   227,   144,   145,
     314,  1010,   121,   570,   815,  1156,   573,    99,  1004,  1519,
    1520,   822,     3,   774,   775,   776,   135,     3,    81,   780,
     781,   108,   783,   784,   785,   217,   787,  1008,    18,    19,
      20,   792,   121,   794,   180,    25,    98,   229,   184,   102,
     103,   218,    68,   933,   221,   137,   135,     3,   178,    75,
    1503,  1504,   106,   107,   141,   142,  1509,  1007,   204,  1434,
      26,  1042,    88,  1516,  1517,   152,  1450,   106,   107,   161,
    1454,   163,  1456,  1457,   136,   129,   222,   223,    59,  1394,
     226,   168,   201,   397,   218,   399,    67,  1205,   655,   656,
     129,   183,  1407,  1638,   157,   874,   218,   881,   160,   666,
     162,   108,   220,   217,   217,   227,  1224,   133,  1226,     8,
     228,   229,   201,  1566,   217,   228,   229,   220,    84,   686,
     182,  1011,  1012,   437,    26,   228,   229,   190,   191,   192,
     193,   194,   195,   196,   141,   142,   143,     8,     9,   706,
     106,   107,   229,   217,    11,    12,   112,    14,    15,    16,
      17,    18,    19,    20,   217,   456,   457,   724,    25,   460,
     219,   168,   217,   129,   130,   218,  1000,   734,  1543,   228,
     229,  1546,   136,    81,   227,   208,   209,   210,   211,   212,
     213,   214,    84,   741,   742,   743,   744,   745,   746,   747,
       5,   218,   793,   954,   102,   103,   160,     3,   162,   960,
     227,     7,   217,   221,   965,  1589,   108,   221,  1592,   105,
     112,   107,   230,   218,   217,   220,   230,    13,   182,   980,
     210,   211,   212,   213,   214,    21,   793,   222,   130,   108,
    1348,  1349,   217,   129,    13,  1232,  1233,  1234,   108,   141,
     142,   143,    21,   217,  1241,  1242,  1243,   143,   211,   157,
      26,   818,    13,    98,    99,   801,   795,   143,   218,   805,
      21,   221,   141,   142,   143,   218,   168,   220,   231,   232,
     233,   141,   142,   143,  1035,   221,   218,   844,   845,   221,
     838,   839,   190,   191,   192,   193,   194,   195,   196,   168,
    1398,   136,   137,  1401,  1264,  1403,   218,   864,   168,   221,
     217,  1271,   218,  1273,  1274,   221,     3,   218,    84,   217,
     221,  1233,  1234,   219,   220,   160,   161,   162,   163,  1241,
    1242,  1243,   108,   218,   891,   220,   893,   108,   895,   217,
     106,   107,   108,   217,   901,   902,   112,   182,   183,   906,
     907,   208,   209,   210,   211,   212,   213,   214,   906,   907,
     108,  1321,   217,   129,   130,   141,   142,   143,   217,   917,
     141,   142,   143,   108,   217,   141,   142,   143,  1129,     3,
     218,   938,   220,   221,   217,   942,   943,   944,   217,   946,
     981,  1142,   168,   141,   142,   143,   217,   168,   955,   956,
     957,   218,   168,   220,   221,   217,   141,   142,   143,   966,
       3,   968,   969,   970,     3,   218,   218,   974,   221,   221,
     168,   228,   229,   143,   981,   218,   983,   984,   221,   986,
     987,  1262,  1263,   168,  1394,   218,   993,   220,  1437,  1438,
    1604,  1605,   162,   163,   973,   218,  1037,  1407,   221,     1,
     217,     3,   172,   173,   174,   175,   176,   218,     3,   218,
     221,   181,   221,  1020,  1021,   185,   186,   187,   218,   218,
     217,   221,   221,   218,   217,   220,  1356,  1034,  1358,  1359,
    1037,  1361,  1362,  1363,   217,  1365,  1366,  1367,   218,  1240,
     218,   221,   218,   221,   217,   221,    11,    12,   217,    14,
      15,    16,    17,    18,    19,    20,  1063,   219,   218,   218,
      25,   221,   221,  1264,  1071,    30,    31,    32,  1269,  1270,
    1271,  1272,  1273,  1274,  1072,   217,  1074,  1075,  1076,   218,
    1078,  1471,   221,   218,   218,  1475,   221,   221,   218,  1479,
     220,  1501,   217,     1,  1484,     3,   983,   984,  1488,  1106,
     219,     1,  1492,     3,     1,  1515,     3,  1281,  1282,  1360,
    1089,  1118,     1,  1364,     3,   219,   218,  1368,   220,   218,
    1321,   220,   219,  1374,  1131,  1132,   218,  1378,   220,   219,
     218,  1382,   220,   218,   220,   220,  1143,  1144,  1339,   218,
    1147,  1148,   362,   363,  1185,  1152,   218,   218,   220,   220,
     217,    11,    12,   217,    14,    15,    16,    17,    18,    19,
      20,  1437,  1438,    23,    24,    25,   503,   504,    28,    29,
      30,    31,    32,  1180,   218,  1585,   220,   218,  1185,   220,
    1187,   218,     1,   220,     3,   218,    25,   220,  1195,  1638,
     218,   220,   220,  1394,   218,  1396,   220,   220,   218,  1206,
     220,   220,   220,  1210,  1211,   218,  1407,   220,     3,   218,
    1189,   220,   218,  1414,   220,   218,     3,   220,   218,   218,
     220,   220,     3,     5,  1554,  1223,  1636,   218,  1558,   220,
     219,   218,  1562,   220,     5,  1645,  1646,   218,   130,   220,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      26,   218,  1453,   220,  1261,  1262,  1263,   218,  1265,   220,
    1239,   218,   218,   220,   220,   218,   218,   220,   220,   218,
     218,   220,   220,   220,  1281,  1282,   218,   220,   220,  1286,
    1287,  1260,   220,   218,  1291,   220,   220,   218,  1295,  1268,
     218,   218,   220,   220,   218,     3,   220,     3,   221,   152,
    1501,  1280,  1503,  1504,     3,     3,     3,   229,  1509,   162,
     163,     3,     3,   220,  1515,  1516,  1517,   107,   220,   172,
     173,   174,   175,   176,   220,  1332,     3,   164,   181,   219,
     217,   108,   185,   186,   187,     3,  1334,     3,  1345,   227,
     220,   219,  1321,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    80,   230,     3,   152,   107,
     221,   220,   162,   163,   229,  1566,   220,   219,   217,   217,
     230,   217,   172,   173,   174,   175,   176,   143,     1,   217,
    1387,   181,    45,   217,  1585,   185,   186,   187,    78,     3,
     220,  1398,     3,    82,  1401,     3,  1403,     3,     3,   222,
       3,     5,     3,  1604,  1605,    76,   220,    77,   219,   218,
     220,   217,   220,   220,  1393,   220,   218,    81,  1425,   217,
    1427,   217,     3,   220,   217,   217,   217,     3,   217,  1436,
      72,   217,   217,    80,     1,  1636,     3,     4,     5,  1446,
     219,     8,     9,    10,  1645,  1646,   220,   219,     3,   222,
     219,   221,   220,   218,   218,   218,   218,     3,   219,  1466,
    1467,    73,     3,    30,    31,    32,   217,    34,   221,   221,
      37,    38,    39,   220,    41,    42,    43,    44,    11,    12,
     219,    14,    15,    16,    17,    18,    19,    20,   219,   221,
      57,   229,    25,    60,    61,    28,    29,    30,    31,    32,
       3,   221,   221,   221,   221,   218,   217,  1514,    22,    26,
     217,   220,   217,   217,   217,   217,  1495,   217,     3,    86,
      87,   217,   217,    73,   204,   204,   220,   220,   204,    27,
      77,  1538,   220,   100,   220,   220,   220,   220,   220,     3,
    1547,  1548,   229,   221,   111,   219,   113,   202,     3,   116,
     217,   118,    83,   218,    11,    12,  1535,    14,    15,    16,
      17,    18,    19,    20,   218,   218,   218,   134,    25,   218,
     218,  1578,  1579,    30,    31,    32,   220,  1584,   218,     5,
       3,   220,   219,     3,   220,   219,   153,   154,     3,   220,
       3,   158,     3,     3,   229,   221,   221,   221,   165,   166,
      11,    12,   221,    14,    15,    16,    17,    18,    19,    20,
      76,   221,   221,   228,    25,   217,    70,    28,    29,    30,
      31,    32,   217,   221,   217,   202,   218,   202,  1635,   229,
    1637,   230,   221,     3,    73,   221,   219,   109,   205,   206,
     207,   221,   221,   210,   211,     3,   217,   221,   221,   221,
     217,   218,   220,   217,   221,    73,   204,   224,   225,   226,
       1,   228,     3,     4,     5,    73,   220,     8,     9,    10,
     203,   220,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   220,   220,   218,     5,   218,   217,   221,    30,
      31,    32,   218,    34,   218,   218,    37,    38,    39,   217,
      41,    42,    43,    44,   217,     3,   228,     3,   220,   220,
     219,    77,    83,   221,    70,   221,    57,   218,   220,    60,
      61,     3,     3,   230,     3,     3,     3,     3,     3,     3,
       3,   220,    72,   221,   221,    72,     3,    76,   220,   202,
     220,   218,   218,   204,   223,    86,    87,   220,     3,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     3,   100,
     219,   221,     3,   221,     3,   221,    83,   229,   221,   221,
     111,   220,   113,   220,   220,   116,   220,   118,   220,    76,
     221,   221,    29,   221,   221,   221,   221,   219,   221,   219,
     428,   220,   203,   134,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   220,   925,     7,   218,    19,   164,
     171,  1321,   153,   154,   729,   366,  1185,   158,  1428,     1,
    1035,     3,     4,     5,   165,   166,     8,     9,    10,  1303,
     633,   712,   465,  1250,  1052,   364,   511,   891,   990,   995,
     437,   619,  1527,   589,   903,  1239,  1060,  1383,    30,    31,
      32,  1016,    34,   503,   476,    37,    38,    39,  1190,    41,
      42,    43,    44,   504,   205,   206,   207,    -1,    -1,   210,
     211,    -1,    -1,    -1,    -1,    57,   217,   218,    60,    61,
     221,   309,    -1,   224,   225,   226,    -1,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    87,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,   100,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,   111,
      -1,   113,    -1,    -1,   116,    -1,   118,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,   153,   154,    -1,    -1,    -1,   158,    -1,    -1,    -1,
      -1,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,
      61,    -1,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,    86,    87,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,   100,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
     111,    -1,   113,    -1,    -1,   116,    -1,   118,    -1,    -1,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   132,    -1,   134,    -1,    -1,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   153,   154,    -1,    -1,   221,   158,    -1,     1,
      -1,     3,     4,     5,   165,   166,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      42,    43,    44,    -1,   205,   206,   207,    -1,    -1,   210,
     211,    -1,    -1,    -1,    -1,    57,   217,    -1,    60,    61,
      -1,    -1,    64,   224,   225,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    87,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,   100,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,   111,
      -1,   113,    -1,    -1,   116,    -1,   118,    -1,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,   134,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,   230,    -1,    25,    -1,
      -1,   153,   154,    30,    -1,    -1,   158,    -1,     1,    -1,
       3,     4,     5,   165,   166,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    34,    -1,    -1,    37,    38,    39,    -1,    41,    42,
      43,    44,    -1,   205,   206,   207,    -1,    -1,   210,   211,
      -1,    -1,    -1,    -1,    57,   217,    -1,    60,    61,    -1,
      -1,    64,   224,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,    87,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,   100,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,   111,    -1,
     113,    -1,    -1,   116,    -1,   118,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,
     153,   154,    -1,    -1,    -1,   158,    -1,     1,    -1,     3,
       4,     5,   165,   166,     8,     9,    10,    -1,    -1,    -1,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    42,    43,
      44,    -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,
      -1,    -1,    -1,    57,   217,    -1,    60,    61,    -1,    -1,
      64,   224,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    87,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,   100,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,   111,    -1,   113,
      -1,    -1,   116,    -1,   118,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,    -1,   230,     8,     9,    10,    -1,   153,
     154,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    34,    -1,    -1,    37,    38,    39,    -1,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    -1,
      -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,    -1,
      -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,    86,    87,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,   100,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,   111,    -1,
     113,    -1,    -1,   116,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   134,    -1,    -1,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     153,   154,    -1,    -1,   221,   158,    -1,     1,    -1,     3,
       4,     5,   165,   166,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    42,    43,
      44,    -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,
      -1,    -1,    -1,    57,   217,    -1,    60,    61,   221,    -1,
      64,   224,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    87,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,   100,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,   111,    -1,   113,
      -1,    -1,   116,    -1,   118,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,   153,
     154,    -1,    -1,    -1,   158,    -1,     1,    -1,     3,     4,
       5,   165,   166,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    42,    43,    44,
      -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,    -1,
      -1,    -1,    57,   217,    -1,    60,    61,    -1,    -1,    64,
     224,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    87,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,   100,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,   111,    -1,   113,    -1,
      -1,   116,    -1,   118,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   134,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,   153,   154,
      -1,    -1,    -1,   158,    -1,     1,    -1,     3,     4,     5,
     165,   166,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    42,    43,    44,    -1,
     205,   206,   207,    -1,    -1,   210,   211,    -1,    -1,    -1,
      -1,    57,   217,    -1,    60,    61,    -1,    -1,    64,   224,
     225,   226,    -1,    -1,    -1,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      86,    87,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,
     116,    -1,   118,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,    -1,   230,     8,     9,    10,    -1,   153,   154,    -1,
      -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    60,    61,    -1,    -1,   205,
     206,   207,    -1,    -1,   210,   211,    -1,    -1,    -1,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,
      -1,   116,    -1,   118,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   134,
      -1,    -1,    -1,    -1,    -1,   221,    -1,     1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,   153,   154,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,
     165,   166,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    60,    61,    -1,    -1,
     205,   206,   207,    -1,    -1,   210,   211,    -1,    -1,    -1,
      -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,   226,    86,    87,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,   100,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,   111,    -1,   113,
      -1,    -1,   116,    -1,   118,    -1,    -1,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
     134,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,   153,
     154,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    34,    -1,    -1,    37,    38,    39,    -1,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    -1,
      -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,    -1,
      -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,    86,    87,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,   100,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,   111,    -1,
     113,    -1,    -1,   116,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   134,    -1,    -1,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     153,   154,    -1,    -1,   221,   158,    -1,     1,    -1,     3,
       4,     5,   165,   166,     8,     9,    10,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      34,    -1,    -1,    37,    38,    39,   230,    41,    42,    43,
      44,    -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,
      -1,    -1,    -1,    57,   217,    -1,    60,    61,    -1,    -1,
      -1,   224,   225,   226,    -1,   228,    -1,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    86,    87,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,   113,
      -1,    -1,   116,    -1,   118,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,    -1,   230,     8,     9,    10,    -1,   153,
     154,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    34,    -1,    -1,    37,    38,    39,    -1,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    -1,
      -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,    -1,
      -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,
     113,    -1,    -1,   116,    -1,   118,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   134,    -1,    -1,    -1,    -1,    -1,   221,    -1,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
     153,   154,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,
      -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,
      -1,    -1,   205,   206,   207,    -1,    -1,   210,   211,    -1,
      -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,   226,    86,    87,    -1,    -1,     1,    -1,
       3,     4,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
      -1,   113,    -1,    26,   116,    -1,   118,    -1,    -1,    -1,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      63,   153,   154,    66,    -1,    -1,   158,    -1,    -1,    -1,
      -1,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
      -1,    -1,    -1,   106,   107,   108,    -1,    -1,    -1,   112,
      -1,    -1,    -1,   205,   206,   207,    -1,    -1,   210,   211,
      -1,    -1,    -1,    -1,    -1,   217,   129,   130,    -1,    -1,
      -1,    -1,   224,   225,   226,    -1,    -1,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,    -1,    34,
      -1,   184,    37,    38,    39,    -1,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    60,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,
     223,    -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    87,     1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,
      -1,   116,    -1,   118,    -1,    -1,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    42,    43,    44,    -1,    -1,   134,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    60,    61,    -1,    -1,    -1,    -1,   153,   154,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,
     165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    86,    87,
      -1,    -1,     1,    -1,     3,     4,    -1,    -1,    -1,    -1,
      -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,    -1,   113,    -1,    -1,   116,    -1,
     118,    -1,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   217,    -1,    -1,    -1,   134,    -1,    -1,    48,
      49,   226,    -1,    -1,    -1,    54,    55,    56,     1,    -1,
       3,     4,    -1,    -1,    63,   153,   154,    66,    -1,    -1,
     158,    -1,    -1,    -1,    -1,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    90,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,    -1,    48,    49,    -1,    -1,    -1,
     109,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    -1,    66,     1,    -1,     3,     4,    -1,   217,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   226,    -1,
      -1,    -1,    -1,    -1,    -1,   144,   145,    90,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    55,    56,
      -1,   180,    -1,    -1,    -1,   184,    63,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,   144,   145,    -1,    -1,   204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    -1,    -1,    -1,
      -1,    -1,    -1,   222,   223,   102,    -1,   226,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,    -1,    -1,
      -1,   184,    -1,    -1,    48,    49,     1,    -1,     3,     4,
      54,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,   204,    66,    -1,    -1,    -1,    -1,   144,   145,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    33,   222,
     223,    -1,    -1,   226,    -1,    -1,    90,    91,    92,    93,
      -1,    -1,    -1,    48,    49,    -1,    -1,    -1,   102,    54,
      55,    56,    -1,   180,    -1,    -1,    -1,   184,    63,    -1,
       1,    66,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,
     144,   145,    33,   220,    -1,   222,   223,   102,    -1,   226,
      -1,    -1,    -1,    -1,   109,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    -1,    66,   180,    -1,    -1,    -1,
     184,    -1,    73,     1,    -1,     3,     4,    -1,    -1,   144,
     145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,    -1,    -1,    -1,    33,    -1,    -1,   222,   223,
      -1,    -1,   226,    -1,    -1,   180,    -1,    -1,    -1,   184,
      48,    49,     1,    -1,     3,     4,    54,    55,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    66,    -1,
      -1,    -1,    -1,   144,   145,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    -1,    -1,   222,   223,    -1,
      -1,   226,    90,    91,    92,    93,    -1,    -1,    -1,    48,
      49,    -1,    -1,    -1,   102,    54,    55,    56,    -1,   180,
      -1,   109,    -1,   184,    63,    -1,    -1,    66,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    90,    91,    92,    93,    -1,   144,   145,    -1,    -1,
      -1,   222,   223,   102,    -1,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,   180,    -1,    -1,    -1,   184,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   144,   145,    -1,    -1,    30,
      31,    32,    -1,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   222,   223,    57,    -1,   226,    60,
      61,   180,    -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    99,   100,
      -1,    -1,    -1,   222,   223,    -1,    -1,   226,    -1,    -1,
     111,    -1,   113,    -1,    -1,   116,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,    -1,   136,   137,    -1,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   153,   154,    -1,    -1,    -1,   158,    -1,   160,
     161,   162,   163,   226,   165,   166,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   182,   183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   205,   206,   207,    -1,    -1,   210,
     211,    -1,     3,     4,     5,    -1,   217,     8,     9,    10,
      -1,    -1,    -1,   224,   225,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    86,    87,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,    -1,   113,    -1,    -1,   116,    -1,   118,    -1,    -1,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,   134,    25,   136,    -1,    28,    29,    30,
      31,    32,    -1,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,   153,   154,    -1,    -1,    -1,   158,    -1,   160,
      -1,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    -1,    34,    -1,    -1,    37,    38,
      39,   182,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    60,    61,    -1,   205,   206,   207,    -1,    -1,   210,
     211,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,
      -1,    -1,    -1,   224,   225,   226,    -1,    86,    87,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,   100,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,   111,    -1,   113,    -1,    -1,   116,    -1,   118,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   134,    -1,    -1,   137,    -1,
     221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,   154,    -1,    -1,    -1,   158,
      -1,    -1,   161,    -1,   163,    -1,   165,   166,    -1,    -1,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   183,    -1,    -1,    -1,    -1,    -1,
     221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,   206,   207,    -1,
      -1,   210,   211,    -1,     3,     4,     5,    -1,   217,     8,
       9,    10,    -1,    -1,    -1,   224,   225,   226,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    -1,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    60,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    86,    87,   221,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,    -1,   113,    -1,    -1,   116,    -1,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,   154,     3,     4,     5,   158,
      -1,     8,     9,    10,    -1,    -1,   165,   166,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,   206,   207,    -1,
      57,   210,   211,    60,    61,    -1,    -1,    -1,   217,    -1,
      -1,    -1,    -1,   222,   223,   224,   225,   226,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,   116,
      -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,
      -1,    -1,   203,   204,    -1,    -1,    -1,    -1,   145,   210,
      -1,   212,    -1,   214,    -1,    -1,   153,   154,    -1,    -1,
      -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,   166,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,   206,
     207,    -1,    -1,   210,   211,    -1,     3,     4,     5,    -1,
     217,     8,     9,    10,    -1,   222,   223,   224,   225,   226,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    60,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,   116,
      -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,   153,   154,    -1,    -1,
      -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,   166,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    42,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    60,    61,    -1,    -1,   205,   206,
     207,    -1,    -1,   210,   211,    -1,    -1,    -1,    -1,    -1,
     217,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,
     116,    -1,   118,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,   153,   154,    -1,
      -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    60,    61,    -1,    -1,   205,
     206,   207,    -1,    -1,   210,   211,    -1,    -1,    -1,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,    86,    87,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,   100,    -1,    -1,    25,   104,
      -1,    28,    29,    30,    31,    32,   111,    -1,   113,    -1,
      -1,   116,    -1,   118,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,   134,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,   153,   154,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    85,    -1,
     165,   166,    89,    -1,    -1,    -1,    30,    31,    32,    -1,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    60,    61,    -1,    -1,
     205,   206,   207,    -1,    -1,   210,   211,    -1,    -1,    -1,
      -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,   226,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,   113,
      -1,    -1,   116,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   153,
     154,     3,     4,     5,   158,    -1,     8,     9,    10,    -1,
      -1,   165,   166,    -1,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    30,    31,
      32,    -1,    34,    -1,   221,    37,    38,    39,    -1,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   205,   206,   207,    -1,    57,   210,   211,    60,    61,
      -1,    -1,    64,   217,    -1,    -1,    -1,   221,    -1,    -1,
     224,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
      -1,   113,    -1,    -1,   116,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,   153,   154,    -1,    -1,    -1,   158,    -1,    -1,    -1,
      -1,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,
      61,    -1,    -1,   205,   206,   207,    -1,    -1,   210,   211,
      -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,    -1,   113,    -1,    -1,   116,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,   153,   154,    -1,    -1,    -1,   158,    -1,    -1,
      -1,    -1,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      60,    61,    -1,    -1,   205,   206,   207,    -1,    -1,   210,
     211,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,
     221,    -1,    -1,   224,   225,   226,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,    -1,   113,    -1,    -1,   116,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,    -1,   153,   154,    -1,    -1,    -1,   158,    -1,
      -1,    -1,    -1,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    30,    31,    32,    -1,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    60,    61,    -1,    -1,   205,   206,   207,    -1,    -1,
     210,   211,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,   226,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,    -1,   113,    -1,    -1,   116,    -1,   118,
      -1,    -1,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,   134,    25,    -1,    -1,    -1,
      29,    30,    31,    32,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,   153,   154,    -1,    -1,    -1,   158,
      -1,    -1,    -1,    -1,    -1,    -1,   165,   166,    -1,    -1,
      -1,    -1,    30,    31,    32,    -1,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    60,    61,    -1,    -1,   205,   206,   207,    -1,
      -1,   210,   211,    -1,    -1,    -1,    -1,    -1,   217,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,    86,    87,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,    -1,   113,    -1,    -1,   116,    -1,
     118,    -1,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      42,    43,    44,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,
      -1,    -1,    -1,    -1,    -1,   153,   154,    69,    -1,    -1,
     158,    -1,    -1,    -1,    -1,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    86,    87,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
      -1,   113,    -1,    -1,   116,    -1,   118,   205,   206,   207,
     122,    -1,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,   134,    -1,    -1,    -1,   224,   225,   226,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,
      -1,   153,   154,    -1,    -1,    -1,   158,    -1,    -1,    -1,
      -1,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    60,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    87,   226,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,    -1,   100,    -1,    -1,    -1,
     104,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,   113,
      -1,    -1,   116,    -1,   118,    -1,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    42,    43,    44,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    60,    61,    -1,    -1,    -1,    -1,    -1,   153,
     154,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    86,    87,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,   100,    -1,    -1,    -1,   104,    -1,    -1,    -1,
      -1,    -1,    -1,   111,    -1,   113,    -1,    -1,   116,    -1,
     118,    34,    -1,    -1,    37,    38,    39,    -1,    41,    42,
      43,    44,    -1,   217,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,   226,    -1,    57,    -1,    -1,    60,    61,    -1,
      -1,    -1,    -1,    -1,    -1,   153,   154,    -1,    -1,    -1,
     158,    -1,    -1,    -1,    -1,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,
     113,    -1,    -1,   116,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,
      -1,   134,     1,    -1,     3,    -1,    -1,     6,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     153,   154,    -1,    -1,    -1,   158,    -1,    26,    -1,    -1,
      -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,    48,
      49,    -1,    51,    52,    53,    54,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,   217,    84,    28,    29,    30,    31,
      32,    90,    -1,   226,    -1,    94,    95,    96,    -1,    -1,
      -1,    -1,    -1,   102,    -1,    -1,   105,   106,   107,   108,
      -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,   128,
     129,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,   138,
     139,   140,   141,   142,   143,    -1,    -1,   146,   147,   148,
     149,   150,    -1,    -1,    -1,    -1,    -1,   156,    -1,    -1,
      -1,    -1,    -1,   162,   163,    -1,    -1,    -1,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
      -1,    -1,   181,    -1,    -1,    -1,   185,   186,   187,   188,
     189,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,   201,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      12,   220,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    11,    12,   221,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    11,    12,   221,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,   221,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    11,    12,   221,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    11,    12,   221,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    -1,    -1,   221,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    11,    12,   221,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,   221,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    11,
      12,   221,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    11,    12,   221,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,   221,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    11,    12,   221,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    -1,    -1,   221,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    11,    12,   221,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    11,
      12,   221,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    11,    12,   221,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,   221,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    -1,    -1,   221,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    11,    12,   221,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    11,    12,   221,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    -1,    -1,   221,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    11,    12,   221,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    11,    12,
     220,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    11,    12,   220,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,    -1,    11,
      12,   220,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,    -1,    11,    12,   220,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    11,    12,   220,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    11,    12,   220,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,    -1,    11,
      12,   220,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    11,    12,   218,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,   218,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,   218,    -1,
      -1,    -1,    -1,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
     218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,     3,    -1,   203,     6,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,   218,    -1,
      -1,    -1,    -1,    -1,    26,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    40,    -1,
     218,    -1,    -1,    -1,    46,    47,    48,    -1,    -1,    51,
      52,    53,    54,    -1,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
     203,    73,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    84,    -1,    -1,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,    -1,    -1,   105,   106,   107,   108,    -1,    -1,    -1,
     112,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,   128,   129,   130,   131,
      -1,    -1,    -1,    -1,    -1,    -1,   138,   139,   140,   141,
     142,   143,    -1,    -1,   146,   147,   148,   149,   150,    -1,
      -1,    -1,    -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,
     162,   163,    -1,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,     1,    -1,     3,   181,
      -1,     6,    -1,   185,   186,   187,   188,   189,    -1,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,   201,
      -1,    26,   204,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    46,    47,    48,    -1,    -1,    51,    52,    53,    54,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,    -1,    -1,
     105,   106,   107,   108,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,    -1,    -1,    -1,
      -1,    -1,    -1,   138,   139,   140,   141,   142,   143,    -1,
      -1,   146,   147,   148,   149,   150,    -1,    -1,    -1,    -1,
      -1,   156,    -1,    -1,    -1,    -1,    -1,   162,   163,    -1,
      -1,    -1,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,    -1,    -1,   181,    -1,    -1,    -1,
     185,   186,   187,   188,   189,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,   204,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,   203,   204,    28,    29,
      30,    31,    32,   210,    -1,   212,    -1,   214,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   203,   204,    -1,    -1,    -1,    -1,    -1,
     210,    -1,   212,    -1,   214,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     203,    -1,    -1,    -1,    -1,    -1,    -1,   210,   211,   212,
      -1,   214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    26,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    40,    -1,    -1,    -1,    -1,
      -1,    46,    47,    48,    -1,    -1,    51,    52,    53,    54,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,    -1,    -1,
     105,   106,   107,   108,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,    -1,    -1,    -1,
      -1,    -1,    -1,   138,   139,   140,   141,   142,   143,    -1,
      -1,   146,   147,   148,   149,   150,    -1,    -1,    -1,    -1,
      -1,   156,    -1,    -1,     1,    -1,     3,   162,   163,     6,
      -1,    -1,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,    -1,    -1,   181,    -1,    -1,    26,
     185,   186,   187,   188,   189,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,   201,    -1,    -1,    46,
      47,    48,    49,    -1,    51,    52,    53,    54,    -1,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      -1,    -1,    -1,    -1,    -1,   102,    -1,    -1,   105,   106,
     107,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,   128,   129,   130,   131,    -1,    -1,    -1,    -1,    -1,
      -1,   138,   139,   140,   141,   142,   143,    -1,    -1,   146,
     147,   148,   149,   150,    -1,    -1,     1,    -1,     3,   156,
      -1,     6,    -1,    -1,    -1,   162,   163,    -1,    -1,    -1,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,    26,    -1,    -1,   181,    -1,    -1,    -1,   185,   186,
     187,   188,   189,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    46,    47,    48,   201,    -1,    51,    52,    53,    54,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,    -1,    -1,
     105,   106,   107,   108,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,    -1,    -1,    -1,
      -1,    -1,    -1,   138,   139,   140,   141,   142,   143,    -1,
      -1,   146,   147,   148,   149,   150,    -1,    -1,     1,    -1,
       3,   156,    -1,     6,    -1,    -1,    -1,   162,   163,    -1,
      -1,    -1,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    26,    -1,    -1,   181,    -1,    -1,    -1,
     185,   186,   187,   188,   189,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    46,    47,    48,   201,    -1,    51,    52,
      53,    54,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,
      -1,    -1,   105,   106,   107,   108,    -1,    -1,    -1,   112,
      -1,    -1,    -1,    -1,    -1,    -1,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,   128,   129,   130,   131,    -1,
      -1,    -1,    -1,    -1,    -1,   138,   139,   140,   141,   142,
     143,    -1,    -1,   146,   147,   148,   149,   150,    -1,    -1,
      -1,    -1,    -1,   156,    -1,    -1,     1,    -1,     3,   162,
     163,     6,    -1,    -1,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,    -1,    -1,    -1,   181,    -1,
      -1,    26,   185,   186,   187,   188,   189,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,   201,    -1,
      -1,    46,    47,    48,    49,    -1,    51,    52,    53,    54,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,    -1,    -1,
     105,   106,   107,   108,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,    -1,    -1,    -1,
      -1,    -1,    -1,   138,   139,   140,   141,   142,   143,    -1,
      -1,   146,   147,   148,   149,   150,    -1,    -1,    -1,     3,
      -1,   156,    -1,    -1,    -1,    -1,    -1,   162,   163,    -1,
      -1,    -1,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,    -1,    -1,   181,    -1,   203,    -1,
     185,   186,   187,   188,   189,   210,    40,   212,    -1,   214,
      -1,    -1,    46,    47,    -1,    -1,   201,    51,    52,    53,
      -1,    -1,    -1,    -1,    58,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,   123,
     124,   125,   126,   127,   128,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   140,   141,   142,   143,
      -1,    -1,   146,   147,   148,   149,   150,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,   163,
      -1,    -1,    -1,    -1,   168,   169,   170,   171,   172,   173,
     174,   175,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,   185,   186,   187,   188,   189
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    26,    71,   121,   135,   201,   251,   252,   255,   273,
     275,   279,   311,   433,     3,    27,   256,   257,     3,     3,
       3,   217,     0,   273,   115,   119,   314,   219,    27,   218,
     220,   274,   274,   217,     3,     3,     3,     4,     5,     8,
       9,    10,    30,    31,    32,    34,    37,    38,    39,    41,
      42,    43,    44,    57,    60,    61,    86,    87,   100,   111,
     113,   116,   118,   134,   153,   154,   158,   165,   166,   205,
     206,   207,   210,   211,   217,   224,   225,   226,   253,   291,
     295,   301,   257,   276,   280,     3,   129,   429,   218,   312,
     217,     8,   295,   295,   295,   217,   217,   217,   217,   217,
     217,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   217,   217,   217,   217,   217,   217,   217,   217,   295,
       1,   295,   295,   295,   295,   291,   292,   295,     1,   295,
     291,   294,    11,    12,    14,    15,    16,    17,    18,    19,
      20,    25,    28,    29,    30,    31,    32,   203,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   217,   228,
     229,    68,    88,   133,   277,   278,    35,    36,    62,   101,
     178,   281,   282,   143,   430,   218,   221,     5,   222,   317,
     291,   294,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   204,   221,   226,   218,
     227,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   294,     3,   291,
      59,    67,     3,     3,    75,   278,   219,   219,   219,   219,
     219,    79,   282,     3,     3,   220,   218,   217,   217,   316,
     221,   221,   221,   221,   221,   221,   221,   221,   218,   221,
     221,   221,   221,   221,   218,   221,   221,   218,   218,   218,
     221,   221,   221,   221,   221,   291,   294,   291,   204,   221,
      23,    24,   204,   230,   220,   220,   220,   220,   291,     3,
       3,     3,     5,   219,   431,   107,   129,   143,   427,   428,
       5,   130,   318,     3,   226,   228,   255,   303,   304,   305,
     368,   369,   370,    26,   315,   291,   291,   291,   291,   291,
     204,   227,   291,   291,   291,   291,   220,   220,   220,   220,
     220,   291,   218,     3,   302,     3,     3,   129,   105,   422,
     423,   427,   221,     3,   351,   218,   221,   229,   370,   371,
       3,   106,   107,   129,   218,   221,   218,   220,   221,     3,
     220,   221,   221,   221,   221,   221,   291,     1,   227,   230,
     230,   230,   107,   432,   218,   220,   220,   220,     3,     3,
     164,   415,   219,   130,   351,     1,   291,   218,   227,   217,
     162,   163,   172,   173,   174,   175,   176,   181,   185,   186,
     187,   306,   342,   306,   143,   306,   343,   369,     3,   305,
     108,   313,   227,     3,   218,   221,     3,   220,   219,   416,
      80,   291,   351,   230,   204,   230,   370,   226,   370,   152,
     307,   307,   307,   307,     3,     1,     6,    48,    54,    65,
      84,    90,    94,    95,    96,   102,   106,   107,   112,   119,
     129,   130,   138,   139,   156,   167,   177,   201,   255,   258,
     319,   329,   334,   335,   374,   107,   220,   253,   203,   210,
     212,   214,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   417,   418,   419,   420,   421,   424,   425,    85,    89,
     352,   353,   354,   356,   291,   371,   221,   229,   375,   376,
     376,   376,   376,   219,   220,   302,     1,   217,   283,   284,
     217,   265,   266,   301,   375,   302,   217,     1,    45,   328,
      49,   335,   302,   217,   343,   343,     1,     3,   108,   141,
     142,   152,   168,   254,   357,   358,   364,   375,     1,   343,
       1,   108,   152,   168,   254,   344,   350,   351,   375,     3,
     217,   298,   299,   217,   299,     1,    81,   102,   103,   157,
     190,   191,   192,   193,   194,   195,   196,   217,   386,   387,
     388,   390,   392,   393,   328,   217,   263,   264,   217,     3,
      40,    46,    47,    51,    52,    53,    58,   105,   108,   120,
     123,   124,   125,   126,   127,   128,   131,   140,   141,   142,
     143,   146,   147,   148,   149,   150,   168,   169,   170,   171,
     188,   189,   300,   342,    49,   220,   319,   336,   337,   319,
      78,   307,   342,     3,   415,   220,    82,   418,   424,   421,
     424,   204,   425,   291,   354,   217,   229,   230,   227,   291,
       3,     3,     3,     3,     5,   220,   219,   220,    98,    99,
     136,   137,   160,   161,   162,   163,   182,   183,   285,   286,
     222,   268,   269,   291,   218,   220,   219,   265,   220,     3,
      76,   108,   141,   142,   152,   168,   375,   379,   204,   335,
      77,   220,   291,   307,   307,   220,   219,   361,   375,   362,
     363,   220,   218,   359,   220,   307,   220,   347,   375,   348,
     349,   220,   218,   345,   217,   375,   285,   291,   293,   218,
     220,   286,   220,    81,   217,   217,   392,     3,     7,   395,
     396,   217,   217,   217,   217,   217,   217,   217,     1,     3,
     122,   132,   389,   394,    81,   386,   220,   219,   220,   219,
       3,   110,   117,   155,   376,     1,     3,   222,   365,     3,
     290,   407,     1,     4,    33,    48,    49,    54,    55,    56,
      63,    66,    90,    91,    92,    93,   102,   144,   145,   180,
     184,   222,   223,   226,   267,   287,   301,   308,   402,   402,
       1,     3,   380,   381,     1,     3,   382,   383,     1,   383,
       1,    50,   114,   141,   340,   341,     1,   381,   217,   268,
     283,   299,   341,   204,   335,    72,   376,   307,    80,   204,
     204,   211,   231,   232,   233,   425,   426,   104,   210,   211,
     291,   355,   355,   221,   204,   219,   220,   291,   218,   218,
     218,   218,     3,     9,    10,   217,   272,   301,   308,   309,
     310,   221,   265,   291,   219,   375,     3,     3,    73,   221,
     376,   376,   291,   364,   360,   364,   364,   357,   364,   376,
     350,   346,   350,   350,   351,   350,     1,   228,   293,   372,
     373,   217,   221,   218,   221,   217,   298,   221,   291,   394,
     220,   219,   219,   218,   220,    69,   122,   132,   295,   398,
     398,   398,   398,   398,   398,   398,   221,   229,   394,   210,
     211,   218,   397,   217,   272,   217,   272,     1,   220,   321,
     221,   221,   221,   269,   221,   218,     1,     9,   217,     1,
     299,   217,    22,    11,   219,   220,   217,   220,   301,   308,
       1,    73,   204,   402,   405,   217,   217,   217,   308,   301,
     217,   308,   402,   109,   204,   405,   217,   308,   217,   217,
     217,   217,   272,   212,   217,   301,   294,   220,   402,   406,
     255,   217,   220,    11,   219,   220,   219,   229,   377,   378,
     218,   220,   220,   219,   377,   218,   220,   220,   220,   220,
     307,   220,   220,   299,   268,   299,   220,   307,     3,    73,
     325,   269,   376,   231,   232,   233,   204,   220,   104,   104,
     204,   204,   291,   291,    27,   220,   286,   285,    99,   286,
      98,   285,   271,   291,   219,   218,   220,   326,   291,     1,
     220,   323,   327,    77,   302,   302,   364,   302,   350,   221,
       3,   221,   218,   221,     1,   293,   373,   299,   291,   299,
     221,   397,   291,   217,   291,   395,   229,   291,   295,   291,
     295,   202,   218,   218,   218,   218,   218,   218,   218,   295,
     397,     3,    13,    21,   270,   271,     1,   270,    83,   320,
     217,   302,   220,     5,   228,   293,   366,   367,   220,   220,
       3,   291,   291,   291,   293,   220,   219,    73,     3,    73,
     402,   291,   291,   291,   220,   220,     1,   308,   219,     3,
     109,     1,   291,   220,   291,   291,     1,   291,   271,   255,
       1,   122,   132,   212,   288,   289,   291,   227,   406,   221,
     294,   145,   223,   267,   287,   291,   145,   267,   287,   291,
     291,   291,   229,   380,   291,   382,   375,   381,   220,   299,
     220,   283,   376,   335,   336,     1,   302,   302,   426,   355,
     355,   230,   221,   221,   221,   221,   221,   221,   218,   221,
     204,   291,   309,    64,   294,   330,   331,   220,    76,   322,
     217,   335,   220,   220,   220,   217,   372,   221,   221,   221,
     220,   220,   388,   392,    13,    21,   204,   291,    70,   399,
     202,   202,   291,   398,   271,   398,   398,   398,   271,   398,
     230,    13,    21,   229,   217,   394,   217,   394,   218,   221,
     221,   221,   106,   107,   129,   255,   258,   408,   410,   411,
     412,   106,   107,   129,   413,   414,   220,   218,     3,   221,
     218,   221,   218,   221,   220,   220,   220,   221,   291,    73,
     403,   221,   221,   221,   221,   219,   291,   109,   404,   221,
     221,   221,   221,   221,   221,   221,   406,   221,   291,   291,
     221,   128,   218,   221,   220,   221,   217,   217,   291,   291,
     220,   217,   291,   291,   220,   204,   291,   381,   220,   220,
       3,   338,   339,   269,    73,   220,   220,   220,   220,   221,
     230,   221,   230,   271,   291,   204,   204,    74,   331,   291,
     258,   296,   297,   410,   414,    73,     1,   221,   291,   220,
     220,   291,   218,   218,   230,   291,   291,   218,     3,   218,
     400,   401,   218,   218,   218,   218,   221,   218,   217,   217,
     295,   394,   221,   394,   221,   271,   108,   143,   168,   254,
     409,   108,   168,   254,   409,   108,   168,   254,   409,   408,
     406,   108,   168,   254,   409,   108,   168,   254,   409,   108,
     168,   254,   409,   218,   220,   221,     5,   217,   366,     3,
     220,   220,   258,   259,   260,     1,    64,   261,   262,   294,
       1,   262,     1,   262,   402,   291,   220,   260,   406,   406,
     402,   406,   402,   402,   255,   289,   289,   220,   291,   220,
     220,   291,   220,   220,   291,   204,   220,   219,   218,   220,
       3,   339,   384,   385,   218,   221,   204,   333,   332,   220,
     297,   402,   221,    77,   221,   221,   204,   291,    70,   295,
     271,   301,   221,   218,   271,   271,   271,   291,   220,   271,
     394,   394,   230,    23,    24,   204,   391,   391,   302,   302,
     302,   307,   302,   302,   302,   307,   302,   302,   302,   307,
      83,     3,     3,     3,   307,     3,     3,     3,   307,     3,
       3,     3,   307,     3,   413,   220,   221,   221,   291,   221,
     258,   405,    74,   204,   204,   406,     1,    74,   261,   204,
      74,    74,    74,    74,   220,   405,    72,    72,   406,   221,
     221,   230,   291,   291,   338,   377,   220,   218,   220,   271,
     291,   337,   337,     3,    76,   220,   291,   221,   202,   400,
     220,   301,   400,   218,   400,   400,   218,   391,   391,   291,
     291,   220,   220,   220,   376,   220,   220,   220,   376,   220,
     220,   220,   376,   376,   376,   376,   260,   220,   221,    73,
     406,   406,   406,     1,   291,   109,   406,   406,   287,   287,
     230,     3,   384,   221,   219,   260,   291,   221,   221,   271,
     221,   221,   271,   291,   291,   221,   221,   302,   302,   302,
       3,     3,     3,   406,   220,   220,   291,   291,   291,   402,
     220,   220,   400,   220,   220,   400,   221,   221,   221,   221,
     220,   220,   220,    83,   308,     1,   308,   220,   220,   221,
      76,   221,   221,   221,   221,   219,   221,   219,   324,   220,
     220,   291,   402,   291,   336,   221,   221,   402,   402
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1455 of yacc.c  */
#line 357 "./parse.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); based_size = 0;;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 359 "./parse.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); based_size = 0;;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 361 "./parse.y"
    { (yyval.number) = pform_verinum_with_size((yyvsp[(1) - (2)].number),(yyvsp[(2) - (2)].number), (yylsp[(2) - (2)]).text, (yylsp[(2) - (2)]).first_line);
	       based_size = 0; ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 376 "./parse.y"
    { (yyval.named_pexprs) = (yyvsp[(2) - (3)].named_pexprs); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 377 "./parse.y"
    { (yyval.named_pexprs) = 0; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 378 "./parse.y"
    { (yyval.named_pexprs) = 0; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 383 "./parse.y"
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs),(yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 389 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 398 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(1) - (1)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 405 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
		  named_pexpr_t*tmp2 = new named_pexpr_t;
		  tmp2->name = lex_strings.make((yyvsp[(1) - (3)].text));
		  tmp2->parm = tmp;
		  delete[](yyvsp[(1) - (3)].text);
		  (yyval.named_pexpr) = tmp2;
		;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 425 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (7)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[(6) - (7)].perm_strings), (yyvsp[(5) - (7)].exprs), (yyvsp[(4) - (7)].flag), dtype);
		  if ((yyvsp[(1) - (7)].named_pexprs)) delete (yyvsp[(1) - (7)].named_pexprs);
		;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 438 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (6)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[(5) - (6)].perm_strings), 0, (yyvsp[(4) - (6)].flag), dtype);
		  if ((yyvsp[(1) - (6)].named_pexprs)) delete (yyvsp[(1) - (6)].named_pexprs);
		;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 450 "./parse.y"
    { pform_set_reg_integer((yyvsp[(3) - (4)].perm_strings));
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 455 "./parse.y"
    { pform_set_reg_time((yyvsp[(3) - (4)].perm_strings));
		;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 464 "./parse.y"
    { delete (yyvsp[(3) - (4)].perm_strings); ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 466 "./parse.y"
    { delete (yyvsp[(3) - (4)].perm_strings); ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 469 "./parse.y"
    { pform_make_events((yyvsp[(2) - (3)].perm_strings), (yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 479 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in reg variable list.");
		  yyerrok;
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 484 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in integer variable list.");
		  yyerrok;
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 489 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in time variable list.");
		  yyerrok;
		;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 493 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in real variable list.");
		  yyerrok;
		;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 497 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in realtime variable list.");
		  yyerrok;
		;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 501 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in parameter list.");
		  yyerrok;
		;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 505 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error localparam list.");
		  yyerrok;
		;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 522 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->expr = *(yyvsp[(1) - (3)].exprs);
		  tmp->stat = (yyvsp[(3) - (3)].statement);
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.citem) = tmp;
		;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 529 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[(3) - (3)].statement);
		  (yyval.citem) = tmp;
		;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 534 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[(2) - (2)].statement);
		  (yyval.citem) = tmp;
		;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 539 "./parse.y"
    { yyerror((yylsp[(2) - (3)]), "error: Incomprehensible case expression.");
		  yyerrok;
		;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 546 "./parse.y"
    { svector<PCase::Item*>*tmp;
		  tmp = new svector<PCase::Item*>(*(yyvsp[(1) - (2)].citems), (yyvsp[(2) - (2)].citem));
		  delete (yyvsp[(1) - (2)].citems);
		  (yyval.citems) = tmp;
		;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 552 "./parse.y"
    { svector<PCase::Item*>*tmp = new svector<PCase::Item*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].citem);
		  (yyval.citems) = tmp;
		;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 571 "./parse.y"
    { pform_set_defparam(*(yyvsp[(1) - (3)].pform_name), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].pform_name);
		;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 579 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: defparam may not include a range.");
		  delete (yyvsp[(1) - (2)].exprs);
		;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 587 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(2) - (2)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 592 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (4)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 600 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(2) - (2)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 605 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (4)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 610 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[(3) - (6)].expr);
		  (*tmp)[1] = (yyvsp[(5) - (6)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 616 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(3);
		  (*tmp)[0] = (yyvsp[(3) - (8)].expr);
		  (*tmp)[1] = (yyvsp[(5) - (8)].expr);
		  (*tmp)[2] = (yyvsp[(7) - (8)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 625 "./parse.y"
    { (yyval.exprs) = (yyvsp[(1) - (1)].exprs); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 626 "./parse.y"
    { (yyval.exprs) = 0; ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 631 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
	        (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		(yyval.exprs) = tmp;
	      ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 636 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		delete (yyvsp[(1) - (3)].exprs);
		(yyval.exprs) = tmp;
	      ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 644 "./parse.y"
    { PExpr*tmp = (yyvsp[(1) - (1)].expr);
		  (yyval.expr) = tmp;
		;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 648 "./parse.y"
    { (yyval.expr) = pform_select_mtm_expr((yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr)); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 654 "./parse.y"
    { verinum*tmp = (yyvsp[(1) - (1)].number);
		  if (tmp == 0) {
			yyerror((yylsp[(1) - (1)]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PENumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[(1) - (1)]));
		  }
		  based_size = 0;
		;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 665 "./parse.y"
    { verireal*tmp = (yyvsp[(1) - (1)].realtime);
		  if (tmp == 0) {
			yyerror((yylsp[(1) - (1)]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PEFNumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[(1) - (1)]));
		  }
		;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 675 "./parse.y"
    { PEIdent*tmp = new PEIdent(lex_strings.make((yyvsp[(1) - (1)].text)));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 688 "./parse.y"
    { perm_string tmp3 = lex_strings.make((yyvsp[(3) - (8)].text));
	pform_set_type_attrib(tmp3, (yyvsp[(5) - (8)].text), (yyvsp[(7) - (8)].text));
	delete[] (yyvsp[(3) - (8)].text);
	delete[] (yyvsp[(5) - (8)].text);
      ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 703 "./parse.y"
    { pform_start_discipline((yyvsp[(2) - (3)].text)); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 705 "./parse.y"
    { pform_end_discipline((yylsp[(1) - (6)])); delete[] (yyvsp[(2) - (6)].text); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 715 "./parse.y"
    { pform_discipline_domain((yylsp[(1) - (3)]), IVL_DIS_DISCRETE); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 717 "./parse.y"
    { pform_discipline_domain((yylsp[(1) - (3)]), IVL_DIS_CONTINUOUS); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 719 "./parse.y"
    { pform_discipline_potential((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].text)); delete[] (yyvsp[(2) - (3)].text); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 721 "./parse.y"
    { pform_discipline_flow((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].text)); delete[] (yyvsp[(2) - (3)].text); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 726 "./parse.y"
    { pform_start_nature((yyvsp[(2) - (3)].text)); ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 729 "./parse.y"
    { pform_end_nature((yylsp[(1) - (6)])); delete[] (yyvsp[(2) - (6)].text); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 739 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 742 "./parse.y"
    { pform_nature_access((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].text)); delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 744 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 746 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 751 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(2) - (5)].drive).str0;
		  (yyval.drive).str1 = (yyvsp[(4) - (5)].drive).str1;
		;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 755 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(4) - (5)].drive).str0;
		  (yyval.drive).str1 = (yyvsp[(2) - (5)].drive).str1;
		;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 759 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(2) - (5)].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 763 "./parse.y"
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[(2) - (5)].drive).str1;
		;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 767 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(4) - (5)].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 771 "./parse.y"
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[(4) - (5)].drive).str1;
		;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 777 "./parse.y"
    { (yyval.drive) = (yyvsp[(1) - (1)].drive); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 778 "./parse.y"
    { (yyval.drive).str0 = PGate::STRONG; (yyval.drive).str1 = PGate::STRONG; ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 782 "./parse.y"
    { (yyval.drive).str0 = PGate::SUPPLY; ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 783 "./parse.y"
    { (yyval.drive).str0 = PGate::STRONG; ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 784 "./parse.y"
    { (yyval.drive).str0 = PGate::PULL; ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 785 "./parse.y"
    { (yyval.drive).str0 = PGate::WEAK; ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 789 "./parse.y"
    { (yyval.drive).str1 = PGate::SUPPLY; ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 790 "./parse.y"
    { (yyval.drive).str1 = PGate::STRONG; ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 791 "./parse.y"
    { (yyval.drive).str1 = PGate::PULL; ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 792 "./parse.y"
    { (yyval.drive).str1 = PGate::WEAK; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 797 "./parse.y"
    { PEIdent*tmpi = new PEIdent(*(yyvsp[(2) - (2)].pform_name));
		  PEEvent*tmpe = new PEEvent(PEEvent::ANYEDGE, tmpi);
		  PEventStatement*tmps = new PEventStatement(tmpe);
		  FILE_NAME(tmps, (yylsp[(1) - (2)]));
		  (yyval.event_statement) = tmps;
		  delete (yyvsp[(2) - (2)].pform_name);
		;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 805 "./parse.y"
    { PEventStatement*tmp = new PEventStatement(*(yyvsp[(3) - (4)].event_expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  delete (yyvsp[(3) - (4)].event_expr);
		  (yyval.event_statement) = tmp;
		;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 811 "./parse.y"
    { yyerror((yylsp[(1) - (4)]), "error: Malformed event control expression.");
		  (yyval.event_statement) = 0;
		;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 818 "./parse.y"
    { (yyval.event_expr) = (yyvsp[(1) - (1)].event_expr); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 820 "./parse.y"
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[(1) - (3)].event_expr), *(yyvsp[(3) - (3)].event_expr));
		  delete (yyvsp[(1) - (3)].event_expr);
		  delete (yyvsp[(3) - (3)].event_expr);
		  (yyval.event_expr) = tmp;
		;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 826 "./parse.y"
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[(1) - (3)].event_expr), *(yyvsp[(3) - (3)].event_expr));
		  delete (yyvsp[(1) - (3)].event_expr);
		  delete (yyvsp[(3) - (3)].event_expr);
		  (yyval.event_expr) = tmp;
		;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 835 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::POSEDGE, (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 842 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::NEGEDGE, (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 849 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::ANYEDGE, (yyvsp[(1) - (1)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 863 "./parse.y"
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[(1) - (6)]), (yyvsp[(1) - (6)].text), (yyvsp[(3) - (6)].text), (yyvsp[(5) - (6)].text)); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 865 "./parse.y"
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[(1) - (4)]), (yyvsp[(1) - (4)].text), (yyvsp[(3) - (4)].text)); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 870 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 872 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 874 "./parse.y"
    { PEUnary*tmp = new PEUnary('-', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 879 "./parse.y"
    { PEUnary*tmp = new PEUnary('~', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 884 "./parse.y"
    { PEUnary*tmp = new PEUnary('&', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 889 "./parse.y"
    { PEUnary*tmp = new PEUnary('!', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 894 "./parse.y"
    { PEUnary*tmp = new PEUnary('|', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 899 "./parse.y"
    { PEUnary*tmp = new PEUnary('^', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 904 "./parse.y"
    { PEUnary*tmp = new PEUnary('A', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 909 "./parse.y"
    { PEUnary*tmp = new PEUnary('N', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 914 "./parse.y"
    { PEUnary*tmp = new PEUnary('X', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 919 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: Operand of unary ! "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 924 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: Operand of reduction ^ "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 929 "./parse.y"
    { PEBinary*tmp = new PEBinary('^', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 934 "./parse.y"
    { PEBinary*tmp = new PEBPower('p', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 939 "./parse.y"
    { PEBinary*tmp = new PEBinary('*', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 944 "./parse.y"
    { PEBinary*tmp = new PEBinary('/', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 949 "./parse.y"
    { PEBinary*tmp = new PEBinary('%', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 954 "./parse.y"
    { PEBinary*tmp = new PEBinary('+', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 959 "./parse.y"
    { PEBinary*tmp = new PEBinary('-', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 964 "./parse.y"
    { PEBinary*tmp = new PEBinary('&', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 969 "./parse.y"
    { PEBinary*tmp = new PEBinary('|', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 974 "./parse.y"
    { PEBinary*tmp = new PEBinary('A', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 979 "./parse.y"
    { PEBinary*tmp = new PEBinary('O', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 984 "./parse.y"
    { PEBinary*tmp = new PEBinary('X', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 989 "./parse.y"
    { PEBinary*tmp = new PEBComp('<', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 994 "./parse.y"
    { PEBinary*tmp = new PEBComp('>', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 999 "./parse.y"
    { PEBinary*tmp = new PEBShift('l', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1004 "./parse.y"
    { PEBinary*tmp = new PEBShift('r', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1009 "./parse.y"
    { PEBinary*tmp = new PEBShift('R', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1014 "./parse.y"
    { PEBinary*tmp = new PEBComp('e', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1019 "./parse.y"
    { PEBinary*tmp = new PEBComp('E', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1024 "./parse.y"
    { PEBinary*tmp = new PEBComp('L', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1029 "./parse.y"
    { PEBinary*tmp = new PEBComp('G', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1034 "./parse.y"
    { PEBinary*tmp = new PEBComp('n', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1039 "./parse.y"
    { PEBinary*tmp = new PEBComp('N', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1044 "./parse.y"
    { PEBinary*tmp = new PEBLogic('o', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1049 "./parse.y"
    { PEBinary*tmp = new PEBLogic('a', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1054 "./parse.y"
    { PETernary*tmp = new PETernary((yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (5)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1062 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1064 "./parse.y"
    { switch (min_typ_max_flag) {
		      case MIN:
			(yyval.expr) = (yyvsp[(1) - (5)].expr);
			delete (yyvsp[(3) - (5)].expr);
			delete (yyvsp[(5) - (5)].expr);
			break;
		      case TYP:
			delete (yyvsp[(1) - (5)].expr);
			(yyval.expr) = (yyvsp[(3) - (5)].expr);
			delete (yyvsp[(5) - (5)].expr);
			break;
		      case MAX:
			delete (yyvsp[(1) - (5)].expr);
			delete (yyvsp[(3) - (5)].expr);
			(yyval.expr) = (yyvsp[(5) - (5)].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << (yyval.expr)->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1111 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1116 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1121 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = 0;
		  (yyval.exprs) = tmp;
		;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1127 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (2)].exprs), 0);
		  delete (yyvsp[(1) - (2)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1135 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1140 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1148 "./parse.y"
    { assert((yyvsp[(1) - (1)].number));
		  PENumber*tmp = new PENumber((yyvsp[(1) - (1)].number));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1154 "./parse.y"
    { PEFNumber*tmp = new PEFNumber((yyvsp[(1) - (1)].realtime));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1159 "./parse.y"
    { PEString*tmp = new PEString((yyvsp[(1) - (1)].text));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1164 "./parse.y"
    { perm_string tn = lex_strings.make((yyvsp[(1) - (1)].text));
		  PECallFunction*tmp = new PECallFunction(tn);
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1175 "./parse.y"
    { PEIdent*tmp = new PEIdent(*(yyvsp[(1) - (1)].pform_name));
	  FILE_NAME(tmp, (yylsp[(1) - (1)]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[(1) - (1)].pform_name);
	;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1186 "./parse.y"
    { PECallFunction*tmp = new PECallFunction(*(yyvsp[(1) - (4)].pform_name), *(yyvsp[(3) - (4)].exprs));
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete (yyvsp[(1) - (4)].pform_name);
	(yyval.expr) = tmp;
      ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1192 "./parse.y"
    { perm_string tn = lex_strings.make((yyvsp[(1) - (4)].text));
	PECallFunction*tmp = new PECallFunction(tn, *(yyvsp[(3) - (4)].exprs));
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(1) - (4)].text);
	(yyval.expr) = tmp;
      ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1203 "./parse.y"
    { perm_string tn = perm_string::literal("$acos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1210 "./parse.y"
    { perm_string tn = perm_string::literal("$acosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1217 "./parse.y"
    { perm_string tn = perm_string::literal("$asin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1224 "./parse.y"
    { perm_string tn = perm_string::literal("$asinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1231 "./parse.y"
    { perm_string tn = perm_string::literal("$atan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1238 "./parse.y"
    { perm_string tn = perm_string::literal("$atanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1245 "./parse.y"
    { perm_string tn = perm_string::literal("$atan2");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1252 "./parse.y"
    { perm_string tn = perm_string::literal("$ceil");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1259 "./parse.y"
    { perm_string tn = perm_string::literal("$cos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1266 "./parse.y"
    { perm_string tn = perm_string::literal("$cosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1273 "./parse.y"
    { perm_string tn = perm_string::literal("$exp");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1280 "./parse.y"
    { perm_string tn = perm_string::literal("$floor");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1287 "./parse.y"
    { perm_string tn = perm_string::literal("$hypot");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1294 "./parse.y"
    { perm_string tn = perm_string::literal("$ln");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1301 "./parse.y"
    { perm_string tn = perm_string::literal("$log10");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1308 "./parse.y"
    { perm_string tn = perm_string::literal("$pow");
        PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1315 "./parse.y"
    { perm_string tn = perm_string::literal("$sin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1322 "./parse.y"
    { perm_string tn = perm_string::literal("$sinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1329 "./parse.y"
    { perm_string tn = perm_string::literal("$sqrt");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1336 "./parse.y"
    { perm_string tn = perm_string::literal("$tan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1343 "./parse.y"
    { perm_string tn = perm_string::literal("$tanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1354 "./parse.y"
    { PEUnary*tmp = new PEUnary('m', (yyvsp[(3) - (4)].expr));
        FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1360 "./parse.y"
    { PEBinary*tmp = new PEBinary('M', (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1366 "./parse.y"
    { PEBinary*tmp = new PEBinary('m', (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1374 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1379 "./parse.y"
    { PEConcat*tmp = new PEConcat(*(yyvsp[(2) - (3)].exprs));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].exprs);
		  (yyval.expr) = tmp;
		;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1385 "./parse.y"
    { PExpr*rep = (yyvsp[(2) - (6)].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[(4) - (6)].exprs), rep);
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  delete (yyvsp[(4) - (6)].exprs);
		  (yyval.expr) = tmp;
		;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1392 "./parse.y"
    { PExpr*rep = (yyvsp[(2) - (7)].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[(4) - (7)].exprs), rep);
		  FILE_NAME(tmp, (yylsp[(1) - (7)]));
		  delete (yyvsp[(4) - (7)].exprs);
		  (yyval.expr) = tmp;
		  yyerror((yylsp[(5) - (7)]), "error: Syntax error between internal '}' "
			  "and closing '}' of repeat concatenation.");
		  yyerrok;
		;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1408 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1410 "./parse.y"
    { if ((yyvsp[(1) - (2)].wires) && (yyvsp[(2) - (2)].wires)) {
		        svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
			delete (yyvsp[(1) - (2)].wires);
			delete (yyvsp[(2) - (2)].wires);
			(yyval.wires) = tmp;
		  } else if ((yyvsp[(1) - (2)].wires)) {
			(yyval.wires) = (yyvsp[(1) - (2)].wires);
		  } else {
			(yyval.wires) = (yyvsp[(2) - (2)].wires);
		  }
		;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1425 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1427 "./parse.y"
    { (yyval.wires) = 0; ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1434 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = (yyvsp[(3) - (4)].exprs);
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1444 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (5)].exprs);
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = (yyvsp[(4) - (5)].exprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  delete[](yyvsp[(1) - (5)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1457 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = "";
		  tmp->parms = (yyvsp[(2) - (3)].exprs);
		  tmp->file  = (yylsp[(1) - (3)]).text;
		  tmp->lineno = (yylsp[(1) - (3)]).first_line;
		  (yyval.gate) = tmp;
		;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1468 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (2)].exprs);
		  tmp->name = (yyvsp[(1) - (2)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (2)]).text;
		  tmp->lineno = (yylsp[(1) - (2)]).first_line;
		  delete[](yyvsp[(1) - (2)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1485 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[(3) - (4)].named_pexprs);
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1496 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (5)].exprs);
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[(4) - (5)].named_pexprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  delete[](yyvsp[(1) - (5)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1511 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  yyerror((yylsp[(2) - (4)]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1524 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  yyerror((yylsp[(3) - (5)]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[(1) - (5)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1539 "./parse.y"
    { svector<lgate>*tmp1 = (yyvsp[(1) - (3)].gates);
		  lgate*tmp2 = (yyvsp[(3) - (3)].gate);
		  svector<lgate>*out = new svector<lgate> (*tmp1, *tmp2);
		  delete tmp1;
		  delete tmp2;
		  (yyval.gates) = out;
		;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1547 "./parse.y"
    { svector<lgate>*tmp = new svector<lgate>(1);
		  (*tmp)[0] = *(yyvsp[(1) - (1)].gate);
		  delete (yyvsp[(1) - (1)].gate);
		  (yyval.gates) = tmp;
		;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1555 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::AND; ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1556 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NAND; ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1557 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::OR; ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1558 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOR; ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1559 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::XOR; ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1560 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::XNOR; ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1561 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUF; ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1562 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUFIF0; ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1563 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUFIF1; ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1564 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOT; ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1565 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOTIF0; ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1566 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOTIF1; ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1567 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NMOS; ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1568 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RNMOS; ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1569 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::PMOS; ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1570 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RPMOS; ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1571 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::CMOS; ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1572 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RCMOS; ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1573 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRAN; ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1574 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRAN; ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1575 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRANIF0; ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1576 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRANIF1; ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1577 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRANIF0; ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1578 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRANIF1; ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1589 "./parse.y"
    { (yyval.pform_name) = new pform_name_t;
	  (yyval.pform_name)->push_back(name_component_t(lex_strings.make((yyvsp[(1) - (1)].text))));
	  delete[](yyvsp[(1) - (1)].text);
	;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1594 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (3)].pform_name);
	  tmp->push_back(name_component_t(lex_strings.make((yyvsp[(3) - (3)].text))));
	  delete[](yyvsp[(3) - (3)].text);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1600 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (4)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[(3) - (4)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1609 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1619 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_UP;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1629 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_DO;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1645 "./parse.y"
    { (yyval.perm_strings) = list_from_identifier((yyvsp[(1) - (1)].text)); ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1647 "./parse.y"
    { (yyval.perm_strings) = list_from_identifier((yyvsp[(1) - (3)].perm_strings), (yyvsp[(3) - (3)].text)); ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1669 "./parse.y"
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].mport);
		  (yyval.mports) = tmp;
		;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1675 "./parse.y"
    { vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back((yyvsp[(3) - (3)].mport));
		  (yyval.mports) = tmp;
		;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1683 "./parse.y"
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].mport);
		  (yyval.mports) = tmp;
		;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1689 "./parse.y"
    { vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back((yyvsp[(3) - (3)].mport));
		  (yyval.mports) = tmp;
		;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1694 "./parse.y"
    { Module::port_t*ptmp;
		  perm_string name = lex_strings.make((yyvsp[(3) - (3)].text));
		  ptmp = pform_module_port_reference(name, (yylsp[(3) - (3)]).text,
						     (yylsp[(3) - (3)]).first_line);
		  vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back(ptmp);

		    /* Get the port declaration details, the port type
		       and what not, from context data stored by the
		       last port_declaration rule. */
		  pform_module_define_port((yylsp[(3) - (3)]), name,
					port_declaration_context.port_type,
					port_declaration_context.port_net_type,
					port_declaration_context.sign_flag,
					port_declaration_context.range, 0);
		  delete[](yyvsp[(3) - (3)].text);
		  (yyval.mports) = tmp;
		;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1713 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: NULL port declarations are not "
		              "allowed.");
		;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1718 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: ';' is an invalid port declaration "
		              "separator.");
		;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1727 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::PINPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1744 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::PINOUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1761 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1778 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1795 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (8)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (8)]).text,
					   (yylsp[(2) - (8)]).first_line);
	pform_module_define_port((yylsp[(2) - (8)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (8)].nettype), (yyvsp[(4) - (8)].flag), (yyvsp[(5) - (8)].exprs), (yyvsp[(1) - (8)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (8)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (8)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (8)].exprs);

	pform_make_reginit((yylsp[(6) - (8)]), name, (yyvsp[(8) - (8)].expr));

	delete (yyvsp[(1) - (8)].named_pexprs);
	delete[](yyvsp[(6) - (8)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1818 "./parse.y"
    { (yyval.nettype) = (yyvsp[(1) - (1)].nettype); ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1819 "./parse.y"
    { (yyval.nettype) = NetNet::IMPLICIT; ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1822 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1822 "./parse.y"
    {(yyval.flag) = false; ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1830 "./parse.y"
    { PEIdent*tmp = new PEIdent(*(yyvsp[(1) - (1)].pform_name));
	  FILE_NAME(tmp, (yylsp[(1) - (1)]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[(1) - (1)].pform_name);
	;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1836 "./parse.y"
    { PEConcat*tmp = new PEConcat(*(yyvsp[(2) - (3)].exprs));
	  FILE_NAME(tmp, (yylsp[(1) - (3)]));
	  delete (yyvsp[(2) - (3)].exprs);
	  (yyval.expr) = tmp;
	;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1848 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[(1) - (3)].expr);
		  (*tmp)[1] = (yyvsp[(3) - (3)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1857 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), *(yyvsp[(3) - (3)].exprs));
		  delete (yyvsp[(1) - (3)].exprs);
		  delete (yyvsp[(3) - (3)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1863 "./parse.y"
    { (yyval.exprs) = (yyvsp[(1) - (1)].exprs); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1872 "./parse.y"
    { pform_startmodule((yyvsp[(3) - (3)].text), (yylsp[(2) - (3)]).text, (yylsp[(2) - (3)]).first_line, (yyvsp[(1) - (3)].named_pexprs)); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1876 "./parse.y"
    { pform_module_set_ports((yyvsp[(6) - (8)].mports)); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1879 "./parse.y"
    { pform_endmodule((yyvsp[(3) - (11)].text));
		  delete[](yyvsp[(3) - (11)].text);
		;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1888 "./parse.y"
    { (yyval.mports) = 0; ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1889 "./parse.y"
    { (yyval.mports) = 0; ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1893 "./parse.y"
    { (yyval.mports) = (yyvsp[(2) - (3)].mports); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1894 "./parse.y"
    { (yyval.mports) = (yyvsp[(2) - (3)].mports); ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1895 "./parse.y"
    { (yyval.mports) = 0; ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1925 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (8)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (8)]), (yyvsp[(5) - (8)].exprs), (yyvsp[(4) - (8)].flag), (yyvsp[(7) - (8)].perm_strings), (yyvsp[(2) - (8)].nettype),
				 NetNet::NOT_A_PORT, dtype, (yyvsp[(1) - (8)].named_pexprs));
		  if ((yyvsp[(6) - (8)].exprs) != 0) {
			yyerror((yylsp[(6) - (8)]), "sorry: net delays not supported.");
			delete (yyvsp[(6) - (8)].exprs);
		  }
		  if ((yyvsp[(1) - (8)].named_pexprs)) delete (yyvsp[(1) - (8)].named_pexprs);
		;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1945 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (8)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (8)]), (yyvsp[(5) - (8)].exprs), (yyvsp[(4) - (8)].flag), (yyvsp[(6) - (8)].exprs),
				 str_strength, (yyvsp[(7) - (8)].net_decl_assign), (yyvsp[(2) - (8)].nettype), dtype);
		  if ((yyvsp[(1) - (8)].named_pexprs)) {
			yyerror((yylsp[(2) - (8)]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[(1) - (8)].named_pexprs);
		  }
		;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1964 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (7)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (7)]), 0, (yyvsp[(4) - (7)].flag), 0, (yyvsp[(5) - (7)].drive), (yyvsp[(6) - (7)].net_decl_assign), (yyvsp[(2) - (7)].nettype), dtype);
		  if ((yyvsp[(1) - (7)].named_pexprs)) {
			yyerror((yylsp[(2) - (7)]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[(1) - (7)].named_pexprs);
		  }
		;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1976 "./parse.y"
    { yyerror((yylsp[(1) - (6)]), "sorry: trireg nets not supported.");
		  delete (yyvsp[(3) - (6)].exprs);
		  delete (yyvsp[(4) - (6)].exprs);
		;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1982 "./parse.y"
    { pform_set_port_type((yylsp[(1) - (6)]), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(3) - (6)].exprs), (yyvsp[(2) - (6)].flag), (yyvsp[(1) - (6)].porttype));
		;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1990 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), (yyvsp[(1) - (6)].porttype), IVL_VT_NO_TYPE, 0,
		                 SR_BOTH);
		;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1995 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), NetNet::POUTPUT,
				 IVL_VT_NO_TYPE, 0, SR_BOTH);
		;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 2004 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), NetNet::PINPUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[(2) - (6)]), "error: reg variables cannot be inputs.");
		;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 2010 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), NetNet::PINOUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[(2) - (6)]), "error: reg variables cannot be inouts.");
		;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 2016 "./parse.y"
    { yyerror((yylsp[(1) - (6)]), "error: Invalid variable list"
			  " in port declaration.");
		  if ((yyvsp[(3) - (6)].exprs)) delete (yyvsp[(3) - (6)].exprs);
		  if ((yyvsp[(4) - (6)].exprs)) delete (yyvsp[(4) - (6)].exprs);
		  yyerrok;
		;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 2027 "./parse.y"
    { pform_attach_discipline((yylsp[(1) - (3)]), (yyvsp[(1) - (3)].discipline), (yyvsp[(2) - (3)].perm_strings)); ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 2042 "./parse.y"
    { pform_makegates((yyvsp[(2) - (4)].gatetype), str_strength, 0, (yyvsp[(3) - (4)].gates), (yyvsp[(1) - (4)].named_pexprs));
		;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2046 "./parse.y"
    { pform_makegates((yyvsp[(2) - (5)].gatetype), str_strength, (yyvsp[(3) - (5)].exprs), (yyvsp[(4) - (5)].gates), (yyvsp[(1) - (5)].named_pexprs));
		;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 2050 "./parse.y"
    { pform_makegates((yyvsp[(2) - (5)].gatetype), (yyvsp[(3) - (5)].drive), 0, (yyvsp[(4) - (5)].gates), (yyvsp[(1) - (5)].named_pexprs));
		;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2054 "./parse.y"
    { pform_makegates((yyvsp[(2) - (6)].gatetype), (yyvsp[(3) - (6)].drive), (yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].gates), (yyvsp[(1) - (6)].named_pexprs));
		;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 2061 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, pull_strength, 0,
				  (yyvsp[(2) - (3)].gates), 0);
		;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 2065 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, pull_strength,
				  0, (yyvsp[(2) - (3)].gates), 0);
		;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2070 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[(3) - (6)].drive), 0, (yyvsp[(5) - (6)].gates), 0);
		;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2074 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[(3) - (6)].drive), 0, (yyvsp[(5) - (6)].gates), 0);
		;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2083 "./parse.y"
    { perm_string tmp1 = lex_strings.make((yyvsp[(2) - (5)].text));
		  pform_make_modgates(tmp1, (yyvsp[(3) - (5)].parmvalue), (yyvsp[(4) - (5)].gates));
		  delete[](yyvsp[(2) - (5)].text);
		  if ((yyvsp[(1) - (5)].named_pexprs)) delete (yyvsp[(1) - (5)].named_pexprs);
		;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2091 "./parse.y"
    { yyerror((yylsp[(2) - (5)]), "error: Invalid module instantiation");
		  delete[](yyvsp[(2) - (5)].text);
		  if ((yyvsp[(1) - (5)].named_pexprs)) delete (yyvsp[(1) - (5)].named_pexprs);
		;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2101 "./parse.y"
    { pform_make_pgassign_list((yyvsp[(4) - (5)].exprs), (yyvsp[(3) - (5)].exprs), (yyvsp[(2) - (5)].drive), (yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line); ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2106 "./parse.y"
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS, (yyvsp[(3) - (3)].statement), (yyvsp[(1) - (3)].named_pexprs));
	FILE_NAME(tmp, (yylsp[(2) - (3)]));
      ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2110 "./parse.y"
    { PProcess*tmp = pform_make_behavior(IVL_PR_INITIAL, (yyvsp[(3) - (3)].statement), (yyvsp[(1) - (3)].named_pexprs));
	FILE_NAME(tmp, (yylsp[(2) - (3)]));
      ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2115 "./parse.y"
    { pform_make_analog_behavior((yylsp[(2) - (3)]), IVL_PR_ALWAYS, (yyvsp[(3) - (3)].statement)); ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2126 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yyvsp[(3) - (4)].text), (yyvsp[(2) - (4)].flag));
	FILE_NAME(current_task, (yylsp[(1) - (4)]));
      ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2133 "./parse.y"
    { current_task->set_ports((yyvsp[(6) - (8)].wires));
	current_task->set_statement((yyvsp[(7) - (8)].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (8)].text);
      ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2141 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yyvsp[(3) - (3)].text), (yyvsp[(2) - (3)].flag));
	FILE_NAME(current_task, (yylsp[(1) - (3)]));
      ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2149 "./parse.y"
    { current_task->set_ports((yyvsp[(6) - (11)].wires));
	current_task->set_statement((yyvsp[(10) - (11)].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (11)].text);
      ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2156 "./parse.y"
    {
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (5)].text);
      ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2168 "./parse.y"
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yyvsp[(4) - (5)].text), (yyvsp[(2) - (5)].flag));
	FILE_NAME(current_function, (yylsp[(1) - (5)]));
      ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2174 "./parse.y"
    { current_function->set_ports((yyvsp[(7) - (9)].wires));
	current_function->set_statement((yyvsp[(8) - (9)].statement));
	current_function->set_return((yyvsp[(3) - (9)].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[(4) - (9)].text);
      ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2183 "./parse.y"
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yyvsp[(4) - (4)].text), (yyvsp[(2) - (4)].flag));
	FILE_NAME(current_function, (yylsp[(1) - (4)]));
      ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2191 "./parse.y"
    { current_function->set_ports((yyvsp[(7) - (12)].wires));
	current_function->set_statement((yyvsp[(11) - (12)].statement));
	current_function->set_return((yyvsp[(3) - (12)].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[(4) - (12)].text);
      ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2199 "./parse.y"
    {
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(4) - (6)].text);
      ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2212 "./parse.y"
    { pform_genvars((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].perm_strings)); ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2217 "./parse.y"
    { pform_start_generate_for((yylsp[(1) - (12)]), (yyvsp[(3) - (12)].text), (yyvsp[(5) - (12)].expr), (yyvsp[(7) - (12)].expr), (yyvsp[(9) - (12)].text), (yyvsp[(11) - (12)].expr)); ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2219 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2224 "./parse.y"
    { pform_start_generate_else((yylsp[(1) - (3)])); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2226 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2230 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2233 "./parse.y"
    { pform_start_generate_case((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2236 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2240 "./parse.y"
    { /* Detect and warn about anachronistic begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[(2) - (5)]) << ": warning: Anachronistic use of begin/end to surround generate schemes." << endl;
	}
      ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2246 "./parse.y"
    {
	pform_start_generate_nblock((yylsp[(1) - (4)]), (yyvsp[(4) - (4)].text));
      ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2249 "./parse.y"
    { /* Detect and warn about anachronistic named begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[(2) - (8)]) << ": warning: Anachronistic use of named begin/end to surround generate schemes." << endl;
	}
	pform_endgenerate();
      ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2260 "./parse.y"
    { /* empty lists are legal syntax. */ ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2263 "./parse.y"
    {
		;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2267 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in specify block");
		  yyerrok;
		;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2276 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: missing endmodule or attempt to "
		              "nest modules.");
		  pform_error_nested_modules();
		  yyerrok;
		;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2283 "./parse.y"
    { yyerror((yylsp[(2) - (2)]), "error: invalid module item.");
		  yyerrok;
		;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2288 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: syntax error in left side "
			  "of continuous assignment.");
		  yyerrok;
		;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2294 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in "
			  "continuous assignment");
		  yyerrok;
		;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2300 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: I give up on this "
			  "function definition.");
		  yyerrok;
		;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2309 "./parse.y"
    { perm_string tmp3 = lex_strings.make((yyvsp[(3) - (9)].text));
		  perm_string tmp5 = lex_strings.make((yyvsp[(5) - (9)].text));
		  pform_set_attrib(tmp3, tmp5, (yyvsp[(7) - (9)].text));
		  delete[] (yyvsp[(3) - (9)].text);
		  delete[] (yyvsp[(5) - (9)].text);
		;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2316 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: Malformed $attribute parameter list."); ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2320 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2321 "./parse.y"
    { (yyval.flag) = false;;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2324 "./parse.y"
    { pform_start_generate_if((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2332 "./parse.y"
    { pform_generate_case_item((yylsp[(1) - (2)]), (yyvsp[(1) - (2)].exprs)); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2333 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2334 "./parse.y"
    { pform_generate_case_item((yylsp[(1) - (2)]), 0); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2335 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2358 "./parse.y"
    { pform_generate_block_name((yyvsp[(3) - (5)].text)); ;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2373 "./parse.y"
    { net_decl_assign_t*tmp = new net_decl_assign_t;
	tmp->next = tmp;
	tmp->name = lex_strings.make((yyvsp[(1) - (3)].text));
	tmp->expr = (yyvsp[(3) - (3)].expr);
	delete[](yyvsp[(1) - (3)].text);
	(yyval.net_decl_assign) = tmp;
      ;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2384 "./parse.y"
    { net_decl_assign_t*tmp = (yyvsp[(1) - (3)].net_decl_assign);
		  (yyvsp[(3) - (3)].net_decl_assign)->next = tmp->next;
		  tmp->next = (yyvsp[(3) - (3)].net_decl_assign);
		  (yyval.net_decl_assign) = tmp;
		;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2390 "./parse.y"
    { (yyval.net_decl_assign) = (yyvsp[(1) - (1)].net_decl_assign);
		;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2395 "./parse.y"
    { (yyval.datatype) = IVL_VT_LOGIC; ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2396 "./parse.y"
    { (yyval.datatype) = IVL_VT_BOOL; ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2397 "./parse.y"
    { (yyval.datatype) = IVL_VT_REAL; ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2400 "./parse.y"
    { (yyval.datatype) = (yyvsp[(1) - (1)].datatype); ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2400 "./parse.y"
    { (yyval.datatype) = IVL_VT_NO_TYPE; ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2403 "./parse.y"
    { (yyval.nettype) = NetNet::WIRE; ;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2404 "./parse.y"
    { (yyval.nettype) = NetNet::TRI; ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2405 "./parse.y"
    { (yyval.nettype) = NetNet::TRI1; ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2406 "./parse.y"
    { (yyval.nettype) = NetNet::SUPPLY0; ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2407 "./parse.y"
    { (yyval.nettype) = NetNet::WAND; ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2408 "./parse.y"
    { (yyval.nettype) = NetNet::TRIAND; ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2409 "./parse.y"
    { (yyval.nettype) = NetNet::TRI0; ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2410 "./parse.y"
    { (yyval.nettype) = NetNet::SUPPLY1; ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2411 "./parse.y"
    { (yyval.nettype) = NetNet::WOR; ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2412 "./parse.y"
    { (yyval.nettype) = NetNet::TRIOR; ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2413 "./parse.y"
    { (yyval.nettype) = NetNet::WONE; ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2417 "./parse.y"
    { (yyval.nettype) = NetNet::REG; ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2426 "./parse.y"
    { param_active_range = (yyvsp[(1) - (1)].exprs);
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2431 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2436 "./parse.y"
    { param_active_range = (yyvsp[(2) - (2)].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2441 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2446 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2458 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2463 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2475 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2480 "./parse.y"
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2485 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2498 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (4)].expr);
	pform_set_parameter((yylsp[(1) - (4)]), lex_strings.make((yyvsp[(1) - (4)].text)), param_active_type,
			    param_active_signed, param_active_range, tmp, (yyvsp[(4) - (4)].value_range));
	delete[](yyvsp[(1) - (4)].text);
      ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2505 "./parse.y"
    { (yyval.value_range) = (yyvsp[(1) - (1)].value_range); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2505 "./parse.y"
    { (yyval.value_range) = 0; ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2509 "./parse.y"
    { (yyval.value_range) = (yyvsp[(2) - (2)].value_range); (yyval.value_range)->next = (yyvsp[(1) - (2)].value_range); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2511 "./parse.y"
    { (yyval.value_range) = (yyvsp[(1) - (1)].value_range); (yyval.value_range)->next = 0; ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2516 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), false, (yyvsp[(3) - (6)].expr), false, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2518 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), false, (yyvsp[(3) - (6)].expr), true, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2520 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), true, (yyvsp[(3) - (6)].expr), false, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2522 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), true, (yyvsp[(3) - (6)].expr), true, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2524 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range(true, false, (yyvsp[(2) - (2)].expr), false, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2528 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2529 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2530 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2531 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2534 "./parse.y"
    { (yyval.flag) = false; ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2534 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2543 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
	pform_set_localparam((yylsp[(1) - (3)]), lex_strings.make((yyvsp[(1) - (3)].text)),
			     param_active_type,
			     param_active_signed,
			     param_active_range, tmp);
	delete[](yyvsp[(1) - (3)].text);
      ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2555 "./parse.y"
    { param_active_range = (yyvsp[(1) - (1)].exprs);
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2560 "./parse.y"
    { param_active_range = 0;
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2565 "./parse.y"
    { param_active_range = (yyvsp[(2) - (2)].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2570 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2575 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2587 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2592 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2604 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2609 "./parse.y"
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2614 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2643 "./parse.y"
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = (yyvsp[(3) - (4)].exprs);
		  tmp->by_name = 0;
		  (yyval.parmvalue) = tmp;
		;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2649 "./parse.y"
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = 0;
		  tmp->by_name = (yyvsp[(3) - (4)].named_pexprs);
		  (yyval.parmvalue) = tmp;
		;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2655 "./parse.y"
    { assert((yyvsp[(2) - (2)].number));
		  PENumber*tmp = new PENumber((yyvsp[(2) - (2)].number));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		  based_size = 0;
		;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2667 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: syntax error in parameter value "
			  "assignment list.");
		  (yyval.parmvalue) = 0;
		;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2672 "./parse.y"
    { (yyval.parmvalue) = 0; ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2677 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = (yyvsp[(4) - (5)].expr);
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2684 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (4)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (4)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2694 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2699 "./parse.y"
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs),(yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2722 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2730 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(4) - (5)].mport);
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.mport) = tmp;
		;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2741 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(2) - (3)].mport);
		  tmp->name = perm_string();
		  (yyval.mport) = tmp;
		;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2750 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(5) - (7)].mport);
		  tmp->name = lex_strings.make((yyvsp[(2) - (7)].text));
		  delete[](yyvsp[(2) - (7)].text);
		  (yyval.mport) = tmp;
		;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2758 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2759 "./parse.y"
    { (yyval.mport) = 0; ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2776 "./parse.y"
    { Module::port_t*ptmp;
	  perm_string name = lex_strings.make((yyvsp[(1) - (1)].text));
	  ptmp = pform_module_port_reference(name, (yylsp[(1) - (1)]).text, (yylsp[(1) - (1)]).first_line);
	  delete[](yyvsp[(1) - (1)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2784 "./parse.y"
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);

	  name_component_t ntmp (lex_strings.make((yyvsp[(1) - (6)].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*wtmp = new PEIdent(pname);
	  FILE_NAME(wtmp, (yylsp[(1) - (6)]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(wtmp);

	  delete[](yyvsp[(1) - (6)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2807 "./parse.y"
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[(3) - (4)].expr);
	  itmp.lsb = 0;

	  name_component_t ntmp (lex_strings.make((yyvsp[(1) - (4)].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*tmp = new PEIdent(pname);
	  FILE_NAME(tmp, (yylsp[(1) - (4)]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(tmp);
	  delete[](yyvsp[(1) - (4)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2829 "./parse.y"
    { yyerror((yylsp[(1) - (4)]), "error: invalid port bit select");
	  Module::port_t*ptmp = new Module::port_t;
	  PEIdent*wtmp = new PEIdent(lex_strings.make((yyvsp[(1) - (4)].text)));
	  FILE_NAME(wtmp, (yylsp[(1) - (4)]));
	  ptmp->name = lex_strings.make((yyvsp[(1) - (4)].text));
	  ptmp->expr.push_back(wtmp);
	  delete[](yyvsp[(1) - (4)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2843 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2845 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(1) - (3)].mport);
		  append(tmp->expr, (yyvsp[(3) - (3)].mport)->expr);
		  delete (yyvsp[(3) - (3)].mport);
		  (yyval.mport) = tmp;
		;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2858 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = (yyvsp[(4) - (5)].expr);
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2865 "./parse.y"
    { yyerror((yylsp[(3) - (5)]), "error: invalid port connection expression.");
		  named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2873 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (4)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (4)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2883 "./parse.y"
    { svector<named_pexpr_t*>*tmp;
		  tmp = new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs), (yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2889 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2896 "./parse.y"
    { (yyval.porttype) = NetNet::PINPUT; ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2897 "./parse.y"
    { (yyval.porttype) = NetNet::POUTPUT; ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2898 "./parse.y"
    { (yyval.porttype) = NetNet::PINOUT; ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2903 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*> (2);
		  (*tmp)[0] = (yyvsp[(2) - (5)].expr);
		  (*tmp)[1] = (yyvsp[(4) - (5)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2912 "./parse.y"
    { (yyval.exprs) = 0; ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2915 "./parse.y"
    { (yyval.dimensions) = 0; ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2916 "./parse.y"
    { (yyval.dimensions) = (yyvsp[(1) - (1)].dimensions); ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2920 "./parse.y"
    { list<index_component_t> *tmp = new list<index_component_t>;
		  index_component_t index;
		  index.msb = (yyvsp[(2) - (5)].expr);
		  index.lsb = (yyvsp[(4) - (5)].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2928 "./parse.y"
    { list<index_component_t> *tmp = (yyvsp[(1) - (6)].dimensions);
		  index_component_t index;
		  index.msb = (yyvsp[(3) - (6)].expr);
		  index.lsb = (yyvsp[(5) - (6)].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2938 "./parse.y"
    { (yyval.function_type).range = (yyvsp[(1) - (1)].exprs); (yyval.function_type).type = PTF_REG; ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2939 "./parse.y"
    { (yyval.function_type).range = (yyvsp[(2) - (2)].exprs); (yyval.function_type).type = PTF_REG_S; ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2940 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_INTEGER; ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2941 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REAL; ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2942 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REALTIME; ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2943 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_TIME; ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2944 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REG; ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2954 "./parse.y"
    { perm_string ident_name = lex_strings.make((yyvsp[(1) - (2)].text));
	pform_makewire((yylsp[(1) - (2)]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(ident_name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
	}
	(yyval.text) = (yyvsp[(1) - (2)].text);
      ;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2970 "./parse.y"
    { perm_string ident_name = lex_strings.make((yyvsp[(1) - (3)].text));
	pform_makewire((yylsp[(1) - (3)]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_make_reginit((yylsp[(1) - (3)]), ident_name, (yyvsp[(3) - (3)].expr));
	(yyval.text) = (yyvsp[(1) - (3)].text);
      ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2980 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2986 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2995 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (2)].text));
        pform_makewire((yylsp[(1) - (2)]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
        if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
        }
	(yyval.text) = (yyvsp[(1) - (2)].text);
      ;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 3010 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (3)].text));
	pform_makewire((yylsp[(1) - (3)]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
	pform_make_reginit((yylsp[(1) - (3)]), name, (yyvsp[(3) - (3)].expr));
	(yyval.text) = (yyvsp[(1) - (3)].text);
      ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 3019 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[(1) - (1)].text);
      ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 3025 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[(3) - (3)].text);
      ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 3034 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (2)].text));
	pform_makewire((yylsp[(1) - (2)]), name, NetNet::IMPLICIT,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
	}
	(yyval.text) = (yyvsp[(1) - (2)].text);
      ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 3053 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 3059 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3069 "./parse.y"
    { pform_module_specify_path((yyvsp[(1) - (2)].specpath));
		;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3072 "./parse.y"
    { pform_module_specify_path((yyvsp[(1) - (2)].specpath));
		;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3075 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(5) - (6)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[(3) - (6)].expr);
		  }
		  pform_module_specify_path(tmp);
		;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3083 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(5) - (6)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[(3) - (6)].expr);
		  }
		  pform_module_specify_path(tmp);
		;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3091 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(2) - (3)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = 0;
		  }
		  pform_module_specify_path(tmp);
		;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3100 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3104 "./parse.y"
    { delete (yyvsp[(5) - (8)].expr);
		;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3108 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3112 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3116 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3121 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3126 "./parse.y"
    { delete (yyvsp[(5) - (10)].expr);
		  delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3130 "./parse.y"
    { delete (yyvsp[(5) - (7)].expr);
		;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3141 "./parse.y"
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (5)].specpath), (yyvsp[(4) - (5)].exprs)); ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3143 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (3)].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (3)].specpath), tmp);
		;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3149 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3149 "./parse.y"
    { (yyval.flag) = false; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3154 "./parse.y"
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (10)]), edge_flag, (yyvsp[(2) - (10)].perm_strings), (yyvsp[(3) - (10)].letter), false, (yyvsp[(6) - (10)].perm_strings), (yyvsp[(8) - (10)].expr)); ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3158 "./parse.y"
    { int edge_flag = (yyvsp[(2) - (11)].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (11)]), edge_flag, (yyvsp[(3) - (11)].perm_strings), (yyvsp[(4) - (11)].letter), false, (yyvsp[(7) - (11)].perm_strings), (yyvsp[(9) - (11)].expr));;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3162 "./parse.y"
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (10)]), edge_flag, (yyvsp[(2) - (10)].perm_strings), (yyvsp[(3) - (10)].letter), true, (yyvsp[(6) - (10)].perm_strings), (yyvsp[(8) - (10)].expr)); ;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3166 "./parse.y"
    { int edge_flag = (yyvsp[(2) - (11)].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (11)]), edge_flag, (yyvsp[(3) - (11)].perm_strings), (yyvsp[(4) - (11)].letter), true, (yyvsp[(7) - (11)].perm_strings), (yyvsp[(9) - (11)].expr)); ;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3178 "./parse.y"
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (5)].specpath), (yyvsp[(4) - (5)].exprs)); ;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3180 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (3)].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (3)].specpath), tmp);
		;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3185 "./parse.y"
    { yyerror((yylsp[(3) - (5)]), "Syntax error in delay value list.");
		  yyerrok;
		  (yyval.specpath) = 0;
		;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3194 "./parse.y"
    { (yyval.specpath) = pform_make_specify_path((yylsp[(1) - (6)]), (yyvsp[(2) - (6)].perm_strings), (yyvsp[(3) - (6)].letter), false, (yyvsp[(5) - (6)].perm_strings)); ;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3197 "./parse.y"
    { (yyval.specpath) = pform_make_specify_path((yylsp[(1) - (6)]), (yyvsp[(2) - (6)].perm_strings), (yyvsp[(3) - (6)].letter), true, (yyvsp[(5) - (6)].perm_strings)); ;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3199 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "Invalid simple path");
		  yyerrok;
		;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3206 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3212 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (4)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (4)].text);
		;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3218 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3224 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (6)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (6)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (6)].text);
		;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3233 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
		  pform_set_specparam(lex_strings.make((yyvsp[(1) - (3)].text)), tmp);
		  delete[](yyvsp[(1) - (3)].text);
		;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3238 "./parse.y"
    { PExpr*tmp = 0;
		  switch (min_typ_max_flag) {
		      case MIN:
			tmp = (yyvsp[(3) - (7)].expr);
			delete (yyvsp[(5) - (7)].expr);
			delete (yyvsp[(7) - (7)].expr);
			break;
		      case TYP:
			delete (yyvsp[(3) - (7)].expr);
			tmp = (yyvsp[(5) - (7)].expr);
			delete (yyvsp[(7) - (7)].expr);
			break;
		      case MAX:
			delete (yyvsp[(3) - (7)].expr);
			delete (yyvsp[(5) - (7)].expr);
			tmp = (yyvsp[(7) - (7)].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << tmp->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		  pform_set_specparam(lex_strings.make((yyvsp[(1) - (7)].text)), tmp);
		  delete[](yyvsp[(1) - (7)].text);
		;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3276 "./parse.y"
    { delete[](yyvsp[(1) - (3)].text);
		  delete (yyvsp[(3) - (3)].expr);
		;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3280 "./parse.y"
    { delete[](yyvsp[(1) - (7)].text);
		  delete (yyvsp[(4) - (7)].expr);
		  delete (yyvsp[(6) - (7)].expr);
		;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3292 "./parse.y"
    { (yyval.letter) = '+'; ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3293 "./parse.y"
    { (yyval.letter) = '-'; ;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3294 "./parse.y"
    { (yyval.letter) = 0;   ;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3299 "./parse.y"
    { delete (yyvsp[(2) - (2)].expr); ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3301 "./parse.y"
    { delete (yyvsp[(2) - (2)].expr); ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3303 "./parse.y"
    { delete (yyvsp[(2) - (4)].expr);
      delete (yyvsp[(4) - (4)].expr);
    ;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3307 "./parse.y"
    { delete (yyvsp[(2) - (4)].expr);
      delete (yyvsp[(4) - (4)].expr);
    ;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3311 "./parse.y"
    { delete (yyvsp[(5) - (5)].expr); ;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3313 "./parse.y"
    { delete (yyvsp[(5) - (7)].expr);
      delete (yyvsp[(7) - (7)].expr);
    ;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3317 "./parse.y"
    { delete (yyvsp[(1) - (3)].expr);
      delete (yyvsp[(3) - (3)].expr);
    ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3321 "./parse.y"
    { delete (yyvsp[(1) - (1)].expr); ;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3335 "./parse.y"
    {  ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3337 "./parse.y"
    {  ;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3341 "./parse.y"
    {  ;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3343 "./parse.y"
    { delete (yyvsp[(2) - (2)].pform_name); ;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3345 "./parse.y"
    {  ;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3347 "./parse.y"
    { delete (yyvsp[(3) - (3)].pform_name); ;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3349 "./parse.y"
    { delete[](yyvsp[(1) - (1)].text); ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3361 "./parse.y"
    { PCAssign*tmp = new PCAssign((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3367 "./parse.y"
    { PDeassign*tmp = new PDeassign((yyvsp[(2) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3377 "./parse.y"
    { PForce*tmp = new PForce((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3382 "./parse.y"
    { PRelease*tmp = new PRelease((yyvsp[(2) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3394 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	tmp->set_statement(*(yyvsp[(2) - (3)].statement_list));
	delete (yyvsp[(2) - (3)].statement_list);
	(yyval.statement) = tmp;
      ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3401 "./parse.y"
    { PBlock*tmp = pform_push_block_scope((yyvsp[(3) - (3)].text), PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	current_block_stack.push(tmp);
      ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3407 "./parse.y"
    { pform_pop_scope();
	assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[(6) - (7)].statement_list));
	delete[](yyvsp[(3) - (7)].text);
	delete (yyvsp[(6) - (7)].statement_list);
	(yyval.statement) = tmp;
      ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3417 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (2)]));
	(yyval.statement) = tmp;
      ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3422 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(3) - (4)].text);
	(yyval.statement) = tmp;
      ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3428 "./parse.y"
    { yyerrok; ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3436 "./parse.y"
    { PBlock*tmp = pform_push_block_scope((yyvsp[(3) - (3)].text), PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	current_block_stack.push(tmp);
      ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3442 "./parse.y"
    { pform_pop_scope();
        assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[(6) - (7)].statement_list));
	delete[](yyvsp[(3) - (7)].text);
	delete (yyvsp[(6) - (7)].statement_list);
	(yyval.statement) = tmp;
      ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3452 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (2)]));
	(yyval.statement) = tmp;
      ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3457 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(3) - (4)].text);
	(yyval.statement) = tmp;
      ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3464 "./parse.y"
    { PDisable*tmp = new PDisable(*(yyvsp[(2) - (3)].pform_name));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3470 "./parse.y"
    { PTrigger*tmp = new PTrigger(*(yyvsp[(2) - (3)].pform_name));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3476 "./parse.y"
    { PForever*tmp = new PForever((yyvsp[(2) - (2)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3481 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  tmp->set_statement(*(yyvsp[(2) - (3)].statement_list));
		  delete (yyvsp[(2) - (3)].statement_list);
		  (yyval.statement) = tmp;
		;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3488 "./parse.y"
    { PRepeat*tmp = new PRepeat((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3493 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQ, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3498 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3503 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQZ, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3508 "./parse.y"
    { yyerrok; ;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3510 "./parse.y"
    { yyerrok; ;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3512 "./parse.y"
    { yyerrok; ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3514 "./parse.y"
    { PCondit*tmp = new PCondit((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement), 0);
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3519 "./parse.y"
    { PCondit*tmp = new PCondit((yyvsp[(3) - (7)].expr), (yyvsp[(5) - (7)].statement), (yyvsp[(7) - (7)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (7)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 3524 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[(5) - (5)].statement);
		;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 3528 "./parse.y"
    { yyerror((yylsp[(1) - (7)]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[(5) - (7)].statement);
		;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3533 "./parse.y"
    { PForStatement*tmp = new PForStatement((yyvsp[(3) - (13)].expr), (yyvsp[(5) - (13)].expr), (yyvsp[(7) - (13)].expr), (yyvsp[(9) - (13)].expr), (yyvsp[(11) - (13)].expr), (yyvsp[(13) - (13)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (13)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3539 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (11)]), "error: Error in for loop step assignment.");
		;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3544 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (13)]), "error: Error in for loop condition expression.");
		;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3548 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (5)]), "error: Incomprehensible for loop.");
		;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3552 "./parse.y"
    { PWhile*tmp = new PWhile((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3557 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (5)]), "error: Error in while loop condition.");
		;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3561 "./parse.y"
    { PExpr*del = (*(yyvsp[(1) - (2)].exprs))[0];
		  assert((yyvsp[(1) - (2)].exprs)->count() == 1);
		  PDelayStatement*tmp = new PDelayStatement(del, (yyvsp[(2) - (2)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3568 "./parse.y"
    { PEventStatement*tmp = (yyvsp[(1) - (3)].event_statement);
	if (tmp == 0) {
	      yyerror((yylsp[(1) - (3)]), "error: Invalid event control.");
	      (yyval.statement) = 0;
	} else {
	      if ((yyvsp[(3) - (3)].statement)) pform_bind_attributes((yyvsp[(3) - (3)].statement)->attributes,(yyvsp[(2) - (3)].named_pexprs));
	      tmp->set_statement((yyvsp[(3) - (3)].statement));
	      (yyval.statement) = tmp;
	}
      ;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3579 "./parse.y"
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	if ((yyvsp[(4) - (4)].statement)) pform_bind_attributes((yyvsp[(4) - (4)].statement)->attributes,(yyvsp[(3) - (4)].named_pexprs));
	tmp->set_statement((yyvsp[(4) - (4)].statement));
	(yyval.statement) = tmp;
      ;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3586 "./parse.y"
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[(1) - (6)]));
	if ((yyvsp[(6) - (6)].statement)) pform_bind_attributes((yyvsp[(6) - (6)].statement)->attributes,(yyvsp[(5) - (6)].named_pexprs));
	tmp->set_statement((yyvsp[(6) - (6)].statement));
	(yyval.statement) = tmp;
      ;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3593 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (4)].expr),(yyvsp[(3) - (4)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3598 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3603 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (4)].expr),(yyvsp[(3) - (4)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3608 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3613 "./parse.y"
    { assert((yyvsp[(3) - (5)].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[(3) - (5)].exprs))[0];
		  PAssign*tmp = new PAssign((yyvsp[(1) - (5)].expr),del,(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3620 "./parse.y"
    { assert((yyvsp[(3) - (5)].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[(3) - (5)].exprs))[0];
		  PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (5)].expr),del,(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3627 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (5)].expr),0,(yyvsp[(3) - (5)].event_statement),(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3632 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (9)].expr),(yyvsp[(5) - (9)].expr),(yyvsp[(7) - (9)].event_statement),(yyvsp[(8) - (9)].expr));
		  FILE_NAME(tmp,(yylsp[(1) - (9)]));
		  tmp->set_lineno((yylsp[(1) - (9)]).first_line);
		  (yyval.statement) = tmp;
		;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3638 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (5)].expr),0,(yyvsp[(3) - (5)].event_statement),(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3643 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (9)].expr),(yyvsp[(5) - (9)].expr),(yyvsp[(7) - (9)].event_statement),(yyvsp[(8) - (9)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (9)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3648 "./parse.y"
    { PEventStatement*tmp;
		  PEEvent*etmp = new PEEvent(PEEvent::POSITIVE, (yyvsp[(3) - (5)].expr));
		  tmp = new PEventStatement(etmp);
		  FILE_NAME(tmp,(yylsp[(1) - (5)]));
		  tmp->set_statement((yyvsp[(5) - (5)].statement));
		  (yyval.statement) = tmp;
		;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3656 "./parse.y"
    { PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[(1) - (5)].text)), *(yyvsp[(3) - (5)].exprs));
		  FILE_NAME(tmp,(yylsp[(1) - (5)]));
		  delete[](yyvsp[(1) - (5)].text);
		  delete (yyvsp[(3) - (5)].exprs);
		  (yyval.statement) = tmp;
		;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3663 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[(1) - (2)].text)), pt);
		  FILE_NAME(tmp,(yylsp[(1) - (2)]));
		  delete[](yyvsp[(1) - (2)].text);
		  (yyval.statement) = tmp;
		;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3670 "./parse.y"
    { PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (5)].pform_name), *(yyvsp[(3) - (5)].exprs));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  delete (yyvsp[(1) - (5)].pform_name);
		  delete (yyvsp[(3) - (5)].exprs);
		  (yyval.statement) = tmp;
		;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3682 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (4)].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  delete (yyvsp[(1) - (4)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3689 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (2)].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  delete (yyvsp[(1) - (2)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3696 "./parse.y"
    { yyerror((yylsp[(2) - (2)]), "error: malformed statement");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3704 "./parse.y"
    { svector<Statement*>*tmp = new svector<Statement*>(*(yyvsp[(1) - (2)].statement_list), (yyvsp[(2) - (2)].statement));
		  delete (yyvsp[(1) - (2)].statement_list);
		  (yyval.statement_list) = tmp;
		;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3709 "./parse.y"
    { svector<Statement*>*tmp = new svector<Statement*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].statement);
		  (yyval.statement_list) = tmp;
		;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3717 "./parse.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3719 "./parse.y"
    { (yyval.statement) = 0; ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3724 "./parse.y"
    { (yyval.statement) = pform_contribution_statement((yylsp[(2) - (4)]), (yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3730 "./parse.y"
    { (yyval.wires) = new svector<PWire*>(0); ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3731 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3742 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_NO_TYPE, (yyvsp[(3) - (6)].flag),
						(yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3750 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (6)].flag),
						(yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3758 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (6)].flag),
						(yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3770 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3785 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3800 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3818 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3832 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3846 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 3863 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3871 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, true,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3879 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, true,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3890 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
		  delete (yyvsp[(1) - (2)].wires);
		  delete (yyvsp[(2) - (2)].wires);
		  (yyval.wires) = tmp;
		;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3896 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3901 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3903 "./parse.y"
    { (yyval.wires) = 0; ;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 3909 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 3923 "./parse.y"
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 3936 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 3952 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 3973 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 3994 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 4018 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 4038 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 4058 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 4081 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 4094 "./parse.y"
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4107 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 4123 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (3)].wires), *(yyvsp[(3) - (3)].wires));
		  delete (yyvsp[(1) - (3)].wires);
		  delete (yyvsp[(3) - (3)].wires);
		  (yyval.wires) = tmp;
		;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4129 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4131 "./parse.y"
    { svector<PWire*>*new_decl
			= pform_make_task_ports(
				port_declaration_context.port_type,
				port_declaration_context.var_type,
				port_declaration_context.sign_flag,
				copy_range(port_declaration_context.range),
				list_from_identifier((yyvsp[(3) - (3)].text)),
				(yylsp[(3) - (3)]).text, (yylsp[(3) - (3)]).first_line);
		  svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (3)].wires), *new_decl);
		  delete (yyvsp[(1) - (3)].wires);
		  delete new_decl;
		  (yyval.wires) = tmp;
		;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4145 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: NULL port declarations are not "
		              "allowed.");
		;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4150 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: ';' is an invalid port declaration "
		              "separator.");
		;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4158 "./parse.y"
    { lex_start_table(); ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4160 "./parse.y"
    { lex_end_table(); (yyval.strings) = (yyvsp[(3) - (4)].strings); ;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4170 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (4)].text))+3];
		  strcpy(tmp, (yyvsp[(1) - (4)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(3) - (4)].letter);
		  *tp++ = 0;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.text) = tmp;
		;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4183 "./parse.y"
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[(1) - (1)].text));
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4189 "./parse.y"
    { list<string>*tmp = (yyvsp[(1) - (2)].strings);
		  tmp->push_back((yyvsp[(2) - (2)].text));
		  delete[](yyvsp[(2) - (2)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4198 "./parse.y"
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[(1) - (1)].text));
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4204 "./parse.y"
    { list<string>*tmp = (yyvsp[(1) - (2)].strings);
		  tmp->push_back((yyvsp[(2) - (2)].text));
		  delete[](yyvsp[(2) - (2)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4213 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (6)].text))+5];
		  strcpy(tmp, (yyvsp[(1) - (6)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(3) - (6)].letter);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(5) - (6)].letter);
		  *tp++ = 0;
		  (yyval.text) = tmp;
		;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4227 "./parse.y"
    { PExpr*etmp = new PENumber((yyvsp[(4) - (5)].number));
		  PEIdent*itmp = new PEIdent(lex_strings.make((yyvsp[(2) - (5)].text)));
		  PAssign*atmp = new PAssign(itmp, etmp);
		  FILE_NAME(atmp, (yylsp[(2) - (5)]));
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.statement) = atmp;
		;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4237 "./parse.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4238 "./parse.y"
    { (yyval.statement) = 0; ;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4243 "./parse.y"
    { char*tmp = new char[2];
		  tmp[0] = (yyvsp[(1) - (1)].letter);
		  tmp[1] = 0;
		  (yyval.text) = tmp;
		;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4249 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (2)].text))+2];
		  strcpy(tmp, (yyvsp[(1) - (2)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = (yyvsp[(2) - (2)].letter);
		  *tp++ = 0;
		  delete[](yyvsp[(1) - (2)].text);
		  (yyval.text) = tmp;
		;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4260 "./parse.y"
    { (yyval.letter) = '0'; ;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4261 "./parse.y"
    { (yyval.letter) = '1'; ;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4262 "./parse.y"
    { (yyval.letter) = 'x'; ;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4263 "./parse.y"
    { (yyval.letter) = '?'; ;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4264 "./parse.y"
    { (yyval.letter) = 'b'; ;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4265 "./parse.y"
    { (yyval.letter) = '*'; ;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4266 "./parse.y"
    { (yyval.letter) = '%'; ;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4267 "./parse.y"
    { (yyval.letter) = 'f'; ;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4268 "./parse.y"
    { (yyval.letter) = 'F'; ;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4269 "./parse.y"
    { (yyval.letter) = 'l'; ;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4270 "./parse.y"
    { (yyval.letter) = 'H'; ;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4271 "./parse.y"
    { (yyval.letter) = 'B'; ;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4272 "./parse.y"
    { (yyval.letter) = 'r'; ;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4273 "./parse.y"
    { (yyval.letter) = 'R'; ;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4274 "./parse.y"
    { (yyval.letter) = 'M'; ;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4275 "./parse.y"
    { (yyval.letter) = 'n'; ;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4276 "./parse.y"
    { (yyval.letter) = 'N'; ;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4277 "./parse.y"
    { (yyval.letter) = 'p'; ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4278 "./parse.y"
    { (yyval.letter) = 'P'; ;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4279 "./parse.y"
    { (yyval.letter) = 'Q'; ;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4280 "./parse.y"
    { (yyval.letter) = 'q'; ;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4281 "./parse.y"
    { (yyval.letter) = '_'; ;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4282 "./parse.y"
    { (yyval.letter) = '+'; ;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4286 "./parse.y"
    { (yyval.letter) = '0'; ;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4287 "./parse.y"
    { (yyval.letter) = '1'; ;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4288 "./parse.y"
    { (yyval.letter) = 'x'; ;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4289 "./parse.y"
    { (yyval.letter) = '-'; ;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4297 "./parse.y"
    { (yyval.wires) = pform_make_udp_input_ports((yyvsp[(2) - (3)].perm_strings)); ;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4299 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(2) - (3)].text));
	PWire*pp = new PWire(pname, NetNet::IMPLICIT, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(2) - (3)].text);
      ;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4307 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(2) - (3)].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::PIMPLICIT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(2) - (3)].text);
      ;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4315 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(3) - (4)].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(3) - (4)].text);
      ;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4326 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4328 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
		  delete (yyvsp[(1) - (2)].wires);
		  delete (yyvsp[(2) - (2)].wires);
		  (yyval.wires) = tmp;
		;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4337 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
	delete[](yyvsp[(1) - (1)].text);
	(yyval.perm_strings) = tmp;
      ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4343 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
	delete[](yyvsp[(3) - (3)].text);
	(yyval.perm_strings) = tmp;
      ;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4350 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4350 "./parse.y"
    { (yyval.flag) = false; ;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4353 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); ;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4354 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4359 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(2) - (2)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(2) - (2)].text);
		;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4365 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (4)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(4) - (4)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(4) - (4)].text);
		;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4383 "./parse.y"
    { perm_string tmp2 = lex_strings.make((yyvsp[(2) - (10)].text));
		  pform_make_udp(tmp2, (yyvsp[(4) - (10)].perm_strings), (yyvsp[(7) - (10)].wires), (yyvsp[(9) - (10)].strings), (yyvsp[(8) - (10)].statement),
				 (yylsp[(2) - (10)]).text, (yylsp[(2) - (10)]).first_line);
		  delete[](yyvsp[(2) - (10)].text);
		;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4398 "./parse.y"
    { perm_string tmp2 = lex_strings.make((yyvsp[(2) - (13)].text));
		  perm_string tmp6 = lex_strings.make((yyvsp[(6) - (13)].text));
		  pform_make_udp(tmp2, (yyvsp[(5) - (13)].flag), tmp6, (yyvsp[(7) - (13)].expr), (yyvsp[(9) - (13)].perm_strings), (yyvsp[(12) - (13)].strings),
				 (yylsp[(2) - (13)]).text, (yylsp[(2) - (13)]).first_line);
		  delete[](yyvsp[(2) - (13)].text);
		  delete[](yyvsp[(6) - (13)].text);
		;}
    break;



/* Line 1455 of yacc.c  */
#line 11745 "parse.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



